# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AuditLogConfigLogType',
    'AuthorizedOrgsDescAssetType',
    'AuthorizedOrgsDescAuthorizationDirection',
    'AuthorizedOrgsDescAuthorizationType',
    'BasicLevelCombiningFunction',
    'DevicePolicyAllowedDeviceManagementLevelsItem',
    'DevicePolicyAllowedEncryptionStatusesItem',
    'EgressFromIdentityType',
    'EgressFromSourceRestriction',
    'IngressFromIdentityType',
    'OsConstraintOsType',
    'ServicePerimeterPerimeterType',
]


class AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """


class AuthorizedOrgsDescAssetType(str, Enum):
    """
    The asset type of this authorized orgs desc. Valid values are `ASSET_TYPE_DEVICE`, and `ASSET_TYPE_CREDENTIAL_STRENGTH`.
    """
    ASSET_TYPE_UNSPECIFIED = "ASSET_TYPE_UNSPECIFIED"
    """
    No asset type specified.
    """
    ASSET_TYPE_DEVICE = "ASSET_TYPE_DEVICE"
    """
    Device asset type.
    """
    ASSET_TYPE_CREDENTIAL_STRENGTH = "ASSET_TYPE_CREDENTIAL_STRENGTH"
    """
    Credential strength asset type.
    """


class AuthorizedOrgsDescAuthorizationDirection(str, Enum):
    """
    The direction of the authorization relationship between this organization and the organizations listed in the `orgs` field. The valid values for this field include the following: `AUTHORIZATION_DIRECTION_FROM`: Allows this organization to evaluate traffic in the organizations listed in the `orgs` field. `AUTHORIZATION_DIRECTION_TO`: Allows the organizations listed in the `orgs` field to evaluate the traffic in this organization. For the authorization relationship to take effect, all of the organizations must authorize and specify the appropriate relationship direction. For example, if organization A authorized organization B and C to evaluate its traffic, by specifying `AUTHORIZATION_DIRECTION_TO` as the authorization direction, organizations B and C must specify `AUTHORIZATION_DIRECTION_FROM` as the authorization direction in their `AuthorizedOrgsDesc` resource.
    """
    AUTHORIZATION_DIRECTION_UNSPECIFIED = "AUTHORIZATION_DIRECTION_UNSPECIFIED"
    """
    No direction specified.
    """
    AUTHORIZATION_DIRECTION_TO = "AUTHORIZATION_DIRECTION_TO"
    """
    The specified organizations are authorized to evaluate traffic in this organization.
    """
    AUTHORIZATION_DIRECTION_FROM = "AUTHORIZATION_DIRECTION_FROM"
    """
    The traffic of the specified organizations can be evaluated by this organization.
    """


class AuthorizedOrgsDescAuthorizationType(str, Enum):
    """
    A granular control type for authorization levels. Valid value is `AUTHORIZATION_TYPE_TRUST`.
    """
    AUTHORIZATION_TYPE_UNSPECIFIED = "AUTHORIZATION_TYPE_UNSPECIFIED"
    """
    No authorization type specified.
    """
    AUTHORIZATION_TYPE_TRUST = "AUTHORIZATION_TYPE_TRUST"
    """
    This authorization relationship is "trust".
    """


class BasicLevelCombiningFunction(str, Enum):
    """
    How the `conditions` list should be combined to determine if a request is granted this `AccessLevel`. If AND is used, each `Condition` in `conditions` must be satisfied for the `AccessLevel` to be applied. If OR is used, at least one `Condition` in `conditions` must be satisfied for the `AccessLevel` to be applied. Default behavior is AND.
    """
    AND_ = "AND"
    """
    All `Conditions` must be true for the `BasicLevel` to be true.
    """
    OR_ = "OR"
    """
    If at least one `Condition` is true, then the `BasicLevel` is true.
    """


class DevicePolicyAllowedDeviceManagementLevelsItem(str, Enum):
    MANAGEMENT_UNSPECIFIED = "MANAGEMENT_UNSPECIFIED"
    """
    The device's management level is not specified or not known.
    """
    NONE = "NONE"
    """
    The device is not managed.
    """
    BASIC = "BASIC"
    """
    Basic management is enabled, which is generally limited to monitoring and wiping the corporate account.
    """
    COMPLETE = "COMPLETE"
    """
    Complete device management. This includes more thorough monitoring and the ability to directly manage the device (such as remote wiping). This can be enabled through the Android Enterprise Platform.
    """


class DevicePolicyAllowedEncryptionStatusesItem(str, Enum):
    ENCRYPTION_UNSPECIFIED = "ENCRYPTION_UNSPECIFIED"
    """
    The encryption status of the device is not specified or not known.
    """
    ENCRYPTION_UNSUPPORTED = "ENCRYPTION_UNSUPPORTED"
    """
    The device does not support encryption.
    """
    UNENCRYPTED = "UNENCRYPTED"
    """
    The device supports encryption, but is currently unencrypted.
    """
    ENCRYPTED = "ENCRYPTED"
    """
    The device is encrypted.
    """


class EgressFromIdentityType(str, Enum):
    """
    Specifies the type of identities that are allowed access to outside the perimeter. If left unspecified, then members of `identities` field will be allowed access.
    """
    IDENTITY_TYPE_UNSPECIFIED = "IDENTITY_TYPE_UNSPECIFIED"
    """
    No blanket identity group specified.
    """
    ANY_IDENTITY = "ANY_IDENTITY"
    """
    Authorize access from all identities outside the perimeter.
    """
    ANY_USER_ACCOUNT = "ANY_USER_ACCOUNT"
    """
    Authorize access from all human users outside the perimeter.
    """
    ANY_SERVICE_ACCOUNT = "ANY_SERVICE_ACCOUNT"
    """
    Authorize access from all service accounts outside the perimeter.
    """


class EgressFromSourceRestriction(str, Enum):
    """
    Whether to enforce traffic restrictions based on `sources` field. If the `sources` fields is non-empty, then this field must be set to `SOURCE_RESTRICTION_ENABLED`.
    """
    SOURCE_RESTRICTION_UNSPECIFIED = "SOURCE_RESTRICTION_UNSPECIFIED"
    """
    Enforcement preference unspecified, will not enforce traffic restrictions based on `sources` in EgressFrom.
    """
    SOURCE_RESTRICTION_ENABLED = "SOURCE_RESTRICTION_ENABLED"
    """
    Enforcement preference enabled, traffic restrictions will be enforced based on `sources` in EgressFrom.
    """
    SOURCE_RESTRICTION_DISABLED = "SOURCE_RESTRICTION_DISABLED"
    """
    Enforcement preference disabled, will not enforce traffic restrictions based on `sources` in EgressFrom.
    """


class IngressFromIdentityType(str, Enum):
    """
    Specifies the type of identities that are allowed access from outside the perimeter. If left unspecified, then members of `identities` field will be allowed access.
    """
    IDENTITY_TYPE_UNSPECIFIED = "IDENTITY_TYPE_UNSPECIFIED"
    """
    No blanket identity group specified.
    """
    ANY_IDENTITY = "ANY_IDENTITY"
    """
    Authorize access from all identities outside the perimeter.
    """
    ANY_USER_ACCOUNT = "ANY_USER_ACCOUNT"
    """
    Authorize access from all human users outside the perimeter.
    """
    ANY_SERVICE_ACCOUNT = "ANY_SERVICE_ACCOUNT"
    """
    Authorize access from all service accounts outside the perimeter.
    """


class OsConstraintOsType(str, Enum):
    """
    Required. The allowed OS type.
    """
    OS_UNSPECIFIED = "OS_UNSPECIFIED"
    """
    The operating system of the device is not specified or not known.
    """
    DESKTOP_MAC = "DESKTOP_MAC"
    """
    A desktop Mac operating system.
    """
    DESKTOP_WINDOWS = "DESKTOP_WINDOWS"
    """
    A desktop Windows operating system.
    """
    DESKTOP_LINUX = "DESKTOP_LINUX"
    """
    A desktop Linux operating system.
    """
    DESKTOP_CHROME_OS = "DESKTOP_CHROME_OS"
    """
    A desktop ChromeOS operating system.
    """
    ANDROID = "ANDROID"
    """
    An Android operating system.
    """
    IOS = "IOS"
    """
    An iOS operating system.
    """


class ServicePerimeterPerimeterType(str, Enum):
    """
    Perimeter type indicator. A single project or VPC network is allowed to be a member of single regular perimeter, but multiple service perimeter bridges. A project cannot be a included in a perimeter bridge without being included in regular perimeter. For perimeter bridges, the restricted service list as well as access level lists must be empty.
    """
    PERIMETER_TYPE_REGULAR = "PERIMETER_TYPE_REGULAR"
    """
    Regular Perimeter. When no value is specified, the perimeter uses this type.
    """
    PERIMETER_TYPE_BRIDGE = "PERIMETER_TYPE_BRIDGE"
    """
    Perimeter Bridge.
    """
