# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'BackupType',
    'ClusterDatabaseVersion',
    'InstanceAvailabilityType',
    'InstanceInstanceType',
    'SslConfigCaSource',
    'SslConfigSslMode',
    'UserUserType',
    'WeeklyScheduleDaysOfWeekItem',
]


class BackupType(str, Enum):
    """
    The backup type, which suggests the trigger for the backup.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Backup Type is unknown.
    """
    ON_DEMAND = "ON_DEMAND"
    """
    ON_DEMAND backups that were triggered by the customer (e.g., not AUTOMATED).
    """
    AUTOMATED = "AUTOMATED"
    """
    AUTOMATED backups triggered by the automated backups scheduler pursuant to an automated backup policy.
    """
    CONTINUOUS = "CONTINUOUS"
    """
    CONTINUOUS backups triggered by the automated backups scheduler due to a continuous backup policy.
    """


class ClusterDatabaseVersion(str, Enum):
    """
    Optional. The database engine major version. This is an optional field and it is populated at the Cluster creation time. If a database version is not supplied at cluster creation time, then a default database version will be used.
    """
    DATABASE_VERSION_UNSPECIFIED = "DATABASE_VERSION_UNSPECIFIED"
    """
    This is an unknown database version.
    """
    POSTGRES13 = "POSTGRES_13"
    """
    DEPRECATED - The database version is Postgres 13.
    """
    POSTGRES14 = "POSTGRES_14"
    """
    The database version is Postgres 14.
    """
    POSTGRES15 = "POSTGRES_15"
    """
    The database version is Postgres 15.
    """


class InstanceAvailabilityType(str, Enum):
    """
    Availability type of an Instance. If empty, defaults to REGIONAL for primary instances. For read pools, availability_type is always UNSPECIFIED. Instances in the read pools are evenly distributed across available zones within the region (i.e. read pools with more than one node will have a node in at least two zones).
    """
    AVAILABILITY_TYPE_UNSPECIFIED = "AVAILABILITY_TYPE_UNSPECIFIED"
    """
    This is an unknown Availability type.
    """
    ZONAL = "ZONAL"
    """
    Zonal available instance.
    """
    REGIONAL = "REGIONAL"
    """
    Regional (or Highly) available instance.
    """


class InstanceInstanceType(str, Enum):
    """
    Required. The type of the instance. Specified at creation time.
    """
    INSTANCE_TYPE_UNSPECIFIED = "INSTANCE_TYPE_UNSPECIFIED"
    """
    The type of the instance is unknown.
    """
    PRIMARY = "PRIMARY"
    """
    PRIMARY instances support read and write operations.
    """
    READ_POOL = "READ_POOL"
    """
    READ POOL instances support read operations only. Each read pool instance consists of one or more homogeneous nodes. * Read pool of size 1 can only have zonal availability. * Read pools with node count of 2 or more can have regional availability (nodes are present in 2 or more zones in a region).
    """
    SECONDARY = "SECONDARY"
    """
    SECONDARY instances support read operations only. SECONDARY instance is a cross-region read replica
    """


class SslConfigCaSource(str, Enum):
    """
    Optional. Certificate Authority (CA) source. Only CA_SOURCE_MANAGED is supported currently, and is the default value.
    """
    CA_SOURCE_UNSPECIFIED = "CA_SOURCE_UNSPECIFIED"
    """
    Certificate Authority (CA) source not specified. Defaults to CA_SOURCE_MANAGED.
    """
    CA_SOURCE_MANAGED = "CA_SOURCE_MANAGED"
    """
    Certificate Authority (CA) managed by the AlloyDB Cluster.
    """


class SslConfigSslMode(str, Enum):
    """
    Optional. SSL mode. Specifies client-server SSL/TLS connection behavior.
    """
    SSL_MODE_UNSPECIFIED = "SSL_MODE_UNSPECIFIED"
    """
    SSL mode not specified. Defaults to ENCRYPTED_ONLY.
    """
    SSL_MODE_ALLOW = "SSL_MODE_ALLOW"
    """
    SSL connections are optional. CA verification not enforced.
    """
    SSL_MODE_REQUIRE = "SSL_MODE_REQUIRE"
    """
    SSL connections are required. CA verification not enforced. Clients may use locally self-signed certificates (default psql client behavior).
    """
    SSL_MODE_VERIFY_CA = "SSL_MODE_VERIFY_CA"
    """
    SSL connections are required. CA verification enforced. Clients must have certificates signed by a Cluster CA, e.g. via GenerateClientCertificate.
    """
    ALLOW_UNENCRYPTED_AND_ENCRYPTED = "ALLOW_UNENCRYPTED_AND_ENCRYPTED"
    """
    SSL connections are optional. CA verification not enforced.
    """
    ENCRYPTED_ONLY = "ENCRYPTED_ONLY"
    """
    SSL connections are required. CA verification not enforced.
    """


class UserUserType(str, Enum):
    """
    Optional. Type of this user.
    """
    USER_TYPE_UNSPECIFIED = "USER_TYPE_UNSPECIFIED"
    """
    Unspecified user type.
    """
    ALLOYDB_BUILT_IN = "ALLOYDB_BUILT_IN"
    """
    The default user type that authenticates via password-based authentication.
    """
    ALLOYDB_IAM_USER = "ALLOYDB_IAM_USER"
    """
    Database user that can authenticate via IAM-Based authentication.
    """


class WeeklyScheduleDaysOfWeekItem(str, Enum):
    DAY_OF_WEEK_UNSPECIFIED = "DAY_OF_WEEK_UNSPECIFIED"
    """
    The day of the week is unspecified.
    """
    MONDAY = "MONDAY"
    """
    Monday
    """
    TUESDAY = "TUESDAY"
    """
    Tuesday
    """
    WEDNESDAY = "WEDNESDAY"
    """
    Wednesday
    """
    THURSDAY = "THURSDAY"
    """
    Thursday
    """
    FRIDAY = "FRIDAY"
    """
    Friday
    """
    SATURDAY = "SATURDAY"
    """
    Saturday
    """
    SUNDAY = "SUNDAY"
    """
    Sunday
    """
