# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ApiProductQuotaCounterScope',
    'DataCollectorType',
    'EnvironmentApiProxyType',
    'EnvironmentDeploymentType',
    'EnvironmentType',
    'GoogleCloudApigeeV1TraceSamplingConfigSampler',
    'GoogleIamV1AuditLogConfigLogType',
    'InstancePeeringCidrRange',
    'OrganizationBillingType',
    'OrganizationRuntimeType',
    'OrganizationType',
    'RatePlanBillingPeriod',
    'RatePlanConsumptionPricingType',
    'RatePlanPaymentFundingModel',
    'RatePlanRevenueShareType',
    'RatePlanState',
    'SecurityActionState',
    'TargetServerProtocol',
]


class ApiProductQuotaCounterScope(str, Enum):
    """
    Scope of the quota decides how the quota counter gets applied and evaluate for quota violation. If the Scope is set as PROXY, then all the operations defined for the APIproduct that are associated with the same proxy will share the same quota counter set at the APIproduct level, making it a global counter at a proxy level. If the Scope is set as OPERATION, then each operations get the counter set at the API product dedicated, making it a local counter. Note that, the QuotaCounterScope applies only when an operation does not have dedicated quota set for itself.
    """
    QUOTA_COUNTER_SCOPE_UNSPECIFIED = "QUOTA_COUNTER_SCOPE_UNSPECIFIED"
    """
    When quota is not explicitly defined for each operation(REST/GraphQL), the limits set at product level will be used as a local counter for quota evaluation by all the operations, independent of proxy association.
    """
    PROXY = "PROXY"
    """
    When quota is not explicitly defined for each operation(REST/GraphQL), set at product level will be used as a global counter for quota evaluation by all the operations associated with a particular proxy.
    """
    OPERATION = "OPERATION"
    """
    When quota is not explicitly defined for each operation(REST/GraphQL), the limits set at product level will be used as a local counter for quota evaluation by all the operations, independent of proxy association. This behavior mimics the same as QUOTA_COUNTER_SCOPE_UNSPECIFIED.
    """


class DataCollectorType(str, Enum):
    """
    Immutable. The type of data this data collector will collect.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    For future compatibility.
    """
    INTEGER = "INTEGER"
    """
    For integer values.
    """
    FLOAT = "FLOAT"
    """
    For float values.
    """
    STRING = "STRING"
    """
    For string values.
    """
    BOOLEAN = "BOOLEAN"
    """
    For boolean values.
    """
    DATETIME = "DATETIME"
    """
    For datetime values.
    """


class EnvironmentApiProxyType(str, Enum):
    """
    Optional. API Proxy type supported by the environment. The type can be set when creating the Environment and cannot be changed.
    """
    API_PROXY_TYPE_UNSPECIFIED = "API_PROXY_TYPE_UNSPECIFIED"
    """
    API proxy type not specified.
    """
    PROGRAMMABLE = "PROGRAMMABLE"
    """
    Programmable API Proxies enable you to develop APIs with highly flexible behavior using bundled policy configuration and one or more programming languages to describe complex sequential and/or conditional flows of logic.
    """
    CONFIGURABLE = "CONFIGURABLE"
    """
    Configurable API Proxies enable you to develop efficient APIs using simple configuration while complex execution control flow logic is handled by Apigee. This type only works with the ARCHIVE deployment type and cannot be combined with the PROXY deployment type.
    """


class EnvironmentDeploymentType(str, Enum):
    """
    Optional. Deployment type supported by the environment. The deployment type can be set when creating the environment and cannot be changed. When you enable archive deployment, you will be **prevented from performing** a [subset of actions](/apigee/docs/api-platform/local-development/overview#prevented-actions) within the environment, including: * Managing the deployment of API proxy or shared flow revisions * Creating, updating, or deleting resource files * Creating, updating, or deleting target servers
    """
    DEPLOYMENT_TYPE_UNSPECIFIED = "DEPLOYMENT_TYPE_UNSPECIFIED"
    """
    Deployment type not specified.
    """
    PROXY = "PROXY"
    """
    Proxy deployment enables you to develop and deploy API proxies using Apigee on Google Cloud. This cannot currently be combined with the CONFIGURABLE API proxy type.
    """
    ARCHIVE = "ARCHIVE"
    """
    Archive deployment enables you to develop API proxies locally then deploy an archive of your API proxy configuration to an environment in Apigee on Google Cloud. You will be prevented from performing a [subset of actions](/apigee/docs/api-platform/local-development/overview#prevented-actions) within the environment.
    """


class EnvironmentType(str, Enum):
    """
    Optional. EnvironmentType selected for the environment.
    """
    ENVIRONMENT_TYPE_UNSPECIFIED = "ENVIRONMENT_TYPE_UNSPECIFIED"
    """
    Environment type not specified.
    """
    BASE = "BASE"
    """
    Base environment has limited capacity and capabilities and are usually used when you are getting started with Apigee or while experimenting. Refer to Apigee's public documentation for more details.
    """
    INTERMEDIATE = "INTERMEDIATE"
    """
    This is the default type and it supports API management features and higher capacity than Base environment. Refer to Apigee's public documentation for more details.
    """
    COMPREHENSIVE = "COMPREHENSIVE"
    """
    Comprehensive environment supports advanced capabilites and even higher capacity than Intermediate environment. Refer to Apigee's public documentation for more details.
    """


class GoogleCloudApigeeV1TraceSamplingConfigSampler(str, Enum):
    """
    Sampler of distributed tracing. OFF is the default value.
    """
    SAMPLER_UNSPECIFIED = "SAMPLER_UNSPECIFIED"
    """
    Sampler unspecified.
    """
    OFF = "OFF"
    """
    OFF means distributed trace is disabled, or the sampling probability is 0.
    """
    PROBABILITY = "PROBABILITY"
    """
    PROBABILITY means traces are captured on a probability that defined by sampling_rate. The sampling rate is limited to 0 to 0.5 when this is set.
    """


class GoogleIamV1AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """


class InstancePeeringCidrRange(str, Enum):
    """
    Optional. Size of the CIDR block range that will be reserved by the instance. PAID organizations support `SLASH_16` to `SLASH_20` and defaults to `SLASH_16`. Evaluation organizations support only `SLASH_23`.
    """
    CIDR_RANGE_UNSPECIFIED = "CIDR_RANGE_UNSPECIFIED"
    """
    Range not specified.
    """
    SLASH16 = "SLASH_16"
    """
    `/16` CIDR range.
    """
    SLASH17 = "SLASH_17"
    """
    `/17` CIDR range.
    """
    SLASH18 = "SLASH_18"
    """
    `/18` CIDR range.
    """
    SLASH19 = "SLASH_19"
    """
    `/19` CIDR range.
    """
    SLASH20 = "SLASH_20"
    """
    `/20` CIDR range.
    """
    SLASH22 = "SLASH_22"
    """
    `/22` CIDR range. Supported for evaluation only.
    """
    SLASH23 = "SLASH_23"
    """
    `/23` CIDR range. Supported for evaluation only.
    """


class OrganizationBillingType(str, Enum):
    """
    Billing type of the Apigee organization. See [Apigee pricing](https://cloud.google.com/apigee/pricing).
    """
    BILLING_TYPE_UNSPECIFIED = "BILLING_TYPE_UNSPECIFIED"
    """
    Billing type not specified.
    """
    SUBSCRIPTION = "SUBSCRIPTION"
    """
    A pre-paid subscription to Apigee.
    """
    EVALUATION = "EVALUATION"
    """
    Free and limited access to Apigee for evaluation purposes only.
    """
    PAYG = "PAYG"
    """
    Access to Apigee using a Pay-As-You-Go plan.
    """


class OrganizationRuntimeType(str, Enum):
    """
    Required. Runtime type of the Apigee organization based on the Apigee subscription purchased.
    """
    RUNTIME_TYPE_UNSPECIFIED = "RUNTIME_TYPE_UNSPECIFIED"
    """
    Runtime type not specified.
    """
    CLOUD = "CLOUD"
    """
    Google-managed Apigee runtime.
    """
    HYBRID = "HYBRID"
    """
    User-managed Apigee hybrid runtime.
    """


class OrganizationType(str, Enum):
    """
    Not used by Apigee.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Subscription type not specified.
    """
    TYPE_TRIAL = "TYPE_TRIAL"
    """
    Subscription to Apigee is free, limited, and used for evaluation purposes only.
    """
    TYPE_PAID = "TYPE_PAID"
    """
    Full subscription to Apigee has been purchased. See [Apigee pricing](https://cloud.google.com/apigee/pricing/).
    """
    TYPE_INTERNAL = "TYPE_INTERNAL"
    """
    For internal users only.
    """


class RatePlanBillingPeriod(str, Enum):
    """
    Frequency at which the customer will be billed.
    """
    BILLING_PERIOD_UNSPECIFIED = "BILLING_PERIOD_UNSPECIFIED"
    """
    Billing period not specified.
    """
    WEEKLY = "WEEKLY"
    """
    Weekly billing period. **Note**: Not supported by Apigee at this time.
    """
    MONTHLY = "MONTHLY"
    """
    Monthly billing period.
    """


class RatePlanConsumptionPricingType(str, Enum):
    """
    Pricing model used for consumption-based charges.
    """
    CONSUMPTION_PRICING_TYPE_UNSPECIFIED = "CONSUMPTION_PRICING_TYPE_UNSPECIFIED"
    """
    Pricing model not specified. This is the default.
    """
    FIXED_PER_UNIT = "FIXED_PER_UNIT"
    """
    Fixed rate charged for each API call.
    """
    BANDED = "BANDED"
    """
    Variable rate charged for each API call based on price tiers. Example: * 1-100 calls cost $2 per call * 101-200 calls cost $1.50 per call * 201-300 calls cost $1 per call * Total price for 50 calls: 50 x $2 = $100 * Total price for 150 calls: 100 x $2 + 50 x $1.5 = $275 * Total price for 250 calls: 100 x $2 + 100 x $1.5 + 50 x $1 = $400. **Note**: Not supported by Apigee at this time.
    """
    TIERED = "TIERED"
    """
    **Note**: Not supported by Apigee at this time.
    """
    STAIRSTEP = "STAIRSTEP"
    """
    **Note**: Not supported by Apigee at this time.
    """


class RatePlanPaymentFundingModel(str, Enum):
    """
    DEPRECATED: This field is no longer supported and will eventually be removed when Apigee Hybrid 1.5/1.6 is no longer supported. Instead, use the `billingType` field inside `DeveloperMonetizationConfig` resource. Flag that specifies the billing account type, prepaid or postpaid.
    """
    PAYMENT_FUNDING_MODEL_UNSPECIFIED = "PAYMENT_FUNDING_MODEL_UNSPECIFIED"
    """
    Billing account type not specified.
    """
    PREPAID = "PREPAID"
    """
    Prepaid billing account type. Developer pays in advance for the use of your API products. Funds are deducted from their prepaid account balance. **Note**: Not supported by Apigee at this time.
    """
    POSTPAID = "POSTPAID"
    """
    Postpaid billing account type. Developer is billed through an invoice after using your API products.
    """


class RatePlanRevenueShareType(str, Enum):
    """
    Method used to calculate the revenue that is shared with developers.
    """
    REVENUE_SHARE_TYPE_UNSPECIFIED = "REVENUE_SHARE_TYPE_UNSPECIFIED"
    """
    Revenue share type is not specified.
    """
    FIXED = "FIXED"
    """
    Fixed percentage of the total revenue will be shared. The percentage to be shared can be configured by the API provider.
    """
    VOLUME_BANDED = "VOLUME_BANDED"
    """
    Amount of revenue shared depends on the number of API calls. The API call volume ranges and the revenue share percentage for each volume can be configured by the API provider. **Note**: Not supported by Apigee at this time.
    """


class RatePlanState(str, Enum):
    """
    Current state of the rate plan (draft or published).
    """
    STATE_UNSPECIFIED = "STATE_UNSPECIFIED"
    """
    State of the rate plan is not specified.
    """
    DRAFT = "DRAFT"
    """
    Rate plan is in draft mode and only visible to API providers.
    """
    PUBLISHED = "PUBLISHED"
    """
    Rate plan is published and will become visible to developers for the configured duration (between `startTime` and `endTime`).
    """


class SecurityActionState(str, Enum):
    """
    Required. Only an ENABLED SecurityAction is enforced. An ENABLED SecurityAction past its expiration time will not be enforced.
    """
    STATE_UNSPECIFIED = "STATE_UNSPECIFIED"
    """
    The default value. This only exists for forward compatibility. A create request with this value will be rejected.
    """
    ENABLED = "ENABLED"
    """
    An ENABLED SecurityAction is actively enforced if the `expiration_time` is in the future.
    """
    DISABLED = "DISABLED"
    """
    A disabled SecurityAction is never enforced.
    """


class TargetServerProtocol(str, Enum):
    """
    Immutable. The protocol used by this TargetServer.
    """
    PROTOCOL_UNSPECIFIED = "PROTOCOL_UNSPECIFIED"
    """
    UNSPECIFIED defaults to HTTP for backwards compatibility.
    """
    HTTP = "HTTP"
    """
    The TargetServer uses HTTP.
    """
    HTTP2 = "HTTP2"
    """
    The TargetSever uses HTTP2.
    """
    GRPC_TARGET = "GRPC_TARGET"
    """
    The TargetServer uses GRPC.
    """
    GRPC = "GRPC"
    """
    GRPC TargetServer to be used in ExternalCallout Policy. Prefer to use EXTERNAL_CALLOUT instead. TODO(b/266125112) deprecate once EXTERNAL _CALLOUT generally available.
    """
    EXTERNAL_CALLOUT = "EXTERNAL_CALLOUT"
    """
    The TargetServer is to be used in the ExternalCallout Policy
    """
