# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AppConnectionType',
    'AppGatewayHostType',
    'AppGatewayType',
    'ConnectionType',
    'GatewayType',
    'GoogleCloudBeyondcorpAppconnectionsV1alphaAppConnectionGatewayType',
    'GoogleCloudBeyondcorpAppconnectorsV1alphaResourceInfoStatus',
    'GoogleIamV1AuditLogConfigLogType',
    'ResourceInfoStatus',
    'SubscriptionSku',
    'SubscriptionType',
]


class AppConnectionType(str, Enum):
    """
    Required. The type of network connectivity used by the AppConnection.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Default value. This value is unused.
    """
    TCP_PROXY = "TCP_PROXY"
    """
    TCP Proxy based BeyondCorp AppConnection. API will default to this if unset.
    """


class AppGatewayHostType(str, Enum):
    """
    Required. The type of hosting used by the AppGateway.
    """
    HOST_TYPE_UNSPECIFIED = "HOST_TYPE_UNSPECIFIED"
    """
    Default value. This value is unused.
    """
    GCP_REGIONAL_MIG = "GCP_REGIONAL_MIG"
    """
    AppGateway hosted in a GCP regional managed instance group.
    """


class AppGatewayType(str, Enum):
    """
    Required. The type of network connectivity used by the AppGateway.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Default value. This value is unused.
    """
    TCP_PROXY = "TCP_PROXY"
    """
    TCP Proxy based BeyondCorp Connection. API will default to this if unset.
    """


class ConnectionType(str, Enum):
    """
    Required. The type of network connectivity used by the connection.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Default value. This value is unused.
    """
    TCP_PROXY = "TCP_PROXY"
    """
    TCP Proxy based BeyondCorp Connection. API will default to this if unset.
    """


class GatewayType(str, Enum):
    """
    Required. The type of hosting used by the gateway.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Default value. This value is unused.
    """
    GCP_REGIONAL_MIG = "GCP_REGIONAL_MIG"
    """
    Gateway hosted in a GCP regional managed instance group.
    """


class GoogleCloudBeyondcorpAppconnectionsV1alphaAppConnectionGatewayType(str, Enum):
    """
    Required. The type of hosting used by the gateway.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Default value. This value is unused.
    """
    GCP_REGIONAL_MIG = "GCP_REGIONAL_MIG"
    """
    Gateway hosted in a GCP regional managed instance group.
    """


class GoogleCloudBeyondcorpAppconnectorsV1alphaResourceInfoStatus(str, Enum):
    """
    Overall health status. Overall status is derived based on the status of each sub level resources.
    """
    HEALTH_STATUS_UNSPECIFIED = "HEALTH_STATUS_UNSPECIFIED"
    """
    Health status is unknown: not initialized or failed to retrieve.
    """
    HEALTHY = "HEALTHY"
    """
    The resource is healthy.
    """
    UNHEALTHY = "UNHEALTHY"
    """
    The resource is unhealthy.
    """
    UNRESPONSIVE = "UNRESPONSIVE"
    """
    The resource is unresponsive.
    """
    DEGRADED = "DEGRADED"
    """
    Some sub-resources are UNHEALTHY.
    """


class GoogleIamV1AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """


class ResourceInfoStatus(str, Enum):
    """
    Overall health status. Overall status is derived based on the status of each sub level resources.
    """
    HEALTH_STATUS_UNSPECIFIED = "HEALTH_STATUS_UNSPECIFIED"
    """
    Health status is unknown: not initialized or failed to retrieve.
    """
    HEALTHY = "HEALTHY"
    """
    The resource is healthy.
    """
    UNHEALTHY = "UNHEALTHY"
    """
    The resource is unhealthy.
    """
    UNRESPONSIVE = "UNRESPONSIVE"
    """
    The resource is unresponsive.
    """
    DEGRADED = "DEGRADED"
    """
    Some sub-resources are UNHEALTHY.
    """


class SubscriptionSku(str, Enum):
    """
    Required. SKU of subscription.
    """
    SKU_UNSPECIFIED = "SKU_UNSPECIFIED"
    """
    Default value. This value is unused.
    """
    BCE_STANDARD_SKU = "BCE_STANDARD_SKU"
    """
    Represents BeyondCorp Standard SKU.
    """


class SubscriptionType(str, Enum):
    """
    Required. Type of subscription.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Default value. This value is unused.
    """
    TRIAL = "TRIAL"
    """
    Represents a trial subscription.
    """
    PAID = "PAID"
    """
    Represents a paid subscription.
    """
    ALLOWLIST = "ALLOWLIST"
    """
    Reresents an allowlisted subscription.
    """
