# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AuditLogConfigLogType',
    'DataMaskingPolicyPredefinedExpression',
    'DataPolicyDataPolicyType',
]


class AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """


class DataMaskingPolicyPredefinedExpression(str, Enum):
    """
    A predefined masking expression.
    """
    PREDEFINED_EXPRESSION_UNSPECIFIED = "PREDEFINED_EXPRESSION_UNSPECIFIED"
    """
    Default, unspecified predefined expression. No masking will take place since no expression is specified.
    """
    SHA256 = "SHA256"
    """
    Masking expression to replace data with SHA-256 hash.
    """
    ALWAYS_NULL = "ALWAYS_NULL"
    """
    Masking expression to replace data with NULLs.
    """
    DEFAULT_MASKING_VALUE = "DEFAULT_MASKING_VALUE"
    """
    Masking expression to replace data with their default masking values. The default masking values for each type listed as below: * STRING: "" * BYTES: b'' * INTEGER: 0 * FLOAT: 0.0 * NUMERIC: 0 * BOOLEAN: FALSE * TIMESTAMP: 1970-01-01 00:00:00 UTC * DATE: 1970-01-01 * TIME: 00:00:00 * DATETIME: 1970-01-01T00:00:00 * GEOGRAPHY: POINT(0 0) * BIGNUMERIC: 0 * ARRAY: [] * STRUCT: NOT_APPLICABLE * JSON: NULL
    """
    LAST_FOUR_CHARACTERS = "LAST_FOUR_CHARACTERS"
    """
    Masking expression shows the last four characters of text. The masking behavior is as follows: * If text length > 4 characters: Replace text with XXXXX, append last four characters of original text. * If text length <= 4 characters: Apply SHA-256 hash.
    """
    FIRST_FOUR_CHARACTERS = "FIRST_FOUR_CHARACTERS"
    """
    Masking expression shows the first four characters of text. The masking behavior is as follows: * If text length > 4 characters: Replace text with XXXXX, prepend first four characters of original text. * If text length <= 4 characters: Apply SHA-256 hash.
    """
    EMAIL_MASK = "EMAIL_MASK"
    """
    Masking expression for email addresses. The masking behavior is as follows: * Syntax-valid email address: Replace username with XXXXX. For example, cloudysanfrancisco@gmail.com becomes XXXXX@gmail.com. * Syntax-invalid email address: Apply SHA-256 hash. For more information, see Email mask.
    """
    DATE_YEAR_MASK = "DATE_YEAR_MASK"
    """
    Masking expression to only show the *year* of `Date`, `DateTime` and `TimeStamp`. For example, with the year 2076: * DATE : 2076-01-01 * DATETIME : 2076-01-01T00:00:00 * TIMESTAMP : 2076-01-01 00:00:00 UTC Truncation occurs according to the UTC time zone. To change this, adjust the default time zone using the `time_zone` system variable. For more information, see the System variables reference.
    """


class DataPolicyDataPolicyType(str, Enum):
    """
    Type of data policy.
    """
    DATA_POLICY_TYPE_UNSPECIFIED = "DATA_POLICY_TYPE_UNSPECIFIED"
    """
    Default value for the data policy type. This should not be used.
    """
    COLUMN_LEVEL_SECURITY_POLICY = "COLUMN_LEVEL_SECURITY_POLICY"
    """
    Used to create a data policy for column-level security, without data masking.
    """
    DATA_MASKING_POLICY = "DATA_MASKING_POLICY"
    """
    Used to create a data policy for data masking.
    """
