# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'CapacityCommitmentEdition',
    'CapacityCommitmentPlan',
    'CapacityCommitmentRenewalPlan',
    'ReservationEdition',
]


class CapacityCommitmentEdition(str, Enum):
    """
    Edition of the capacity commitment.
    """
    EDITION_UNSPECIFIED = "EDITION_UNSPECIFIED"
    """
    Default value, which will be treated as ENTERPRISE.
    """
    STANDARD = "STANDARD"
    """
    Standard edition.
    """
    ENTERPRISE = "ENTERPRISE"
    """
    Enterprise edition.
    """
    ENTERPRISE_PLUS = "ENTERPRISE_PLUS"
    """
    Enterprise plus edition.
    """


class CapacityCommitmentPlan(str, Enum):
    """
    Capacity commitment commitment plan.
    """
    COMMITMENT_PLAN_UNSPECIFIED = "COMMITMENT_PLAN_UNSPECIFIED"
    """
    Invalid plan value. Requests with this value will be rejected with error code `google.rpc.Code.INVALID_ARGUMENT`.
    """
    FLEX = "FLEX"
    """
    Flex commitments have committed period of 1 minute after becoming ACTIVE. After that, they are not in a committed period anymore and can be removed any time.
    """
    FLEX_FLAT_RATE = "FLEX_FLAT_RATE"
    """
    Same as FLEX, should only be used if flat-rate commitments are still available.
    """
    TRIAL = "TRIAL"
    """
    Trial commitments have a committed period of 182 days after becoming ACTIVE. After that, they are converted to a new commitment based on the `renewal_plan`. Default `renewal_plan` for Trial commitment is Flex so that it can be deleted right after committed period ends.
    """
    MONTHLY = "MONTHLY"
    """
    Monthly commitments have a committed period of 30 days after becoming ACTIVE. After that, they are not in a committed period anymore and can be removed any time.
    """
    MONTHLY_FLAT_RATE = "MONTHLY_FLAT_RATE"
    """
    Same as MONTHLY, should only be used if flat-rate commitments are still available.
    """
    ANNUAL = "ANNUAL"
    """
    Annual commitments have a committed period of 365 days after becoming ACTIVE. After that they are converted to a new commitment based on the renewal_plan.
    """
    ANNUAL_FLAT_RATE = "ANNUAL_FLAT_RATE"
    """
    Same as ANNUAL, should only be used if flat-rate commitments are still available.
    """
    THREE_YEAR = "THREE_YEAR"
    """
    3-year commitments have a committed period of 1095(3 * 365) days after becoming ACTIVE. After that they are converted to a new commitment based on the renewal_plan.
    """
    NONE = "NONE"
    """
    Should only be used for `renewal_plan` and is only meaningful if edition is specified to values other than EDITION_UNSPECIFIED. Otherwise CreateCapacityCommitmentRequest or UpdateCapacityCommitmentRequest will be rejected with error code `google.rpc.Code.INVALID_ARGUMENT`. If the renewal_plan is NONE, capacity commitment will be removed at the end of its commitment period.
    """


class CapacityCommitmentRenewalPlan(str, Enum):
    """
    The plan this capacity commitment is converted to after commitment_end_time passes. Once the plan is changed, committed period is extended according to commitment plan. Only applicable for ANNUAL and TRIAL commitments.
    """
    COMMITMENT_PLAN_UNSPECIFIED = "COMMITMENT_PLAN_UNSPECIFIED"
    """
    Invalid plan value. Requests with this value will be rejected with error code `google.rpc.Code.INVALID_ARGUMENT`.
    """
    FLEX = "FLEX"
    """
    Flex commitments have committed period of 1 minute after becoming ACTIVE. After that, they are not in a committed period anymore and can be removed any time.
    """
    FLEX_FLAT_RATE = "FLEX_FLAT_RATE"
    """
    Same as FLEX, should only be used if flat-rate commitments are still available.
    """
    TRIAL = "TRIAL"
    """
    Trial commitments have a committed period of 182 days after becoming ACTIVE. After that, they are converted to a new commitment based on the `renewal_plan`. Default `renewal_plan` for Trial commitment is Flex so that it can be deleted right after committed period ends.
    """
    MONTHLY = "MONTHLY"
    """
    Monthly commitments have a committed period of 30 days after becoming ACTIVE. After that, they are not in a committed period anymore and can be removed any time.
    """
    MONTHLY_FLAT_RATE = "MONTHLY_FLAT_RATE"
    """
    Same as MONTHLY, should only be used if flat-rate commitments are still available.
    """
    ANNUAL = "ANNUAL"
    """
    Annual commitments have a committed period of 365 days after becoming ACTIVE. After that they are converted to a new commitment based on the renewal_plan.
    """
    ANNUAL_FLAT_RATE = "ANNUAL_FLAT_RATE"
    """
    Same as ANNUAL, should only be used if flat-rate commitments are still available.
    """
    THREE_YEAR = "THREE_YEAR"
    """
    3-year commitments have a committed period of 1095(3 * 365) days after becoming ACTIVE. After that they are converted to a new commitment based on the renewal_plan.
    """
    NONE = "NONE"
    """
    Should only be used for `renewal_plan` and is only meaningful if edition is specified to values other than EDITION_UNSPECIFIED. Otherwise CreateCapacityCommitmentRequest or UpdateCapacityCommitmentRequest will be rejected with error code `google.rpc.Code.INVALID_ARGUMENT`. If the renewal_plan is NONE, capacity commitment will be removed at the end of its commitment period.
    """


class ReservationEdition(str, Enum):
    """
    Edition of the reservation.
    """
    EDITION_UNSPECIFIED = "EDITION_UNSPECIFIED"
    """
    Default value, which will be treated as ENTERPRISE.
    """
    STANDARD = "STANDARD"
    """
    Standard edition.
    """
    ENTERPRISE = "ENTERPRISE"
    """
    Enterprise edition.
    """
    ENTERPRISE_PLUS = "ENTERPRISE_PLUS"
    """
    Enterprise plus edition.
    """
