# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AppProfilePriority',
    'AuditLogConfigLogType',
    'ClusterDefaultStorageType',
    'InstanceType',
    'StandardIsolationPriority',
    'TableGranularity',
]


class AppProfilePriority(str, Enum):
    """
    This field has been deprecated in favor of `standard_isolation.priority`. If you set this field, `standard_isolation.priority` will be set instead. The priority of requests sent using this app profile.
    """
    PRIORITY_UNSPECIFIED = "PRIORITY_UNSPECIFIED"
    """
    Default value. Mapped to PRIORITY_HIGH (the legacy behavior) on creation.
    """
    PRIORITY_LOW = "PRIORITY_LOW"
    PRIORITY_MEDIUM = "PRIORITY_MEDIUM"
    PRIORITY_HIGH = "PRIORITY_HIGH"


class AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """


class ClusterDefaultStorageType(str, Enum):
    """
    Immutable. The type of storage used by this cluster to serve its parent instance's tables, unless explicitly overridden.
    """
    STORAGE_TYPE_UNSPECIFIED = "STORAGE_TYPE_UNSPECIFIED"
    """
    The user did not specify a storage type.
    """
    SSD = "SSD"
    """
    Flash (SSD) storage should be used.
    """
    HDD = "HDD"
    """
    Magnetic drive (HDD) storage should be used.
    """


class InstanceType(str, Enum):
    """
    The type of the instance. Defaults to `PRODUCTION`.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    The type of the instance is unspecified. If set when creating an instance, a `PRODUCTION` instance will be created. If set when updating an instance, the type will be left unchanged.
    """
    PRODUCTION = "PRODUCTION"
    """
    An instance meant for production use. `serve_nodes` must be set on the cluster.
    """
    DEVELOPMENT = "DEVELOPMENT"
    """
    DEPRECATED: Prefer PRODUCTION for all use cases, as it no longer enforces a higher minimum node count than DEVELOPMENT.
    """


class StandardIsolationPriority(str, Enum):
    """
    The priority of requests sent using this app profile.
    """
    PRIORITY_UNSPECIFIED = "PRIORITY_UNSPECIFIED"
    """
    Default value. Mapped to PRIORITY_HIGH (the legacy behavior) on creation.
    """
    PRIORITY_LOW = "PRIORITY_LOW"
    PRIORITY_MEDIUM = "PRIORITY_MEDIUM"
    PRIORITY_HIGH = "PRIORITY_HIGH"


class TableGranularity(str, Enum):
    """
    Immutable. The granularity (i.e. `MILLIS`) at which timestamps are stored in this table. Timestamps not matching the granularity will be rejected. If unspecified at creation time, the value will be set to `MILLIS`. Views: `SCHEMA_VIEW`, `FULL`.
    """
    TIMESTAMP_GRANULARITY_UNSPECIFIED = "TIMESTAMP_GRANULARITY_UNSPECIFIED"
    """
    The user did not specify a granularity. Should not be returned. When specified during table creation, MILLIS will be used.
    """
    MILLIS = "MILLIS"
    """
    The table keeps data versioned at a granularity of 1ms.
    """
