# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'BudgetOwnershipScope',
    'GoogleCloudBillingBudgetsV1beta1FilterCalendarPeriod',
    'GoogleCloudBillingBudgetsV1beta1FilterCreditTypesTreatment',
    'GoogleCloudBillingBudgetsV1beta1ThresholdRuleSpendBasis',
]


class BudgetOwnershipScope(str, Enum):
    OWNERSHIP_SCOPE_UNSPECIFIED = "OWNERSHIP_SCOPE_UNSPECIFIED"
    """
    Unspecified ownership scope, same as ALL_USERS.
    """
    ALL_USERS = "ALL_USERS"
    """
    The Budget is fully accessible to both billing account users and resource users, provided that they have the required IAM permissions.
    """
    BILLING_ACCOUNT = "BILLING_ACCOUNT"
    """
    Only billing account users have full access to the `Budget`, resource-level users have read-only access, provided that they have the required IAM permissions.
    """


class GoogleCloudBillingBudgetsV1beta1FilterCalendarPeriod(str, Enum):
    """
    Optional. Specifies to track usage for recurring calendar period. For example, assume that CalendarPeriod.QUARTER is set. The budget will track usage from April 1 to June 30, when the current calendar month is April, May, June. After that, it will track usage from July 1 to September 30 when the current calendar month is July, August, September, so on.
    """
    CALENDAR_PERIOD_UNSPECIFIED = "CALENDAR_PERIOD_UNSPECIFIED"
    """
    Calendar period is unset. This is the default if the budget is for a custom time period (CustomPeriod).
    """
    MONTH = "MONTH"
    """
    A month. Month starts on the first day of each month, such as January 1, February 1, March 1, and so on.
    """
    QUARTER = "QUARTER"
    """
    A quarter. Quarters start on dates January 1, April 1, July 1, and October 1 of each year.
    """
    YEAR = "YEAR"
    """
    A year. Year starts on January 1.
    """


class GoogleCloudBillingBudgetsV1beta1FilterCreditTypesTreatment(str, Enum):
    """
    Optional. If not set, default behavior is `INCLUDE_ALL_CREDITS`.
    """
    CREDIT_TYPES_TREATMENT_UNSPECIFIED = "CREDIT_TYPES_TREATMENT_UNSPECIFIED"
    INCLUDE_ALL_CREDITS = "INCLUDE_ALL_CREDITS"
    """
    All types of credit are subtracted from the gross cost to determine the spend for threshold calculations.
    """
    EXCLUDE_ALL_CREDITS = "EXCLUDE_ALL_CREDITS"
    """
    All types of credit are added to the net cost to determine the spend for threshold calculations.
    """
    INCLUDE_SPECIFIED_CREDITS = "INCLUDE_SPECIFIED_CREDITS"
    """
    [Credit types](https://cloud.google.com/billing/docs/how-to/export-data-bigquery-tables#credits-type) specified in the credit_types field are subtracted from the gross cost to determine the spend for threshold calculations.
    """


class GoogleCloudBillingBudgetsV1beta1ThresholdRuleSpendBasis(str, Enum):
    """
    Optional. The type of basis used to determine if spend has passed the threshold. Behavior defaults to CURRENT_SPEND if not set.
    """
    BASIS_UNSPECIFIED = "BASIS_UNSPECIFIED"
    """
    Unspecified threshold basis.
    """
    CURRENT_SPEND = "CURRENT_SPEND"
    """
    Use current spend as the basis for comparison against the threshold.
    """
    FORECASTED_SPEND = "FORECASTED_SPEND"
    """
    Use forecasted spend for the period as the basis for comparison against the threshold. FORECASTED_SPEND can only be set when the budget's time period is a Filter.calendar_period. It cannot be set in combination with Filter.custom_period.
    """
