# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'PkixPublicKeySignatureAlgorithm',
    'VerificationRuleTrustedBuilder',
    'VulnerabilityCheckMaximumFixableSeverity',
    'VulnerabilityCheckMaximumUnfixableSeverity',
]


class PkixPublicKeySignatureAlgorithm(str, Enum):
    """
    The signature algorithm used to verify a message against a signature using this key. These signature algorithm must match the structure and any object identifiers encoded in `public_key_pem` (i.e. this algorithm must match that of the public key).
    """
    SIGNATURE_ALGORITHM_UNSPECIFIED = "SIGNATURE_ALGORITHM_UNSPECIFIED"
    """
    Not specified.
    """
    RSA_PSS2048_SHA256 = "RSA_PSS_2048_SHA256"
    """
    RSASSA-PSS 2048 bit key with a SHA256 digest.
    """
    RSA_SIGN_PSS2048_SHA256 = "RSA_SIGN_PSS_2048_SHA256"
    """
    RSASSA-PSS 2048 bit key with a SHA256 digest.
    """
    RSA_PSS3072_SHA256 = "RSA_PSS_3072_SHA256"
    """
    RSASSA-PSS 3072 bit key with a SHA256 digest.
    """
    RSA_SIGN_PSS3072_SHA256 = "RSA_SIGN_PSS_3072_SHA256"
    """
    RSASSA-PSS 3072 bit key with a SHA256 digest.
    """
    RSA_PSS4096_SHA256 = "RSA_PSS_4096_SHA256"
    """
    RSASSA-PSS 4096 bit key with a SHA256 digest.
    """
    RSA_SIGN_PSS4096_SHA256 = "RSA_SIGN_PSS_4096_SHA256"
    """
    RSASSA-PSS 4096 bit key with a SHA256 digest.
    """
    RSA_PSS4096_SHA512 = "RSA_PSS_4096_SHA512"
    """
    RSASSA-PSS 4096 bit key with a SHA512 digest.
    """
    RSA_SIGN_PSS4096_SHA512 = "RSA_SIGN_PSS_4096_SHA512"
    """
    RSASSA-PSS 4096 bit key with a SHA512 digest.
    """
    RSA_SIGN_PKCS12048_SHA256 = "RSA_SIGN_PKCS1_2048_SHA256"
    """
    RSASSA-PKCS1-v1_5 with a 2048 bit key and a SHA256 digest.
    """
    RSA_SIGN_PKCS13072_SHA256 = "RSA_SIGN_PKCS1_3072_SHA256"
    """
    RSASSA-PKCS1-v1_5 with a 3072 bit key and a SHA256 digest.
    """
    RSA_SIGN_PKCS14096_SHA256 = "RSA_SIGN_PKCS1_4096_SHA256"
    """
    RSASSA-PKCS1-v1_5 with a 4096 bit key and a SHA256 digest.
    """
    RSA_SIGN_PKCS14096_SHA512 = "RSA_SIGN_PKCS1_4096_SHA512"
    """
    RSASSA-PKCS1-v1_5 with a 4096 bit key and a SHA512 digest.
    """
    ECDSA_P256_SHA256 = "ECDSA_P256_SHA256"
    """
    ECDSA on the NIST P-256 curve with a SHA256 digest.
    """
    EC_SIGN_P256_SHA256 = "EC_SIGN_P256_SHA256"
    """
    ECDSA on the NIST P-256 curve with a SHA256 digest.
    """
    ECDSA_P384_SHA384 = "ECDSA_P384_SHA384"
    """
    ECDSA on the NIST P-384 curve with a SHA384 digest.
    """
    EC_SIGN_P384_SHA384 = "EC_SIGN_P384_SHA384"
    """
    ECDSA on the NIST P-384 curve with a SHA384 digest.
    """
    ECDSA_P521_SHA512 = "ECDSA_P521_SHA512"
    """
    ECDSA on the NIST P-521 curve with a SHA512 digest.
    """
    EC_SIGN_P521_SHA512 = "EC_SIGN_P521_SHA512"
    """
    ECDSA on the NIST P-521 curve with a SHA512 digest.
    """


class VerificationRuleTrustedBuilder(str, Enum):
    """
    Each verification rule is used for evaluation against provenances generated by a specific builder (group). For some of the builders, such as the Google Cloud Build, users don't need to explicitly specify their roots of trust in the policy since the evaluation service can automatically fetch them based on the builder (group).
    """
    BUILDER_UNSPECIFIED = "BUILDER_UNSPECIFIED"
    """
    Should never happen.
    """
    GOOGLE_CLOUD_BUILD = "GOOGLE_CLOUD_BUILD"
    """
    The whole Google Cloud Build (GCB) builder group, including all GCB builder types.
    """


class VulnerabilityCheckMaximumFixableSeverity(str, Enum):
    """
    Required. The threshold for severity for which a fix is currently available. This field is required and must be set.
    """
    MAXIMUM_ALLOWED_SEVERITY_UNSPECIFIED = "MAXIMUM_ALLOWED_SEVERITY_UNSPECIFIED"
    """
    Not specified.
    """
    BLOCK_ALL = "BLOCK_ALL"
    """
    Block any vulnerability.
    """
    MINIMAL = "MINIMAL"
    """
    Allow only minimal severity.
    """
    LOW = "LOW"
    """
    Allow only low severity and lower.
    """
    MEDIUM = "MEDIUM"
    """
    Allow medium severity and lower.
    """
    HIGH = "HIGH"
    """
    Allow high severity and lower.
    """
    CRITICAL = "CRITICAL"
    """
    Allow critical severity and lower.
    """
    ALLOW_ALL = "ALLOW_ALL"
    """
    Allow all severity, even vulnerability with unspecified severity.
    """


class VulnerabilityCheckMaximumUnfixableSeverity(str, Enum):
    """
    Required. The threshold for severity for which a fix isn't currently available. This field is required and must be set.
    """
    MAXIMUM_ALLOWED_SEVERITY_UNSPECIFIED = "MAXIMUM_ALLOWED_SEVERITY_UNSPECIFIED"
    """
    Not specified.
    """
    BLOCK_ALL = "BLOCK_ALL"
    """
    Block any vulnerability.
    """
    MINIMAL = "MINIMAL"
    """
    Allow only minimal severity.
    """
    LOW = "LOW"
    """
    Allow only low severity and lower.
    """
    MEDIUM = "MEDIUM"
    """
    Allow medium severity and lower.
    """
    HIGH = "HIGH"
    """
    Allow high severity and lower.
    """
    CRITICAL = "CRITICAL"
    """
    Allow critical severity and lower.
    """
    ALLOW_ALL = "ALLOW_ALL"
    """
    Allow all severity, even vulnerability with unspecified severity.
    """
