# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'BlockchainNodeBlockchainType',
    'EthereumDetailsConsensusClient',
    'EthereumDetailsExecutionClient',
    'EthereumDetailsNetwork',
    'EthereumDetailsNodeType',
    'GethDetailsGarbageCollectionMode',
]


class BlockchainNodeBlockchainType(str, Enum):
    """
    Immutable. The blockchain type of the node.
    """
    BLOCKCHAIN_TYPE_UNSPECIFIED = "BLOCKCHAIN_TYPE_UNSPECIFIED"
    """
    Blockchain type has not been specified, but should be.
    """
    ETHEREUM = "ETHEREUM"
    """
    The blockchain type is Ethereum.
    """


class EthereumDetailsConsensusClient(str, Enum):
    """
    Immutable. The consensus client.
    """
    CONSENSUS_CLIENT_UNSPECIFIED = "CONSENSUS_CLIENT_UNSPECIFIED"
    """
    Consensus client has not been specified, but should be.
    """
    LIGHTHOUSE = "LIGHTHOUSE"
    """
    Consensus client implementation written in Rust, maintained by Sigma Prime. See [Lighthouse - Sigma Prime](https://lighthouse.sigmaprime.io/) for details.
    """
    ERIGON_EMBEDDED_CONSENSUS_LAYER = "ERIGON_EMBEDDED_CONSENSUS_LAYER"
    """
    Erigon's embedded consensus client embedded in the execution client. Note this option is not currently available when creating new blockchain nodes. See [Erigon on GitHub](https://github.com/ledgerwatch/erigon#embedded-consensus-layer) for details.
    """


class EthereumDetailsExecutionClient(str, Enum):
    """
    Immutable. The execution client
    """
    EXECUTION_CLIENT_UNSPECIFIED = "EXECUTION_CLIENT_UNSPECIFIED"
    """
    Execution client has not been specified, but should be.
    """
    GETH = "GETH"
    """
    Official Go implementation of the Ethereum protocol. See [go-ethereum](https://geth.ethereum.org/) for details.
    """
    ERIGON = "ERIGON"
    """
    An implementation of Ethereum (execution client), on the efficiency frontier, written in Go. See [Erigon on GitHub](https://github.com/ledgerwatch/erigon) for details.
    """


class EthereumDetailsNetwork(str, Enum):
    """
    Immutable. The Ethereum environment being accessed.
    """
    NETWORK_UNSPECIFIED = "NETWORK_UNSPECIFIED"
    """
    The network has not been specified, but should be.
    """
    MAINNET = "MAINNET"
    """
    The Ethereum Mainnet.
    """
    TESTNET_GOERLI_PRATER = "TESTNET_GOERLI_PRATER"
    """
    The Ethereum Testnet based on Goerli protocol.
    """
    TESTNET_SEPOLIA = "TESTNET_SEPOLIA"
    """
    The Ethereum Testnet based on Sepolia/Bepolia protocol. See https://github.com/eth-clients/sepolia.
    """
    TESTNET_HOLESKY = "TESTNET_HOLESKY"
    """
    The Ethereum Testnet based on Holesky specification. See https://github.com/eth-clients/holesky.
    """


class EthereumDetailsNodeType(str, Enum):
    """
    Immutable. The type of Ethereum node.
    """
    NODE_TYPE_UNSPECIFIED = "NODE_TYPE_UNSPECIFIED"
    """
    Node type has not been specified, but should be.
    """
    LIGHT = "LIGHT"
    """
    An Ethereum node that only downloads Ethereum block headers.
    """
    FULL = "FULL"
    """
    Keeps a complete copy of the blockchain data, and contributes to the network by receiving, validating, and forwarding transactions.
    """
    ARCHIVE = "ARCHIVE"
    """
    Holds the same data as full node as well as all of the blockchain's history state data dating back to the Genesis Block.
    """


class GethDetailsGarbageCollectionMode(str, Enum):
    """
    Immutable. Blockchain garbage collection mode.
    """
    GARBAGE_COLLECTION_MODE_UNSPECIFIED = "GARBAGE_COLLECTION_MODE_UNSPECIFIED"
    """
    The garbage collection has not been specified.
    """
    FULL = "FULL"
    """
    Configures Geth's garbage collection so that older data not needed for a full node is deleted. This is the default mode when creating a full node.
    """
    ARCHIVE = "ARCHIVE"
    """
    Configures Geth's garbage collection so that old data is never deleted. This is the default mode when creating an archive node. This value can also be chosen when creating a full node in order to create a partial/recent archive node. See [Sync modes](https://geth.ethereum.org/docs/fundamentals/sync-modes) for more details.
    """
