# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities

__all__ = [
    'GetEndpointAttachmentResult',
    'AwaitableGetEndpointAttachmentResult',
    'get_endpoint_attachment',
    'get_endpoint_attachment_output',
]

@pulumi.output_type
class GetEndpointAttachmentResult:
    def __init__(__self__, create_time=None, description=None, endpoint_ip=None, labels=None, name=None, service_attachment=None, update_time=None):
        if create_time and not isinstance(create_time, str):
            raise TypeError("Expected argument 'create_time' to be a str")
        pulumi.set(__self__, "create_time", create_time)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if endpoint_ip and not isinstance(endpoint_ip, str):
            raise TypeError("Expected argument 'endpoint_ip' to be a str")
        pulumi.set(__self__, "endpoint_ip", endpoint_ip)
        if labels and not isinstance(labels, dict):
            raise TypeError("Expected argument 'labels' to be a dict")
        pulumi.set(__self__, "labels", labels)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if service_attachment and not isinstance(service_attachment, str):
            raise TypeError("Expected argument 'service_attachment' to be a str")
        pulumi.set(__self__, "service_attachment", service_attachment)
        if update_time and not isinstance(update_time, str):
            raise TypeError("Expected argument 'update_time' to be a str")
        pulumi.set(__self__, "update_time", update_time)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        Created time.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Optional. Description of the resource.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="endpointIp")
    def endpoint_ip(self) -> str:
        """
        The Private Service Connect connection endpoint ip
        """
        return pulumi.get(self, "endpoint_ip")

    @property
    @pulumi.getter
    def labels(self) -> Mapping[str, str]:
        """
        Optional. Resource labels to represent user-provided metadata. Refer to cloud documentation on labels for more details. https://cloud.google.com/compute/docs/labeling-resources
        """
        return pulumi.get(self, "labels")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Resource name of the Endpoint Attachment. Format: projects/{project}/locations/{location}/endpointAttachments/{endpoint_attachment}
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="serviceAttachment")
    def service_attachment(self) -> str:
        """
        The path of the service attachment
        """
        return pulumi.get(self, "service_attachment")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> str:
        """
        Updated time.
        """
        return pulumi.get(self, "update_time")


class AwaitableGetEndpointAttachmentResult(GetEndpointAttachmentResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetEndpointAttachmentResult(
            create_time=self.create_time,
            description=self.description,
            endpoint_ip=self.endpoint_ip,
            labels=self.labels,
            name=self.name,
            service_attachment=self.service_attachment,
            update_time=self.update_time)


def get_endpoint_attachment(endpoint_attachment_id: Optional[str] = None,
                            location: Optional[str] = None,
                            project: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetEndpointAttachmentResult:
    """
    Gets details of a single EndpointAttachment.
    """
    __args__ = dict()
    __args__['endpointAttachmentId'] = endpoint_attachment_id
    __args__['location'] = location
    __args__['project'] = project
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('google-native:connectors/v1:getEndpointAttachment', __args__, opts=opts, typ=GetEndpointAttachmentResult).value

    return AwaitableGetEndpointAttachmentResult(
        create_time=pulumi.get(__ret__, 'create_time'),
        description=pulumi.get(__ret__, 'description'),
        endpoint_ip=pulumi.get(__ret__, 'endpoint_ip'),
        labels=pulumi.get(__ret__, 'labels'),
        name=pulumi.get(__ret__, 'name'),
        service_attachment=pulumi.get(__ret__, 'service_attachment'),
        update_time=pulumi.get(__ret__, 'update_time'))


@_utilities.lift_output_func(get_endpoint_attachment)
def get_endpoint_attachment_output(endpoint_attachment_id: Optional[pulumi.Input[str]] = None,
                                   location: Optional[pulumi.Input[str]] = None,
                                   project: Optional[pulumi.Input[Optional[str]]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetEndpointAttachmentResult]:
    """
    Gets details of a single EndpointAttachment.
    """
    ...
