# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AlloyDbSettingsDatabaseVersion',
    'AuditLogConfigLogType',
    'CloudSqlSettingsActivationPolicy',
    'CloudSqlSettingsAvailabilityType',
    'CloudSqlSettingsDataDiskType',
    'CloudSqlSettingsDatabaseVersion',
    'CloudSqlSettingsEdition',
    'ConnectionProfileProvider',
    'ConnectionProfileState',
    'DatabaseEngineInfoEngine',
    'DatabaseTypeEngine',
    'DatabaseTypeProvider',
    'DoubleComparisonFilterValueComparison',
    'IntComparisonFilterValueComparison',
    'MappingRuleRuleScope',
    'MappingRuleState',
    'MigrationJobState',
    'MigrationJobType',
    'MultiEntityRenameSourceNameTransformation',
    'PerformanceConfigDumpParallelLevel',
    'SourceNumericFilterNumericFilterOption',
    'ValueListFilterValuePresentList',
]


class AlloyDbSettingsDatabaseVersion(str, Enum):
    """
    Optional. The database engine major version. This is an optional field. If a database version is not supplied at cluster creation time, then a default database version will be used.
    """
    DATABASE_VERSION_UNSPECIFIED = "DATABASE_VERSION_UNSPECIFIED"
    """
    This is an unknown database version.
    """
    POSTGRES14 = "POSTGRES_14"
    """
    The database version is Postgres 14.
    """
    POSTGRES15 = "POSTGRES_15"
    """
    The database version is Postgres 15.
    """


class AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """


class CloudSqlSettingsActivationPolicy(str, Enum):
    """
    The activation policy specifies when the instance is activated; it is applicable only when the instance state is 'RUNNABLE'. Valid values: 'ALWAYS': The instance is on, and remains so even in the absence of connection requests. `NEVER`: The instance is off; it is not activated, even if a connection request arrives.
    """
    SQL_ACTIVATION_POLICY_UNSPECIFIED = "SQL_ACTIVATION_POLICY_UNSPECIFIED"
    """
    unspecified policy.
    """
    ALWAYS = "ALWAYS"
    """
    The instance is always up and running.
    """
    NEVER = "NEVER"
    """
    The instance should never spin up.
    """


class CloudSqlSettingsAvailabilityType(str, Enum):
    """
    Optional. Availability type. Potential values: * `ZONAL`: The instance serves data from only one zone. Outages in that zone affect data availability. * `REGIONAL`: The instance can serve data from more than one zone in a region (it is highly available).
    """
    SQL_AVAILABILITY_TYPE_UNSPECIFIED = "SQL_AVAILABILITY_TYPE_UNSPECIFIED"
    """
    This is an unknown Availability type.
    """
    ZONAL = "ZONAL"
    """
    Zonal availablility instance.
    """
    REGIONAL = "REGIONAL"
    """
    Regional availability instance.
    """


class CloudSqlSettingsDataDiskType(str, Enum):
    """
    The type of storage: `PD_SSD` (default) or `PD_HDD`.
    """
    SQL_DATA_DISK_TYPE_UNSPECIFIED = "SQL_DATA_DISK_TYPE_UNSPECIFIED"
    """
    Unspecified.
    """
    PD_SSD = "PD_SSD"
    """
    SSD disk.
    """
    PD_HDD = "PD_HDD"
    """
    HDD disk.
    """


class CloudSqlSettingsDatabaseVersion(str, Enum):
    """
    The database engine type and version.
    """
    SQL_DATABASE_VERSION_UNSPECIFIED = "SQL_DATABASE_VERSION_UNSPECIFIED"
    """
    Unspecified version.
    """
    MYSQL56 = "MYSQL_5_6"
    """
    MySQL 5.6.
    """
    MYSQL57 = "MYSQL_5_7"
    """
    MySQL 5.7.
    """
    MYSQL80 = "MYSQL_8_0"
    """
    MySQL 8.0.
    """
    MYSQL8018 = "MYSQL_8_0_18"
    """
    The database major version is MySQL 8.0 and the minor version is 18.
    """
    MYSQL8026 = "MYSQL_8_0_26"
    """
    The database major version is MySQL 8.0 and the minor version is 26.
    """
    MYSQL8027 = "MYSQL_8_0_27"
    """
    The database major version is MySQL 8.0 and the minor version is 27.
    """
    MYSQL8028 = "MYSQL_8_0_28"
    """
    The database major version is MySQL 8.0 and the minor version is 28.
    """
    MYSQL8030 = "MYSQL_8_0_30"
    """
    The database major version is MySQL 8.0 and the minor version is 30.
    """
    MYSQL8031 = "MYSQL_8_0_31"
    """
    The database major version is MySQL 8.0 and the minor version is 31.
    """
    MYSQL8032 = "MYSQL_8_0_32"
    """
    The database major version is MySQL 8.0 and the minor version is 32.
    """
    MYSQL8033 = "MYSQL_8_0_33"
    """
    The database major version is MySQL 8.0 and the minor version is 33.
    """
    MYSQL8034 = "MYSQL_8_0_34"
    """
    The database major version is MySQL 8.0 and the minor version is 34.
    """
    POSTGRES96 = "POSTGRES_9_6"
    """
    PostgreSQL 9.6.
    """
    POSTGRES11 = "POSTGRES_11"
    """
    PostgreSQL 11.
    """
    POSTGRES10 = "POSTGRES_10"
    """
    PostgreSQL 10.
    """
    POSTGRES12 = "POSTGRES_12"
    """
    PostgreSQL 12.
    """
    POSTGRES13 = "POSTGRES_13"
    """
    PostgreSQL 13.
    """
    POSTGRES14 = "POSTGRES_14"
    """
    PostgreSQL 14.
    """
    POSTGRES15 = "POSTGRES_15"
    """
    PostgreSQL 15.
    """


class CloudSqlSettingsEdition(str, Enum):
    """
    Optional. The edition of the given Cloud SQL instance.
    """
    EDITION_UNSPECIFIED = "EDITION_UNSPECIFIED"
    """
    The instance did not specify the edition.
    """
    ENTERPRISE = "ENTERPRISE"
    """
    The instance is an enterprise edition.
    """
    ENTERPRISE_PLUS = "ENTERPRISE_PLUS"
    """
    The instance is an enterprise plus edition.
    """


class ConnectionProfileProvider(str, Enum):
    """
    The database provider.
    """
    DATABASE_PROVIDER_UNSPECIFIED = "DATABASE_PROVIDER_UNSPECIFIED"
    """
    The database provider is unknown.
    """
    CLOUDSQL = "CLOUDSQL"
    """
    CloudSQL runs the database.
    """
    RDS = "RDS"
    """
    RDS runs the database.
    """
    AURORA = "AURORA"
    """
    Amazon Aurora.
    """
    ALLOYDB = "ALLOYDB"
    """
    AlloyDB.
    """


class ConnectionProfileState(str, Enum):
    """
    The current connection profile state (e.g. DRAFT, READY, or FAILED).
    """
    STATE_UNSPECIFIED = "STATE_UNSPECIFIED"
    """
    The state of the connection profile is unknown.
    """
    DRAFT = "DRAFT"
    """
    The connection profile is in draft mode and fully editable.
    """
    CREATING = "CREATING"
    """
    The connection profile is being created.
    """
    READY = "READY"
    """
    The connection profile is ready.
    """
    UPDATING = "UPDATING"
    """
    The connection profile is being updated.
    """
    DELETING = "DELETING"
    """
    The connection profile is being deleted.
    """
    DELETED = "DELETED"
    """
    The connection profile has been deleted.
    """
    FAILED = "FAILED"
    """
    The last action on the connection profile failed.
    """


class DatabaseEngineInfoEngine(str, Enum):
    """
    Required. Engine type.
    """
    DATABASE_ENGINE_UNSPECIFIED = "DATABASE_ENGINE_UNSPECIFIED"
    """
    The source database engine of the migration job is unknown.
    """
    MYSQL = "MYSQL"
    """
    The source engine is MySQL.
    """
    POSTGRESQL = "POSTGRESQL"
    """
    The source engine is PostgreSQL.
    """
    ORACLE = "ORACLE"
    """
    The source engine is Oracle.
    """


class DatabaseTypeEngine(str, Enum):
    """
    The database engine.
    """
    DATABASE_ENGINE_UNSPECIFIED = "DATABASE_ENGINE_UNSPECIFIED"
    """
    The source database engine of the migration job is unknown.
    """
    MYSQL = "MYSQL"
    """
    The source engine is MySQL.
    """
    POSTGRESQL = "POSTGRESQL"
    """
    The source engine is PostgreSQL.
    """
    ORACLE = "ORACLE"
    """
    The source engine is Oracle.
    """


class DatabaseTypeProvider(str, Enum):
    """
    The database provider.
    """
    DATABASE_PROVIDER_UNSPECIFIED = "DATABASE_PROVIDER_UNSPECIFIED"
    """
    The database provider is unknown.
    """
    CLOUDSQL = "CLOUDSQL"
    """
    CloudSQL runs the database.
    """
    RDS = "RDS"
    """
    RDS runs the database.
    """
    AURORA = "AURORA"
    """
    Amazon Aurora.
    """
    ALLOYDB = "ALLOYDB"
    """
    AlloyDB.
    """


class DoubleComparisonFilterValueComparison(str, Enum):
    """
    Required. Relation between source value and compare value
    """
    VALUE_COMPARISON_UNSPECIFIED = "VALUE_COMPARISON_UNSPECIFIED"
    """
    Value comparison unspecified.
    """
    VALUE_COMPARISON_IF_VALUE_SMALLER_THAN = "VALUE_COMPARISON_IF_VALUE_SMALLER_THAN"
    """
    Value is smaller than the Compare value.
    """
    VALUE_COMPARISON_IF_VALUE_SMALLER_EQUAL_THAN = "VALUE_COMPARISON_IF_VALUE_SMALLER_EQUAL_THAN"
    """
    Value is smaller or equal than the Compare value.
    """
    VALUE_COMPARISON_IF_VALUE_LARGER_THAN = "VALUE_COMPARISON_IF_VALUE_LARGER_THAN"
    """
    Value is larger than the Compare value.
    """
    VALUE_COMPARISON_IF_VALUE_LARGER_EQUAL_THAN = "VALUE_COMPARISON_IF_VALUE_LARGER_EQUAL_THAN"
    """
    Value is larger or equal than the Compare value.
    """


class IntComparisonFilterValueComparison(str, Enum):
    """
    Required. Relation between source value and compare value
    """
    VALUE_COMPARISON_UNSPECIFIED = "VALUE_COMPARISON_UNSPECIFIED"
    """
    Value comparison unspecified.
    """
    VALUE_COMPARISON_IF_VALUE_SMALLER_THAN = "VALUE_COMPARISON_IF_VALUE_SMALLER_THAN"
    """
    Value is smaller than the Compare value.
    """
    VALUE_COMPARISON_IF_VALUE_SMALLER_EQUAL_THAN = "VALUE_COMPARISON_IF_VALUE_SMALLER_EQUAL_THAN"
    """
    Value is smaller or equal than the Compare value.
    """
    VALUE_COMPARISON_IF_VALUE_LARGER_THAN = "VALUE_COMPARISON_IF_VALUE_LARGER_THAN"
    """
    Value is larger than the Compare value.
    """
    VALUE_COMPARISON_IF_VALUE_LARGER_EQUAL_THAN = "VALUE_COMPARISON_IF_VALUE_LARGER_EQUAL_THAN"
    """
    Value is larger or equal than the Compare value.
    """


class MappingRuleRuleScope(str, Enum):
    """
    Required. The rule scope
    """
    DATABASE_ENTITY_TYPE_UNSPECIFIED = "DATABASE_ENTITY_TYPE_UNSPECIFIED"
    """
    Unspecified database entity type.
    """
    DATABASE_ENTITY_TYPE_SCHEMA = "DATABASE_ENTITY_TYPE_SCHEMA"
    """
    Schema.
    """
    DATABASE_ENTITY_TYPE_TABLE = "DATABASE_ENTITY_TYPE_TABLE"
    """
    Table.
    """
    DATABASE_ENTITY_TYPE_COLUMN = "DATABASE_ENTITY_TYPE_COLUMN"
    """
    Column.
    """
    DATABASE_ENTITY_TYPE_CONSTRAINT = "DATABASE_ENTITY_TYPE_CONSTRAINT"
    """
    Constraint.
    """
    DATABASE_ENTITY_TYPE_INDEX = "DATABASE_ENTITY_TYPE_INDEX"
    """
    Index.
    """
    DATABASE_ENTITY_TYPE_TRIGGER = "DATABASE_ENTITY_TYPE_TRIGGER"
    """
    Trigger.
    """
    DATABASE_ENTITY_TYPE_VIEW = "DATABASE_ENTITY_TYPE_VIEW"
    """
    View.
    """
    DATABASE_ENTITY_TYPE_SEQUENCE = "DATABASE_ENTITY_TYPE_SEQUENCE"
    """
    Sequence.
    """
    DATABASE_ENTITY_TYPE_STORED_PROCEDURE = "DATABASE_ENTITY_TYPE_STORED_PROCEDURE"
    """
    Stored Procedure.
    """
    DATABASE_ENTITY_TYPE_FUNCTION = "DATABASE_ENTITY_TYPE_FUNCTION"
    """
    Function.
    """
    DATABASE_ENTITY_TYPE_SYNONYM = "DATABASE_ENTITY_TYPE_SYNONYM"
    """
    Synonym.
    """
    DATABASE_ENTITY_TYPE_DATABASE_PACKAGE = "DATABASE_ENTITY_TYPE_DATABASE_PACKAGE"
    """
    Package.
    """
    DATABASE_ENTITY_TYPE_UDT = "DATABASE_ENTITY_TYPE_UDT"
    """
    UDT.
    """
    DATABASE_ENTITY_TYPE_MATERIALIZED_VIEW = "DATABASE_ENTITY_TYPE_MATERIALIZED_VIEW"
    """
    Materialized View.
    """
    DATABASE_ENTITY_TYPE_DATABASE = "DATABASE_ENTITY_TYPE_DATABASE"
    """
    Database.
    """


class MappingRuleState(str, Enum):
    """
    Optional. The mapping rule state
    """
    STATE_UNSPECIFIED = "STATE_UNSPECIFIED"
    """
    The state of the mapping rule is unknown.
    """
    ENABLED = "ENABLED"
    """
    The rule is enabled.
    """
    DISABLED = "DISABLED"
    """
    The rule is disabled.
    """
    DELETED = "DELETED"
    """
    The rule is logically deleted.
    """


class MigrationJobState(str, Enum):
    """
    The current migration job state.
    """
    STATE_UNSPECIFIED = "STATE_UNSPECIFIED"
    """
    The state of the migration job is unknown.
    """
    MAINTENANCE = "MAINTENANCE"
    """
    The migration job is down for maintenance.
    """
    DRAFT = "DRAFT"
    """
    The migration job is in draft mode and no resources are created.
    """
    CREATING = "CREATING"
    """
    The migration job is being created.
    """
    NOT_STARTED = "NOT_STARTED"
    """
    The migration job is created and not started.
    """
    RUNNING = "RUNNING"
    """
    The migration job is running.
    """
    FAILED = "FAILED"
    """
    The migration job failed.
    """
    COMPLETED = "COMPLETED"
    """
    The migration job has been completed.
    """
    DELETING = "DELETING"
    """
    The migration job is being deleted.
    """
    STOPPING = "STOPPING"
    """
    The migration job is being stopped.
    """
    STOPPED = "STOPPED"
    """
    The migration job is currently stopped.
    """
    DELETED = "DELETED"
    """
    The migration job has been deleted.
    """
    UPDATING = "UPDATING"
    """
    The migration job is being updated.
    """
    STARTING = "STARTING"
    """
    The migration job is starting.
    """
    RESTARTING = "RESTARTING"
    """
    The migration job is restarting.
    """
    RESUMING = "RESUMING"
    """
    The migration job is resuming.
    """


class MigrationJobType(str, Enum):
    """
    Required. The migration job type.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    The type of the migration job is unknown.
    """
    ONE_TIME = "ONE_TIME"
    """
    The migration job is a one time migration.
    """
    CONTINUOUS = "CONTINUOUS"
    """
    The migration job is a continuous migration.
    """


class MultiEntityRenameSourceNameTransformation(str, Enum):
    """
    Optional. Additional transformation that can be done on the source entity name before it is being used by the new_name_pattern, for example lower case. If no transformation is desired, use NO_TRANSFORMATION
    """
    ENTITY_NAME_TRANSFORMATION_UNSPECIFIED = "ENTITY_NAME_TRANSFORMATION_UNSPECIFIED"
    """
    Entity name transformation unspecified.
    """
    ENTITY_NAME_TRANSFORMATION_NO_TRANSFORMATION = "ENTITY_NAME_TRANSFORMATION_NO_TRANSFORMATION"
    """
    No transformation.
    """
    ENTITY_NAME_TRANSFORMATION_LOWER_CASE = "ENTITY_NAME_TRANSFORMATION_LOWER_CASE"
    """
    Transform to lower case.
    """
    ENTITY_NAME_TRANSFORMATION_UPPER_CASE = "ENTITY_NAME_TRANSFORMATION_UPPER_CASE"
    """
    Transform to upper case.
    """
    ENTITY_NAME_TRANSFORMATION_CAPITALIZED_CASE = "ENTITY_NAME_TRANSFORMATION_CAPITALIZED_CASE"
    """
    Transform to capitalized case.
    """


class PerformanceConfigDumpParallelLevel(str, Enum):
    """
    Initial dump parallelism level.
    """
    DUMP_PARALLEL_LEVEL_UNSPECIFIED = "DUMP_PARALLEL_LEVEL_UNSPECIFIED"
    """
    Unknown dump parallel level. Will be defaulted to OPTIMAL.
    """
    MIN = "MIN"
    """
    Minimal parallel level.
    """
    OPTIMAL = "OPTIMAL"
    """
    Optimal parallel level.
    """
    MAX = "MAX"
    """
    Maximum parallel level.
    """


class SourceNumericFilterNumericFilterOption(str, Enum):
    """
    Required. Enum to set the option defining the datatypes numeric filter has to be applied to
    """
    NUMERIC_FILTER_OPTION_UNSPECIFIED = "NUMERIC_FILTER_OPTION_UNSPECIFIED"
    """
    Numeric filter option unspecified
    """
    NUMERIC_FILTER_OPTION_ALL = "NUMERIC_FILTER_OPTION_ALL"
    """
    Numeric filter option that matches all numeric columns.
    """
    NUMERIC_FILTER_OPTION_LIMIT = "NUMERIC_FILTER_OPTION_LIMIT"
    """
    Numeric filter option that matches columns having numeric datatypes with specified precision and scale within the limited range of filter.
    """
    NUMERIC_FILTER_OPTION_LIMITLESS = "NUMERIC_FILTER_OPTION_LIMITLESS"
    """
    Numeric filter option that matches only the numeric columns with no precision and scale specified.
    """


class ValueListFilterValuePresentList(str, Enum):
    """
    Required. Indicates whether the filter matches rows with values that are present in the list or those with values not present in it.
    """
    VALUE_PRESENT_IN_LIST_UNSPECIFIED = "VALUE_PRESENT_IN_LIST_UNSPECIFIED"
    """
    Value present in list unspecified
    """
    VALUE_PRESENT_IN_LIST_IF_VALUE_LIST = "VALUE_PRESENT_IN_LIST_IF_VALUE_LIST"
    """
    If the source value is in the supplied list at value_list
    """
    VALUE_PRESENT_IN_LIST_IF_VALUE_NOT_LIST = "VALUE_PRESENT_IN_LIST_IF_VALUE_NOT_LIST"
    """
    If the source value is not in the supplied list at value_list
    """
