# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'GoogleCloudDatapipelinesV1FlexTemplateRuntimeEnvironmentFlexrsGoal',
    'GoogleCloudDatapipelinesV1FlexTemplateRuntimeEnvironmentIpConfiguration',
    'GoogleCloudDatapipelinesV1RuntimeEnvironmentIpConfiguration',
    'PipelineState',
    'PipelineType',
]


class GoogleCloudDatapipelinesV1FlexTemplateRuntimeEnvironmentFlexrsGoal(str, Enum):
    """
    Set FlexRS goal for the job. https://cloud.google.com/dataflow/docs/guides/flexrs
    """
    FLEXRS_UNSPECIFIED = "FLEXRS_UNSPECIFIED"
    """
    Run in the default mode.
    """
    FLEXRS_SPEED_OPTIMIZED = "FLEXRS_SPEED_OPTIMIZED"
    """
    Optimize for lower execution time.
    """
    FLEXRS_COST_OPTIMIZED = "FLEXRS_COST_OPTIMIZED"
    """
    Optimize for lower cost.
    """


class GoogleCloudDatapipelinesV1FlexTemplateRuntimeEnvironmentIpConfiguration(str, Enum):
    """
    Configuration for VM IPs.
    """
    WORKER_IP_UNSPECIFIED = "WORKER_IP_UNSPECIFIED"
    """
    The configuration is unknown, or unspecified.
    """
    WORKER_IP_PUBLIC = "WORKER_IP_PUBLIC"
    """
    Workers should have public IP addresses.
    """
    WORKER_IP_PRIVATE = "WORKER_IP_PRIVATE"
    """
    Workers should have private IP addresses.
    """


class GoogleCloudDatapipelinesV1RuntimeEnvironmentIpConfiguration(str, Enum):
    """
    Configuration for VM IPs.
    """
    WORKER_IP_UNSPECIFIED = "WORKER_IP_UNSPECIFIED"
    """
    The configuration is unknown, or unspecified.
    """
    WORKER_IP_PUBLIC = "WORKER_IP_PUBLIC"
    """
    Workers should have public IP addresses.
    """
    WORKER_IP_PRIVATE = "WORKER_IP_PRIVATE"
    """
    Workers should have private IP addresses.
    """


class PipelineState(str, Enum):
    """
    Required. The state of the pipeline. When the pipeline is created, the state is set to 'PIPELINE_STATE_ACTIVE' by default. State changes can be requested by setting the state to stopping, paused, or resuming. State cannot be changed through UpdatePipeline requests.
    """
    STATE_UNSPECIFIED = "STATE_UNSPECIFIED"
    """
    The pipeline state isn't specified.
    """
    STATE_RESUMING = "STATE_RESUMING"
    """
    The pipeline is getting started or resumed. When finished, the pipeline state will be 'PIPELINE_STATE_ACTIVE'.
    """
    STATE_ACTIVE = "STATE_ACTIVE"
    """
    The pipeline is actively running.
    """
    STATE_STOPPING = "STATE_STOPPING"
    """
    The pipeline is in the process of stopping. When finished, the pipeline state will be 'PIPELINE_STATE_ARCHIVED'.
    """
    STATE_ARCHIVED = "STATE_ARCHIVED"
    """
    The pipeline has been stopped. This is a terminal state and cannot be undone.
    """
    STATE_PAUSED = "STATE_PAUSED"
    """
    The pipeline is paused. This is a non-terminal state. When the pipeline is paused, it will hold processing jobs, but can be resumed later. For a batch pipeline, this means pausing the scheduler job. For a streaming pipeline, creating a job snapshot to resume from will give the same effect.
    """


class PipelineType(str, Enum):
    """
    Required. The type of the pipeline. This field affects the scheduling of the pipeline and the type of metrics to show for the pipeline.
    """
    PIPELINE_TYPE_UNSPECIFIED = "PIPELINE_TYPE_UNSPECIFIED"
    """
    The pipeline type isn't specified.
    """
    PIPELINE_TYPE_BATCH = "PIPELINE_TYPE_BATCH"
    """
    A batch pipeline. It runs jobs on a specific schedule, and each job will automatically terminate once execution is finished.
    """
    PIPELINE_TYPE_STREAMING = "PIPELINE_TYPE_STREAMING"
    """
    A streaming pipeline. The underlying job is continuously running until it is manually terminated by the user. This type of pipeline doesn't have a schedule to run on, and the linked job gets created when the pipeline is created.
    """
