# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'GoogleCloudDiscoveryengineV1alphaConversationContextResponse',
    'GoogleCloudDiscoveryengineV1alphaConversationMessageResponse',
    'GoogleCloudDiscoveryengineV1alphaDocumentContentResponse',
    'GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigAgentCreationConfigResponse',
    'GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigResponse',
    'GoogleCloudDiscoveryengineV1alphaEngineChatEngineMetadataResponse',
    'GoogleCloudDiscoveryengineV1alphaEngineCommonConfigResponse',
    'GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigOptimizationObjectiveConfigResponse',
    'GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigResponse',
    'GoogleCloudDiscoveryengineV1alphaEngineRecommendationMetadataResponse',
    'GoogleCloudDiscoveryengineV1alphaEngineSearchEngineConfigResponse',
    'GoogleCloudDiscoveryengineV1alphaEngineSimilarDocumentsEngineConfigResponse',
    'GoogleCloudDiscoveryengineV1alphaFieldConfigResponse',
    'GoogleCloudDiscoveryengineV1alphaReplyReferenceResponse',
    'GoogleCloudDiscoveryengineV1alphaReplyResponse',
    'GoogleCloudDiscoveryengineV1alphaSearchResponseSummaryResponse',
    'GoogleCloudDiscoveryengineV1alphaSearchResponseSummarySafetyAttributesResponse',
    'GoogleCloudDiscoveryengineV1alphaTextInputResponse',
]

@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaConversationContextResponse(dict):
    """
    Defines context of the conversation
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "activeDocument":
            suggest = "active_document"
        elif key == "contextDocuments":
            suggest = "context_documents"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaConversationContextResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaConversationContextResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaConversationContextResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 active_document: str,
                 context_documents: Sequence[str]):
        """
        Defines context of the conversation
        :param str active_document: The current active document the user opened. It contains the document resource reference.
        :param Sequence[str] context_documents: The current list of documents the user is seeing. It contains the document resource references.
        """
        pulumi.set(__self__, "active_document", active_document)
        pulumi.set(__self__, "context_documents", context_documents)

    @property
    @pulumi.getter(name="activeDocument")
    def active_document(self) -> str:
        """
        The current active document the user opened. It contains the document resource reference.
        """
        return pulumi.get(self, "active_document")

    @property
    @pulumi.getter(name="contextDocuments")
    def context_documents(self) -> Sequence[str]:
        """
        The current list of documents the user is seeing. It contains the document resource references.
        """
        return pulumi.get(self, "context_documents")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaConversationMessageResponse(dict):
    """
    Defines a conversation message.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createTime":
            suggest = "create_time"
        elif key == "userInput":
            suggest = "user_input"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaConversationMessageResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaConversationMessageResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaConversationMessageResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 create_time: str,
                 reply: 'outputs.GoogleCloudDiscoveryengineV1alphaReplyResponse',
                 user_input: 'outputs.GoogleCloudDiscoveryengineV1alphaTextInputResponse'):
        """
        Defines a conversation message.
        :param str create_time: Message creation timestamp.
        :param 'GoogleCloudDiscoveryengineV1alphaReplyResponse' reply: Search reply.
        :param 'GoogleCloudDiscoveryengineV1alphaTextInputResponse' user_input: User text input.
        """
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "reply", reply)
        pulumi.set(__self__, "user_input", user_input)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        Message creation timestamp.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def reply(self) -> 'outputs.GoogleCloudDiscoveryengineV1alphaReplyResponse':
        """
        Search reply.
        """
        return pulumi.get(self, "reply")

    @property
    @pulumi.getter(name="userInput")
    def user_input(self) -> 'outputs.GoogleCloudDiscoveryengineV1alphaTextInputResponse':
        """
        User text input.
        """
        return pulumi.get(self, "user_input")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaDocumentContentResponse(dict):
    """
    Unstructured data linked to this document.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "mimeType":
            suggest = "mime_type"
        elif key == "rawBytes":
            suggest = "raw_bytes"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaDocumentContentResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaDocumentContentResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaDocumentContentResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 mime_type: str,
                 raw_bytes: str,
                 uri: str):
        """
        Unstructured data linked to this document.
        :param str mime_type: The MIME type of the content. Supported types: * `application/pdf` (PDF, only native PDFs are supported for now) * `text/html` (HTML) * `application/vnd.openxmlformats-officedocument.wordprocessingml.document` (DOCX) * `application/vnd.openxmlformats-officedocument.presentationml.presentation` (PPTX) * `text/plain` (TXT) See https://www.iana.org/assignments/media-types/media-types.xhtml.
        :param str raw_bytes: The content represented as a stream of bytes. The maximum length is 1,000,000 bytes (1 MB / ~0.95 MiB). Note: As with all `bytes` fields, this field is represented as pure binary in Protocol Buffers and base64-encoded string in JSON. For example, `abc123!?$*&()'-=@~` should be represented as `YWJjMTIzIT8kKiYoKSctPUB+` in JSON. See https://developers.google.com/protocol-buffers/docs/proto3#json.
        :param str uri: The URI of the content. Only Cloud Storage URIs (e.g. `gs://bucket-name/path/to/file`) are supported. The maximum file size is 100 MB.
        """
        pulumi.set(__self__, "mime_type", mime_type)
        pulumi.set(__self__, "raw_bytes", raw_bytes)
        pulumi.set(__self__, "uri", uri)

    @property
    @pulumi.getter(name="mimeType")
    def mime_type(self) -> str:
        """
        The MIME type of the content. Supported types: * `application/pdf` (PDF, only native PDFs are supported for now) * `text/html` (HTML) * `application/vnd.openxmlformats-officedocument.wordprocessingml.document` (DOCX) * `application/vnd.openxmlformats-officedocument.presentationml.presentation` (PPTX) * `text/plain` (TXT) See https://www.iana.org/assignments/media-types/media-types.xhtml.
        """
        return pulumi.get(self, "mime_type")

    @property
    @pulumi.getter(name="rawBytes")
    def raw_bytes(self) -> str:
        """
        The content represented as a stream of bytes. The maximum length is 1,000,000 bytes (1 MB / ~0.95 MiB). Note: As with all `bytes` fields, this field is represented as pure binary in Protocol Buffers and base64-encoded string in JSON. For example, `abc123!?$*&()'-=@~` should be represented as `YWJjMTIzIT8kKiYoKSctPUB+` in JSON. See https://developers.google.com/protocol-buffers/docs/proto3#json.
        """
        return pulumi.get(self, "raw_bytes")

    @property
    @pulumi.getter
    def uri(self) -> str:
        """
        The URI of the content. Only Cloud Storage URIs (e.g. `gs://bucket-name/path/to/file`) are supported. The maximum file size is 100 MB.
        """
        return pulumi.get(self, "uri")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigAgentCreationConfigResponse(dict):
    """
    Configurations for generating a Dialogflow agent. Note that these configurations are one-time consumed by and passed to Dialogflow service. It means they cannot be retrieved using EngineService.GetEngine or EngineService.ListEngines API after engine creation.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "defaultLanguageCode":
            suggest = "default_language_code"
        elif key == "timeZone":
            suggest = "time_zone"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigAgentCreationConfigResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigAgentCreationConfigResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigAgentCreationConfigResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 business: str,
                 default_language_code: str,
                 time_zone: str):
        """
        Configurations for generating a Dialogflow agent. Note that these configurations are one-time consumed by and passed to Dialogflow service. It means they cannot be retrieved using EngineService.GetEngine or EngineService.ListEngines API after engine creation.
        :param str business: Name of the company, organization or other entity that the agent represents. Used for knowledge connector LLM prompt and for knowledge search.
        :param str default_language_code: The default language of the agent as a language tag. See [Language Support](https://cloud.google.com/dialogflow/docs/reference/language) for a list of the currently supported language codes.
        :param str time_zone: The time zone of the agent from the [time zone database](https://www.iana.org/time-zones), e.g., America/New_York, Europe/Paris.
        """
        pulumi.set(__self__, "business", business)
        pulumi.set(__self__, "default_language_code", default_language_code)
        pulumi.set(__self__, "time_zone", time_zone)

    @property
    @pulumi.getter
    def business(self) -> str:
        """
        Name of the company, organization or other entity that the agent represents. Used for knowledge connector LLM prompt and for knowledge search.
        """
        return pulumi.get(self, "business")

    @property
    @pulumi.getter(name="defaultLanguageCode")
    def default_language_code(self) -> str:
        """
        The default language of the agent as a language tag. See [Language Support](https://cloud.google.com/dialogflow/docs/reference/language) for a list of the currently supported language codes.
        """
        return pulumi.get(self, "default_language_code")

    @property
    @pulumi.getter(name="timeZone")
    def time_zone(self) -> str:
        """
        The time zone of the agent from the [time zone database](https://www.iana.org/time-zones), e.g., America/New_York, Europe/Paris.
        """
        return pulumi.get(self, "time_zone")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigResponse(dict):
    """
    Configurations for a Chat Engine.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "agentCreationConfig":
            suggest = "agent_creation_config"
        elif key == "dialogflowAgentToLink":
            suggest = "dialogflow_agent_to_link"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 agent_creation_config: 'outputs.GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigAgentCreationConfigResponse',
                 dialogflow_agent_to_link: str):
        """
        Configurations for a Chat Engine.
        :param 'GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigAgentCreationConfigResponse' agent_creation_config: The configurationt generate the Dialogflow agent that is associated to this Engine. Note that these configurations are one-time consumed by and passed to Dialogflow service. It means they cannot be retrieved using EngineService.GetEngine or EngineService.ListEngines API after engine creation.
        :param str dialogflow_agent_to_link: The resource name of an exist Dialogflow agent to link to this Chat Engine. Customers can either provide `agent_creation_config` to create agent or provide an agent name that links the agent with the Chat engine. Format: `projects//locations//agents/`. Note that the `dialogflow_agent_to_link` are one-time consumed by and passed to Dialogflow service. It means they cannot be retrieved using EngineService.GetEngine or EngineService.ListEngines API after engine creation. Please use chat_engine_metadata.dialogflow_agent for actual agent association after Engine is created.
        """
        pulumi.set(__self__, "agent_creation_config", agent_creation_config)
        pulumi.set(__self__, "dialogflow_agent_to_link", dialogflow_agent_to_link)

    @property
    @pulumi.getter(name="agentCreationConfig")
    def agent_creation_config(self) -> 'outputs.GoogleCloudDiscoveryengineV1alphaEngineChatEngineConfigAgentCreationConfigResponse':
        """
        The configurationt generate the Dialogflow agent that is associated to this Engine. Note that these configurations are one-time consumed by and passed to Dialogflow service. It means they cannot be retrieved using EngineService.GetEngine or EngineService.ListEngines API after engine creation.
        """
        return pulumi.get(self, "agent_creation_config")

    @property
    @pulumi.getter(name="dialogflowAgentToLink")
    def dialogflow_agent_to_link(self) -> str:
        """
        The resource name of an exist Dialogflow agent to link to this Chat Engine. Customers can either provide `agent_creation_config` to create agent or provide an agent name that links the agent with the Chat engine. Format: `projects//locations//agents/`. Note that the `dialogflow_agent_to_link` are one-time consumed by and passed to Dialogflow service. It means they cannot be retrieved using EngineService.GetEngine or EngineService.ListEngines API after engine creation. Please use chat_engine_metadata.dialogflow_agent for actual agent association after Engine is created.
        """
        return pulumi.get(self, "dialogflow_agent_to_link")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaEngineChatEngineMetadataResponse(dict):
    """
    Additional information of a Chat Engine. Fields in this message are output only.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dialogflowAgent":
            suggest = "dialogflow_agent"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaEngineChatEngineMetadataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineChatEngineMetadataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineChatEngineMetadataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dialogflow_agent: str):
        """
        Additional information of a Chat Engine. Fields in this message are output only.
        :param str dialogflow_agent: The resource name of a Dialogflow agent, that this Chat Engine refers to. Format: `projects//locations//agents/`.
        """
        pulumi.set(__self__, "dialogflow_agent", dialogflow_agent)

    @property
    @pulumi.getter(name="dialogflowAgent")
    def dialogflow_agent(self) -> str:
        """
        The resource name of a Dialogflow agent, that this Chat Engine refers to. Format: `projects//locations//agents/`.
        """
        return pulumi.get(self, "dialogflow_agent")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaEngineCommonConfigResponse(dict):
    """
    Common configurations for an Engine.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "companyName":
            suggest = "company_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaEngineCommonConfigResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineCommonConfigResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineCommonConfigResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 company_name: str):
        """
        Common configurations for an Engine.
        :param str company_name: The name of the company, business or entity that is associated with the engine. Setting this may help improve LLM related features.
        """
        pulumi.set(__self__, "company_name", company_name)

    @property
    @pulumi.getter(name="companyName")
    def company_name(self) -> str:
        """
        The name of the company, business or entity that is associated with the engine. Setting this may help improve LLM related features.
        """
        return pulumi.get(self, "company_name")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigOptimizationObjectiveConfigResponse(dict):
    """
    Custom threshold for `cvr` optimization_objective.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "targetField":
            suggest = "target_field"
        elif key == "targetFieldValueFloat":
            suggest = "target_field_value_float"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigOptimizationObjectiveConfigResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigOptimizationObjectiveConfigResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigOptimizationObjectiveConfigResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 target_field: str,
                 target_field_value_float: float):
        """
        Custom threshold for `cvr` optimization_objective.
        :param str target_field: The name of the field to target. Currently supported values: `watch-percentage`, `watch-time`.
        :param float target_field_value_float: The threshold to be applied to the target (e.g., 0.5).
        """
        pulumi.set(__self__, "target_field", target_field)
        pulumi.set(__self__, "target_field_value_float", target_field_value_float)

    @property
    @pulumi.getter(name="targetField")
    def target_field(self) -> str:
        """
        The name of the field to target. Currently supported values: `watch-percentage`, `watch-time`.
        """
        return pulumi.get(self, "target_field")

    @property
    @pulumi.getter(name="targetFieldValueFloat")
    def target_field_value_float(self) -> float:
        """
        The threshold to be applied to the target (e.g., 0.5).
        """
        return pulumi.get(self, "target_field_value_float")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigResponse(dict):
    """
    Additional config specs for a Media Recommendation engine.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "optimizationObjective":
            suggest = "optimization_objective"
        elif key == "optimizationObjectiveConfig":
            suggest = "optimization_objective_config"
        elif key == "trainingState":
            suggest = "training_state"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 optimization_objective: str,
                 optimization_objective_config: 'outputs.GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigOptimizationObjectiveConfigResponse',
                 training_state: str,
                 type: str):
        """
        Additional config specs for a Media Recommendation engine.
        :param str optimization_objective: The optimization objective e.g. `cvr`. This field together with optimization_objective describe engine metadata to use to control engine training and serving. Currently supported values: `ctr`, `cvr`. If not specified, we choose default based on engine type. Default depends on type of recommendation: `recommended-for-you` => `ctr` `others-you-may-like` => `ctr`
        :param 'GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigOptimizationObjectiveConfigResponse' optimization_objective_config: Name and value of the custom threshold for cvr optimization_objective. For target_field `watch-time`, target_field_value must be an integer value indicating the media progress time in seconds between (0, 86400] (excludes 0, includes 86400) (e.g., 90). For target_field `watch-percentage`, the target_field_value must be a valid float value between (0, 1.0] (excludes 0, includes 1.0) (e.g., 0.5).
        :param str training_state: The training state that the engine is in (e.g. `TRAINING` or `PAUSED`). Since part of the cost of running the service is frequency of training - this can be used to determine when to train engine in order to control cost. If not specified: the default value for `CreateEngine` method is `TRAINING`. The default value for `UpdateEngine` method is to keep the state the same as before.
        :param str type: The type of engine e.g. `recommended-for-you`. This field together with optimization_objective describe engine metadata to use to control engine training and serving. Currently supported values: `recommended-for-you`, `others-you-may-like`, `more-like-this`, `most-popular-items`.
        """
        pulumi.set(__self__, "optimization_objective", optimization_objective)
        pulumi.set(__self__, "optimization_objective_config", optimization_objective_config)
        pulumi.set(__self__, "training_state", training_state)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="optimizationObjective")
    def optimization_objective(self) -> str:
        """
        The optimization objective e.g. `cvr`. This field together with optimization_objective describe engine metadata to use to control engine training and serving. Currently supported values: `ctr`, `cvr`. If not specified, we choose default based on engine type. Default depends on type of recommendation: `recommended-for-you` => `ctr` `others-you-may-like` => `ctr`
        """
        return pulumi.get(self, "optimization_objective")

    @property
    @pulumi.getter(name="optimizationObjectiveConfig")
    def optimization_objective_config(self) -> 'outputs.GoogleCloudDiscoveryengineV1alphaEngineMediaRecommendationEngineConfigOptimizationObjectiveConfigResponse':
        """
        Name and value of the custom threshold for cvr optimization_objective. For target_field `watch-time`, target_field_value must be an integer value indicating the media progress time in seconds between (0, 86400] (excludes 0, includes 86400) (e.g., 90). For target_field `watch-percentage`, the target_field_value must be a valid float value between (0, 1.0] (excludes 0, includes 1.0) (e.g., 0.5).
        """
        return pulumi.get(self, "optimization_objective_config")

    @property
    @pulumi.getter(name="trainingState")
    def training_state(self) -> str:
        """
        The training state that the engine is in (e.g. `TRAINING` or `PAUSED`). Since part of the cost of running the service is frequency of training - this can be used to determine when to train engine in order to control cost. If not specified: the default value for `CreateEngine` method is `TRAINING`. The default value for `UpdateEngine` method is to keep the state the same as before.
        """
        return pulumi.get(self, "training_state")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of engine e.g. `recommended-for-you`. This field together with optimization_objective describe engine metadata to use to control engine training and serving. Currently supported values: `recommended-for-you`, `others-you-may-like`, `more-like-this`, `most-popular-items`.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaEngineRecommendationMetadataResponse(dict):
    """
    Additional information of a recommendation engine.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dataState":
            suggest = "data_state"
        elif key == "lastTuneTime":
            suggest = "last_tune_time"
        elif key == "servingState":
            suggest = "serving_state"
        elif key == "tuningOperation":
            suggest = "tuning_operation"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaEngineRecommendationMetadataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineRecommendationMetadataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineRecommendationMetadataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 data_state: str,
                 last_tune_time: str,
                 serving_state: str,
                 tuning_operation: str):
        """
        Additional information of a recommendation engine.
        :param str data_state: The state of data requirements for this engine: `DATA_OK` and `DATA_ERROR`. Engine cannot be trained if the data is in `DATA_ERROR` state. Engine can have `DATA_ERROR` state even if serving state is `ACTIVE`: engines were trained successfully before, but cannot be refreshed because the underlying engine no longer has sufficient data for training.
        :param str last_tune_time: The timestamp when the latest successful tune finished. Only applicable on Media Recommendation engines.
        :param str serving_state: The serving state of the engine: `ACTIVE`, `NOT_ACTIVE`.
        :param str tuning_operation: The latest tune operation id associated with the engine. Only applicable on Media Recommendation engines. If present, this operation id can be used to determine if there is an ongoing tune for this engine. To check the operation status, send the GetOperation request with this operation id in the engine resource format. If no tuning has happened for this engine, the string is empty.
        """
        pulumi.set(__self__, "data_state", data_state)
        pulumi.set(__self__, "last_tune_time", last_tune_time)
        pulumi.set(__self__, "serving_state", serving_state)
        pulumi.set(__self__, "tuning_operation", tuning_operation)

    @property
    @pulumi.getter(name="dataState")
    def data_state(self) -> str:
        """
        The state of data requirements for this engine: `DATA_OK` and `DATA_ERROR`. Engine cannot be trained if the data is in `DATA_ERROR` state. Engine can have `DATA_ERROR` state even if serving state is `ACTIVE`: engines were trained successfully before, but cannot be refreshed because the underlying engine no longer has sufficient data for training.
        """
        return pulumi.get(self, "data_state")

    @property
    @pulumi.getter(name="lastTuneTime")
    def last_tune_time(self) -> str:
        """
        The timestamp when the latest successful tune finished. Only applicable on Media Recommendation engines.
        """
        return pulumi.get(self, "last_tune_time")

    @property
    @pulumi.getter(name="servingState")
    def serving_state(self) -> str:
        """
        The serving state of the engine: `ACTIVE`, `NOT_ACTIVE`.
        """
        return pulumi.get(self, "serving_state")

    @property
    @pulumi.getter(name="tuningOperation")
    def tuning_operation(self) -> str:
        """
        The latest tune operation id associated with the engine. Only applicable on Media Recommendation engines. If present, this operation id can be used to determine if there is an ongoing tune for this engine. To check the operation status, send the GetOperation request with this operation id in the engine resource format. If no tuning has happened for this engine, the string is empty.
        """
        return pulumi.get(self, "tuning_operation")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaEngineSearchEngineConfigResponse(dict):
    """
    Configurations for a Search Engine.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "searchAddOns":
            suggest = "search_add_ons"
        elif key == "searchTier":
            suggest = "search_tier"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaEngineSearchEngineConfigResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineSearchEngineConfigResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaEngineSearchEngineConfigResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 search_add_ons: Sequence[str],
                 search_tier: str):
        """
        Configurations for a Search Engine.
        :param Sequence[str] search_add_ons: The add-on that this search engine enables.
        :param str search_tier: The search feature tier of this engine. Different tiers might have different pricing. To learn more, please check the pricing documentation. Defaults to SearchTier.SEARCH_TIER_STANDARD if not specified.
        """
        pulumi.set(__self__, "search_add_ons", search_add_ons)
        pulumi.set(__self__, "search_tier", search_tier)

    @property
    @pulumi.getter(name="searchAddOns")
    def search_add_ons(self) -> Sequence[str]:
        """
        The add-on that this search engine enables.
        """
        return pulumi.get(self, "search_add_ons")

    @property
    @pulumi.getter(name="searchTier")
    def search_tier(self) -> str:
        """
        The search feature tier of this engine. Different tiers might have different pricing. To learn more, please check the pricing documentation. Defaults to SearchTier.SEARCH_TIER_STANDARD if not specified.
        """
        return pulumi.get(self, "search_tier")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaEngineSimilarDocumentsEngineConfigResponse(dict):
    """
    Additional config specs for a `similar-items` engine.
    """
    def __init__(__self__):
        """
        Additional config specs for a `similar-items` engine.
        """
        pass


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaFieldConfigResponse(dict):
    """
    Configurations for fields of a schema. For example, configuring a field is indexable, or searchable.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "completableOption":
            suggest = "completable_option"
        elif key == "dynamicFacetableOption":
            suggest = "dynamic_facetable_option"
        elif key == "fieldPath":
            suggest = "field_path"
        elif key == "fieldType":
            suggest = "field_type"
        elif key == "indexableOption":
            suggest = "indexable_option"
        elif key == "keyPropertyType":
            suggest = "key_property_type"
        elif key == "recsFilterableOption":
            suggest = "recs_filterable_option"
        elif key == "retrievableOption":
            suggest = "retrievable_option"
        elif key == "searchableOption":
            suggest = "searchable_option"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaFieldConfigResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaFieldConfigResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaFieldConfigResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 completable_option: str,
                 dynamic_facetable_option: str,
                 field_path: str,
                 field_type: str,
                 indexable_option: str,
                 key_property_type: str,
                 recs_filterable_option: str,
                 retrievable_option: str,
                 searchable_option: str):
        """
        Configurations for fields of a schema. For example, configuring a field is indexable, or searchable.
        :param str completable_option: If completable_option is COMPLETABLE_ENABLED, field values are directly used and returned as suggestions for Autocomplete in CompletionService.CompleteQuery. If completable_option is unset, the server behavior defaults to COMPLETABLE_DISABLED for fields that support setting completable options, which are just `string` fields. For those fields that do not support setting completable options, the server will skip completable option setting, and setting completable_option for those fields will throw `INVALID_ARGUMENT` error.
        :param str dynamic_facetable_option: If dynamic_facetable_option is DYNAMIC_FACETABLE_ENABLED, field values are available for dynamic facet. Could only be DYNAMIC_FACETABLE_DISABLED if FieldConfig.indexable_option is INDEXABLE_DISABLED. Otherwise, an `INVALID_ARGUMENT` error will be returned. If dynamic_facetable_option is unset, the server behavior defaults to DYNAMIC_FACETABLE_DISABLED for fields that support setting dynamic facetable options. For those fields that do not support setting dynamic facetable options, such as `object` and `boolean`, the server will skip dynamic facetable option setting, and setting dynamic_facetable_option for those fields will throw `INVALID_ARGUMENT` error.
        :param str field_path: Field path of the schema field. For example: `title`, `description`, `release_info.release_year`.
        :param str field_type: Raw type of the field.
        :param str indexable_option: If indexable_option is INDEXABLE_ENABLED, field values are indexed so that it can be filtered or faceted in SearchService.Search. If indexable_option is unset, the server behavior defaults to INDEXABLE_DISABLED for fields that support setting indexable options. For those fields that do not support setting indexable options, such as `object` and `boolean` and key properties, the server will skip indexable_option setting, and setting indexable_option for those fields will throw `INVALID_ARGUMENT` error.
        :param str key_property_type: Type of the key property that this field is mapped to. Empty string if this is not annotated as mapped to a key property. Example types are `title`, `description`. Full list is defined by `keyPropertyMapping` in the schema field annotation. If the schema field has a `KeyPropertyMapping` annotation, `indexable_option` and `searchable_option` of this field cannot be modified.
        :param str recs_filterable_option: If recs_filterable_option is FILTERABLE_ENABLED, field values are filterable by filter expression in RecommendationService.Recommend. If FILTERABLE_ENABLED but the field type is numerical, field values are not filterable by text queries in RecommendationService.Recommend. Only textual fields are supported. If recs_filterable_option is unset, the default setting is FILTERABLE_DISABLED for fields that support setting filterable options. When a field set to [FILTERABLE_DISABLED] is filtered, a warning is generated and an empty result is returned.
        :param str retrievable_option: If retrievable_option is RETRIEVABLE_ENABLED, field values are included in the search results. If retrievable_option is unset, the server behavior defaults to RETRIEVABLE_DISABLED for fields that support setting retrievable options. For those fields that do not support setting retrievable options, such as `object` and `boolean`, the server will skip retrievable option setting, and setting retrievable_option for those fields will throw `INVALID_ARGUMENT` error.
        :param str searchable_option: If searchable_option is SEARCHABLE_ENABLED, field values are searchable by text queries in SearchService.Search. If SEARCHABLE_ENABLED but field type is numerical, field values will not be searchable by text queries in SearchService.Search, as there are no text values associated to numerical fields. If searchable_option is unset, the server behavior defaults to SEARCHABLE_DISABLED for fields that support setting searchable options. Only `string` fields that have no key property mapping support setting searchable_option. For those fields that do not support setting searchable options, the server will skip searchable option setting, and setting searchable_option for those fields will throw `INVALID_ARGUMENT` error.
        """
        pulumi.set(__self__, "completable_option", completable_option)
        pulumi.set(__self__, "dynamic_facetable_option", dynamic_facetable_option)
        pulumi.set(__self__, "field_path", field_path)
        pulumi.set(__self__, "field_type", field_type)
        pulumi.set(__self__, "indexable_option", indexable_option)
        pulumi.set(__self__, "key_property_type", key_property_type)
        pulumi.set(__self__, "recs_filterable_option", recs_filterable_option)
        pulumi.set(__self__, "retrievable_option", retrievable_option)
        pulumi.set(__self__, "searchable_option", searchable_option)

    @property
    @pulumi.getter(name="completableOption")
    def completable_option(self) -> str:
        """
        If completable_option is COMPLETABLE_ENABLED, field values are directly used and returned as suggestions for Autocomplete in CompletionService.CompleteQuery. If completable_option is unset, the server behavior defaults to COMPLETABLE_DISABLED for fields that support setting completable options, which are just `string` fields. For those fields that do not support setting completable options, the server will skip completable option setting, and setting completable_option for those fields will throw `INVALID_ARGUMENT` error.
        """
        return pulumi.get(self, "completable_option")

    @property
    @pulumi.getter(name="dynamicFacetableOption")
    def dynamic_facetable_option(self) -> str:
        """
        If dynamic_facetable_option is DYNAMIC_FACETABLE_ENABLED, field values are available for dynamic facet. Could only be DYNAMIC_FACETABLE_DISABLED if FieldConfig.indexable_option is INDEXABLE_DISABLED. Otherwise, an `INVALID_ARGUMENT` error will be returned. If dynamic_facetable_option is unset, the server behavior defaults to DYNAMIC_FACETABLE_DISABLED for fields that support setting dynamic facetable options. For those fields that do not support setting dynamic facetable options, such as `object` and `boolean`, the server will skip dynamic facetable option setting, and setting dynamic_facetable_option for those fields will throw `INVALID_ARGUMENT` error.
        """
        return pulumi.get(self, "dynamic_facetable_option")

    @property
    @pulumi.getter(name="fieldPath")
    def field_path(self) -> str:
        """
        Field path of the schema field. For example: `title`, `description`, `release_info.release_year`.
        """
        return pulumi.get(self, "field_path")

    @property
    @pulumi.getter(name="fieldType")
    def field_type(self) -> str:
        """
        Raw type of the field.
        """
        return pulumi.get(self, "field_type")

    @property
    @pulumi.getter(name="indexableOption")
    def indexable_option(self) -> str:
        """
        If indexable_option is INDEXABLE_ENABLED, field values are indexed so that it can be filtered or faceted in SearchService.Search. If indexable_option is unset, the server behavior defaults to INDEXABLE_DISABLED for fields that support setting indexable options. For those fields that do not support setting indexable options, such as `object` and `boolean` and key properties, the server will skip indexable_option setting, and setting indexable_option for those fields will throw `INVALID_ARGUMENT` error.
        """
        return pulumi.get(self, "indexable_option")

    @property
    @pulumi.getter(name="keyPropertyType")
    def key_property_type(self) -> str:
        """
        Type of the key property that this field is mapped to. Empty string if this is not annotated as mapped to a key property. Example types are `title`, `description`. Full list is defined by `keyPropertyMapping` in the schema field annotation. If the schema field has a `KeyPropertyMapping` annotation, `indexable_option` and `searchable_option` of this field cannot be modified.
        """
        return pulumi.get(self, "key_property_type")

    @property
    @pulumi.getter(name="recsFilterableOption")
    def recs_filterable_option(self) -> str:
        """
        If recs_filterable_option is FILTERABLE_ENABLED, field values are filterable by filter expression in RecommendationService.Recommend. If FILTERABLE_ENABLED but the field type is numerical, field values are not filterable by text queries in RecommendationService.Recommend. Only textual fields are supported. If recs_filterable_option is unset, the default setting is FILTERABLE_DISABLED for fields that support setting filterable options. When a field set to [FILTERABLE_DISABLED] is filtered, a warning is generated and an empty result is returned.
        """
        return pulumi.get(self, "recs_filterable_option")

    @property
    @pulumi.getter(name="retrievableOption")
    def retrievable_option(self) -> str:
        """
        If retrievable_option is RETRIEVABLE_ENABLED, field values are included in the search results. If retrievable_option is unset, the server behavior defaults to RETRIEVABLE_DISABLED for fields that support setting retrievable options. For those fields that do not support setting retrievable options, such as `object` and `boolean`, the server will skip retrievable option setting, and setting retrievable_option for those fields will throw `INVALID_ARGUMENT` error.
        """
        return pulumi.get(self, "retrievable_option")

    @property
    @pulumi.getter(name="searchableOption")
    def searchable_option(self) -> str:
        """
        If searchable_option is SEARCHABLE_ENABLED, field values are searchable by text queries in SearchService.Search. If SEARCHABLE_ENABLED but field type is numerical, field values will not be searchable by text queries in SearchService.Search, as there are no text values associated to numerical fields. If searchable_option is unset, the server behavior defaults to SEARCHABLE_DISABLED for fields that support setting searchable options. Only `string` fields that have no key property mapping support setting searchable_option. For those fields that do not support setting searchable options, the server will skip searchable option setting, and setting searchable_option for those fields will throw `INVALID_ARGUMENT` error.
        """
        return pulumi.get(self, "searchable_option")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaReplyReferenceResponse(dict):
    """
    Defines reference in reply.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "anchorText":
            suggest = "anchor_text"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaReplyReferenceResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaReplyReferenceResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaReplyReferenceResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 anchor_text: str,
                 end: int,
                 start: int,
                 uri: str):
        """
        Defines reference in reply.
        :param str anchor_text: Anchor text.
        :param int end: Anchor text end index.
        :param int start: Anchor text start index.
        :param str uri: URI link reference.
        """
        pulumi.set(__self__, "anchor_text", anchor_text)
        pulumi.set(__self__, "end", end)
        pulumi.set(__self__, "start", start)
        pulumi.set(__self__, "uri", uri)

    @property
    @pulumi.getter(name="anchorText")
    def anchor_text(self) -> str:
        """
        Anchor text.
        """
        return pulumi.get(self, "anchor_text")

    @property
    @pulumi.getter
    def end(self) -> int:
        """
        Anchor text end index.
        """
        return pulumi.get(self, "end")

    @property
    @pulumi.getter
    def start(self) -> int:
        """
        Anchor text start index.
        """
        return pulumi.get(self, "start")

    @property
    @pulumi.getter
    def uri(self) -> str:
        """
        URI link reference.
        """
        return pulumi.get(self, "uri")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaReplyResponse(dict):
    """
    Defines a reply message to user.
    """
    def __init__(__self__, *,
                 references: Sequence['outputs.GoogleCloudDiscoveryengineV1alphaReplyReferenceResponse'],
                 reply: str,
                 summary: 'outputs.GoogleCloudDiscoveryengineV1alphaSearchResponseSummaryResponse'):
        """
        Defines a reply message to user.
        :param Sequence['GoogleCloudDiscoveryengineV1alphaReplyReferenceResponse'] references: References in the reply.
        :param str reply: DEPRECATED: use `summary` instead. Text reply.
        :param 'GoogleCloudDiscoveryengineV1alphaSearchResponseSummaryResponse' summary: Summary based on search results.
        """
        pulumi.set(__self__, "references", references)
        pulumi.set(__self__, "reply", reply)
        pulumi.set(__self__, "summary", summary)

    @property
    @pulumi.getter
    def references(self) -> Sequence['outputs.GoogleCloudDiscoveryengineV1alphaReplyReferenceResponse']:
        """
        References in the reply.
        """
        return pulumi.get(self, "references")

    @property
    @pulumi.getter
    @_utilities.deprecated("""DEPRECATED: use `summary` instead. Text reply.""")
    def reply(self) -> str:
        """
        DEPRECATED: use `summary` instead. Text reply.
        """
        return pulumi.get(self, "reply")

    @property
    @pulumi.getter
    def summary(self) -> 'outputs.GoogleCloudDiscoveryengineV1alphaSearchResponseSummaryResponse':
        """
        Summary based on search results.
        """
        return pulumi.get(self, "summary")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaSearchResponseSummaryResponse(dict):
    """
    Summary of the top N search result specified by the summary spec.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "safetyAttributes":
            suggest = "safety_attributes"
        elif key == "summarySkippedReasons":
            suggest = "summary_skipped_reasons"
        elif key == "summaryText":
            suggest = "summary_text"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GoogleCloudDiscoveryengineV1alphaSearchResponseSummaryResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GoogleCloudDiscoveryengineV1alphaSearchResponseSummaryResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GoogleCloudDiscoveryengineV1alphaSearchResponseSummaryResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 safety_attributes: 'outputs.GoogleCloudDiscoveryengineV1alphaSearchResponseSummarySafetyAttributesResponse',
                 summary_skipped_reasons: Sequence[str],
                 summary_text: str):
        """
        Summary of the top N search result specified by the summary spec.
        :param 'GoogleCloudDiscoveryengineV1alphaSearchResponseSummarySafetyAttributesResponse' safety_attributes: A collection of Safety Attribute categories and their associated confidence scores.
        :param Sequence[str] summary_skipped_reasons: Additional summary-skipped reasons. This provides the reason for ignored cases. If nothing is skipped, this field is not set.
        :param str summary_text: The summary content.
        """
        pulumi.set(__self__, "safety_attributes", safety_attributes)
        pulumi.set(__self__, "summary_skipped_reasons", summary_skipped_reasons)
        pulumi.set(__self__, "summary_text", summary_text)

    @property
    @pulumi.getter(name="safetyAttributes")
    def safety_attributes(self) -> 'outputs.GoogleCloudDiscoveryengineV1alphaSearchResponseSummarySafetyAttributesResponse':
        """
        A collection of Safety Attribute categories and their associated confidence scores.
        """
        return pulumi.get(self, "safety_attributes")

    @property
    @pulumi.getter(name="summarySkippedReasons")
    def summary_skipped_reasons(self) -> Sequence[str]:
        """
        Additional summary-skipped reasons. This provides the reason for ignored cases. If nothing is skipped, this field is not set.
        """
        return pulumi.get(self, "summary_skipped_reasons")

    @property
    @pulumi.getter(name="summaryText")
    def summary_text(self) -> str:
        """
        The summary content.
        """
        return pulumi.get(self, "summary_text")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaSearchResponseSummarySafetyAttributesResponse(dict):
    """
    Safety Attribute categories and their associated confidence scores.
    """
    def __init__(__self__, *,
                 categories: Sequence[str],
                 scores: Sequence[float]):
        """
        Safety Attribute categories and their associated confidence scores.
        :param Sequence[str] categories: The display names of Safety Attribute categories associated with the generated content. Order matches the Scores.
        :param Sequence[float] scores: The confidence scores of the each category, higher value means higher confidence. Order matches the Categories.
        """
        pulumi.set(__self__, "categories", categories)
        pulumi.set(__self__, "scores", scores)

    @property
    @pulumi.getter
    def categories(self) -> Sequence[str]:
        """
        The display names of Safety Attribute categories associated with the generated content. Order matches the Scores.
        """
        return pulumi.get(self, "categories")

    @property
    @pulumi.getter
    def scores(self) -> Sequence[float]:
        """
        The confidence scores of the each category, higher value means higher confidence. Order matches the Categories.
        """
        return pulumi.get(self, "scores")


@pulumi.output_type
class GoogleCloudDiscoveryengineV1alphaTextInputResponse(dict):
    """
    Defines text input.
    """
    def __init__(__self__, *,
                 context: 'outputs.GoogleCloudDiscoveryengineV1alphaConversationContextResponse',
                 input: str):
        """
        Defines text input.
        :param 'GoogleCloudDiscoveryengineV1alphaConversationContextResponse' context: Conversation context of the input.
        :param str input: Text input.
        """
        pulumi.set(__self__, "context", context)
        pulumi.set(__self__, "input", input)

    @property
    @pulumi.getter
    def context(self) -> 'outputs.GoogleCloudDiscoveryengineV1alphaConversationContextResponse':
        """
        Conversation context of the input.
        """
        return pulumi.get(self, "context")

    @property
    @pulumi.getter
    def input(self) -> str:
        """
        Text input.
        """
        return pulumi.get(self, "input")


