# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'DnsKeySpecAlgorithm',
    'DnsKeySpecKeyType',
    'GoogleIamV1AuditLogConfigLogType',
    'ManagedZoneDnsSecConfigNonExistence',
    'ManagedZoneDnsSecConfigState',
    'ManagedZoneForwardingConfigNameServerTargetForwardingPath',
    'ManagedZoneVisibility',
    'PolicyAlternativeNameServerConfigTargetNameServerForwardingPath',
    'RRSetRoutingPolicyLoadBalancerTargetIpProtocol',
    'RRSetRoutingPolicyLoadBalancerTargetLoadBalancerType',
    'ResponsePolicyRuleBehavior',
]


class DnsKeySpecAlgorithm(str, Enum):
    """
    String mnemonic specifying the DNSSEC algorithm of this key.
    """
    RSASHA1 = "rsasha1"
    RSASHA256 = "rsasha256"
    RSASHA512 = "rsasha512"
    ECDSAP256SHA256 = "ecdsap256sha256"
    ECDSAP384SHA384 = "ecdsap384sha384"


class DnsKeySpecKeyType(str, Enum):
    """
    Specifies whether this is a key signing key (KSK) or a zone signing key (ZSK). Key signing keys have the Secure Entry Point flag set and, when active, are only used to sign resource record sets of type DNSKEY. Zone signing keys do not have the Secure Entry Point flag set and are used to sign all other types of resource record sets.
    """
    KEY_SIGNING = "keySigning"
    ZONE_SIGNING = "zoneSigning"


class GoogleIamV1AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """


class ManagedZoneDnsSecConfigNonExistence(str, Enum):
    """
    Specifies the mechanism for authenticated denial-of-existence responses. Can only be changed while the state is OFF.
    """
    NSEC = "nsec"
    NSEC3 = "nsec3"


class ManagedZoneDnsSecConfigState(str, Enum):
    """
    Specifies whether DNSSEC is enabled, and what mode it is in.
    """
    OFF = "off"
    """
    DNSSEC is disabled; the zone is not signed.
    """
    ON = "on"
    """
    DNSSEC is enabled; the zone is signed and fully managed.
    """
    TRANSFER = "transfer"
    """
    DNSSEC is enabled, but in a "transfer" mode.
    """


class ManagedZoneForwardingConfigNameServerTargetForwardingPath(str, Enum):
    """
    Forwarding path for this NameServerTarget. If unset or set to DEFAULT, Cloud DNS makes forwarding decisions based on IP address ranges; that is, RFC1918 addresses go to the VPC network, non-RFC1918 addresses go to the internet. When set to PRIVATE, Cloud DNS always sends queries through the VPC network for this target.
    """
    DEFAULT = "default"
    """
    Cloud DNS makes forwarding decisions based on address ranges; that is, RFC1918 addresses forward to the target through the VPC and non-RFC1918 addresses forward to the target through the internet
    """
    PRIVATE = "private"
    """
    Cloud DNS always forwards to this target through the VPC.
    """


class ManagedZoneVisibility(str, Enum):
    """
    The zone's visibility: public zones are exposed to the Internet, while private zones are visible only to Virtual Private Cloud resources.
    """
    PUBLIC = "public"
    PRIVATE = "private"


class PolicyAlternativeNameServerConfigTargetNameServerForwardingPath(str, Enum):
    """
    Forwarding path for this TargetNameServer. If unset or set to DEFAULT, Cloud DNS makes forwarding decisions based on address ranges; that is, RFC1918 addresses go to the VPC network, non-RFC1918 addresses go to the internet. When set to PRIVATE, Cloud DNS always sends queries through the VPC network for this target.
    """
    DEFAULT = "default"
    """
    Cloud DNS makes forwarding decision based on IP address ranges; that is, RFC1918 addresses forward to the target through the VPC and non-RFC1918 addresses forward to the target through the internet
    """
    PRIVATE = "private"
    """
    Cloud DNS always forwards to this target through the VPC.
    """


class RRSetRoutingPolicyLoadBalancerTargetIpProtocol(str, Enum):
    """
    The protocol of the load balancer to health check.
    """
    UNDEFINED = "undefined"
    TCP = "tcp"
    UDP = "udp"


class RRSetRoutingPolicyLoadBalancerTargetLoadBalancerType(str, Enum):
    """
    The type of load balancer specified by this target. This value must match the configuration of the load balancer located at the LoadBalancerTarget's IP address, port, and region. Use the following: - *regionalL4ilb*: for a regional internal passthrough Network Load Balancer. - *regionalL7ilb*: for a regional internal Application Load Balancer. - *globalL7ilb*: for a global internal Application Load Balancer. 
    """
    NONE = "none"
    GLOBAL_L7ILB = "globalL7ilb"
    REGIONAL_L4ILB = "regionalL4ilb"
    REGIONAL_L7ILB = "regionalL7ilb"


class ResponsePolicyRuleBehavior(str, Enum):
    """
    Answer this query with a behavior rather than DNS data.
    """
    BEHAVIOR_UNSPECIFIED = "behaviorUnspecified"
    BYPASS_RESPONSE_POLICY = "bypassResponsePolicy"
    """
    Skip a less-specific ResponsePolicyRule and continue normal query logic. This can be used with a less-specific wildcard selector to exempt a subset of the wildcard ResponsePolicyRule from the ResponsePolicy behavior and query the public Internet instead. For instance, if these rules exist: *.example.com -> LocalData 1.2.3.4 foo.example.com -> Behavior 'bypassResponsePolicy' Then a query for 'foo.example.com' skips the wildcard. This additionally functions to facilitate the allowlist feature. RPZs can be applied to multiple levels in the (eventually org, folder, project, network) hierarchy. If a rule is applied at a higher level of the hierarchy, adding a passthru rule at a lower level will supersede that, and a query from an affected vm to that domain will be exempt from the RPZ and proceed to normal resolution behavior.
    """
