# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'GetWorkforcePoolResult',
    'AwaitableGetWorkforcePoolResult',
    'get_workforce_pool',
    'get_workforce_pool_output',
]

@pulumi.output_type
class GetWorkforcePoolResult:
    def __init__(__self__, access_restrictions=None, description=None, disabled=None, display_name=None, expire_time=None, name=None, parent=None, session_duration=None, state=None):
        if access_restrictions and not isinstance(access_restrictions, dict):
            raise TypeError("Expected argument 'access_restrictions' to be a dict")
        pulumi.set(__self__, "access_restrictions", access_restrictions)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if disabled and not isinstance(disabled, bool):
            raise TypeError("Expected argument 'disabled' to be a bool")
        pulumi.set(__self__, "disabled", disabled)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if expire_time and not isinstance(expire_time, str):
            raise TypeError("Expected argument 'expire_time' to be a str")
        pulumi.set(__self__, "expire_time", expire_time)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if parent and not isinstance(parent, str):
            raise TypeError("Expected argument 'parent' to be a str")
        pulumi.set(__self__, "parent", parent)
        if session_duration and not isinstance(session_duration, str):
            raise TypeError("Expected argument 'session_duration' to be a str")
        pulumi.set(__self__, "session_duration", session_duration)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="accessRestrictions")
    def access_restrictions(self) -> 'outputs.AccessRestrictionsResponse':
        """
        Optional. Configure access restrictions on the workforce pool users. This is an optional field. If specified web sign-in can be restricted to given set of services or programmatic sign-in can be disabled for pool users.
        """
        return pulumi.get(self, "access_restrictions")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        A user-specified description of the pool. Cannot exceed 256 characters.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def disabled(self) -> bool:
        """
        Disables the workforce pool. You cannot use a disabled pool to exchange tokens, or use existing tokens to access resources. If the pool is re-enabled, existing tokens grant access again.
        """
        return pulumi.get(self, "disabled")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> str:
        """
        A user-specified display name of the pool in Google Cloud Console. Cannot exceed 32 characters.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="expireTime")
    def expire_time(self) -> str:
        """
        Time after which the workforce pool will be permanently purged and cannot be recovered.
        """
        return pulumi.get(self, "expire_time")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The resource name of the pool. Format: `locations/{location}/workforcePools/{workforce_pool_id}`
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def parent(self) -> str:
        """
        Immutable. The resource name of the parent. Format: `organizations/{org-id}`.
        """
        return pulumi.get(self, "parent")

    @property
    @pulumi.getter(name="sessionDuration")
    def session_duration(self) -> str:
        """
        Duration that the Google Cloud access tokens, console sign-in sessions, and `gcloud` sign-in sessions from this pool are valid. Must be greater than 15 minutes (900s) and less than 12 hours (43200s). If `session_duration` is not configured, minted credentials have a default duration of one hour (3600s). For SAML providers, the lifetime of the token is the minimum of the `session_duration` and the `SessionNotOnOrAfter` claim in the SAML assertion.
        """
        return pulumi.get(self, "session_duration")

    @property
    @pulumi.getter
    def state(self) -> str:
        """
        The state of the pool.
        """
        return pulumi.get(self, "state")


class AwaitableGetWorkforcePoolResult(GetWorkforcePoolResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWorkforcePoolResult(
            access_restrictions=self.access_restrictions,
            description=self.description,
            disabled=self.disabled,
            display_name=self.display_name,
            expire_time=self.expire_time,
            name=self.name,
            parent=self.parent,
            session_duration=self.session_duration,
            state=self.state)


def get_workforce_pool(location: Optional[str] = None,
                       workforce_pool_id: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWorkforcePoolResult:
    """
    Gets an individual WorkforcePool.
    """
    __args__ = dict()
    __args__['location'] = location
    __args__['workforcePoolId'] = workforce_pool_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('google-native:iam/v1:getWorkforcePool', __args__, opts=opts, typ=GetWorkforcePoolResult).value

    return AwaitableGetWorkforcePoolResult(
        access_restrictions=pulumi.get(__ret__, 'access_restrictions'),
        description=pulumi.get(__ret__, 'description'),
        disabled=pulumi.get(__ret__, 'disabled'),
        display_name=pulumi.get(__ret__, 'display_name'),
        expire_time=pulumi.get(__ret__, 'expire_time'),
        name=pulumi.get(__ret__, 'name'),
        parent=pulumi.get(__ret__, 'parent'),
        session_duration=pulumi.get(__ret__, 'session_duration'),
        state=pulumi.get(__ret__, 'state'))


@_utilities.lift_output_func(get_workforce_pool)
def get_workforce_pool_output(location: Optional[pulumi.Input[str]] = None,
                              workforce_pool_id: Optional[pulumi.Input[str]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetWorkforcePoolResult]:
    """
    Gets an individual WorkforcePool.
    """
    ...
