# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'GoogleCloudIdentitytoolkitAdminV2MultiFactorAuthConfigEnabledProvidersItem',
    'GoogleCloudIdentitytoolkitAdminV2MultiFactorAuthConfigState',
    'GoogleCloudIdentitytoolkitAdminV2PasswordPolicyConfigPasswordPolicyEnforcementState',
    'GoogleCloudIdentitytoolkitAdminV2ProviderConfigState',
    'GoogleCloudIdentitytoolkitAdminV2RecaptchaConfigEmailPasswordEnforcementState',
    'GoogleCloudIdentitytoolkitAdminV2RecaptchaManagedRuleAction',
    'GoogleIamV1AuditLogConfigLogType',
]


class GoogleCloudIdentitytoolkitAdminV2MultiFactorAuthConfigEnabledProvidersItem(str, Enum):
    PROVIDER_UNSPECIFIED = "PROVIDER_UNSPECIFIED"
    """
    Illegal Provider, should not be used
    """
    PHONE_SMS = "PHONE_SMS"
    """
    SMS is enabled as a second factor for this project.
    """


class GoogleCloudIdentitytoolkitAdminV2MultiFactorAuthConfigState(str, Enum):
    """
    Whether MultiFactor Authentication has been enabled for this project.
    """
    STATE_UNSPECIFIED = "STATE_UNSPECIFIED"
    """
    Illegal State, should not be used.
    """
    DISABLED = "DISABLED"
    """
    Multi-factor authentication cannot be used for this project
    """
    ENABLED = "ENABLED"
    """
    Multi-factor authentication can be used for this project
    """
    MANDATORY = "MANDATORY"
    """
    Multi-factor authentication is required for this project. Users from this project must authenticate with the second factor.
    """


class GoogleCloudIdentitytoolkitAdminV2PasswordPolicyConfigPasswordPolicyEnforcementState(str, Enum):
    """
    Which enforcement mode to use for the password policy.
    """
    PASSWORD_POLICY_ENFORCEMENT_STATE_UNSPECIFIED = "PASSWORD_POLICY_ENFORCEMENT_STATE_UNSPECIFIED"
    """
    Illegal State, should not be used.
    """
    OFF = "OFF"
    """
    Password Policy will not be used on the project.
    """
    ENFORCE = "ENFORCE"
    """
    Passwords non-compliant with the password policy will be rejected with an error thrown.
    """


class GoogleCloudIdentitytoolkitAdminV2ProviderConfigState(str, Enum):
    """
    Describes the state of the MultiFactor Authentication type.
    """
    MFA_STATE_UNSPECIFIED = "MFA_STATE_UNSPECIFIED"
    """
    Illegal State, should not be used.
    """
    DISABLED = "DISABLED"
    """
    Multi-factor authentication cannot be used for this project.
    """
    ENABLED = "ENABLED"
    """
    Multi-factor authentication can be used for this project.
    """
    MANDATORY = "MANDATORY"
    """
    Multi-factor authentication is required for this project. Users from this project must authenticate with the second factor.
    """


class GoogleCloudIdentitytoolkitAdminV2RecaptchaConfigEmailPasswordEnforcementState(str, Enum):
    """
    The reCAPTCHA config for email/password provider, containing the enforcement status. The email/password provider contains all related user flows protected by reCAPTCHA.
    """
    RECAPTCHA_PROVIDER_ENFORCEMENT_STATE_UNSPECIFIED = "RECAPTCHA_PROVIDER_ENFORCEMENT_STATE_UNSPECIFIED"
    """
    Enforcement state has not been set.
    """
    OFF = "OFF"
    """
    Unenforced.
    """
    AUDIT = "AUDIT"
    """
    reCAPTCHA assessment is created, result is not used to enforce.
    """
    ENFORCE = "ENFORCE"
    """
    reCAPTCHA assessment is created, result is used to enforce.
    """


class GoogleCloudIdentitytoolkitAdminV2RecaptchaManagedRuleAction(str, Enum):
    """
    The action taken if the reCAPTCHA score of a request is within the interval [start_score, end_score].
    """
    RECAPTCHA_ACTION_UNSPECIFIED = "RECAPTCHA_ACTION_UNSPECIFIED"
    """
    The reCAPTCHA action is not specified.
    """
    BLOCK = "BLOCK"
    """
    The reCAPTCHA-protected request will be blocked.
    """


class GoogleIamV1AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """
