# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'BillingAccountSinkOutputVersionFormat',
    'FolderSinkOutputVersionFormat',
    'IndexConfigType',
    'LabelDescriptorValueType',
    'MetricDescriptorLaunchStage',
    'MetricDescriptorMetadataLaunchStage',
    'MetricDescriptorMetricKind',
    'MetricDescriptorValueType',
    'MetricVersion',
    'OrganizationSinkOutputVersionFormat',
    'SinkOutputVersionFormat',
]


class BillingAccountSinkOutputVersionFormat(str, Enum):
    """
    Deprecated. This field is unused.
    """
    VERSION_FORMAT_UNSPECIFIED = "VERSION_FORMAT_UNSPECIFIED"
    """
    An unspecified format version that will default to V2.
    """
    V2 = "V2"
    """
    LogEntry version 2 format.
    """
    V1 = "V1"
    """
    LogEntry version 1 format.
    """


class FolderSinkOutputVersionFormat(str, Enum):
    """
    Deprecated. This field is unused.
    """
    VERSION_FORMAT_UNSPECIFIED = "VERSION_FORMAT_UNSPECIFIED"
    """
    An unspecified format version that will default to V2.
    """
    V2 = "V2"
    """
    LogEntry version 2 format.
    """
    V1 = "V1"
    """
    LogEntry version 1 format.
    """


class IndexConfigType(str, Enum):
    """
    Required. The type of data in this index.
    """
    INDEX_TYPE_UNSPECIFIED = "INDEX_TYPE_UNSPECIFIED"
    """
    The index's type is unspecified.
    """
    INDEX_TYPE_STRING = "INDEX_TYPE_STRING"
    """
    The index is a string-type index.
    """
    INDEX_TYPE_INTEGER = "INDEX_TYPE_INTEGER"
    """
    The index is a integer-type index.
    """


class LabelDescriptorValueType(str, Enum):
    """
    The type of data that can be assigned to the label.
    """
    STRING = "STRING"
    """
    A variable-length string. This is the default.
    """
    BOOL = "BOOL"
    """
    Boolean; true or false.
    """
    INT64 = "INT64"
    """
    A 64-bit signed integer.
    """


class MetricDescriptorLaunchStage(str, Enum):
    """
    Optional. The launch stage of the metric definition.
    """
    LAUNCH_STAGE_UNSPECIFIED = "LAUNCH_STAGE_UNSPECIFIED"
    """
    Do not use this default value.
    """
    UNIMPLEMENTED = "UNIMPLEMENTED"
    """
    The feature is not yet implemented. Users can not use it.
    """
    PRELAUNCH = "PRELAUNCH"
    """
    Prelaunch features are hidden from users and are only visible internally.
    """
    EARLY_ACCESS = "EARLY_ACCESS"
    """
    Early Access features are limited to a closed group of testers. To use these features, you must sign up in advance and sign a Trusted Tester agreement (which includes confidentiality provisions). These features may be unstable, changed in backward-incompatible ways, and are not guaranteed to be released.
    """
    ALPHA = "ALPHA"
    """
    Alpha is a limited availability test for releases before they are cleared for widespread use. By Alpha, all significant design issues are resolved and we are in the process of verifying functionality. Alpha customers need to apply for access, agree to applicable terms, and have their projects allowlisted. Alpha releases don't have to be feature complete, no SLAs are provided, and there are no technical support obligations, but they will be far enough along that customers can actually use them in test environments or for limited-use tests -- just like they would in normal production cases.
    """
    BETA = "BETA"
    """
    Beta is the point at which we are ready to open a release for any customer to use. There are no SLA or technical support obligations in a Beta release. Products will be complete from a feature perspective, but may have some open outstanding issues. Beta releases are suitable for limited production use cases.
    """
    GA = "GA"
    """
    GA features are open to all developers and are considered stable and fully qualified for production use.
    """
    DEPRECATED = "DEPRECATED"
    """
    Deprecated features are scheduled to be shut down and removed. For more information, see the "Deprecation Policy" section of our Terms of Service (https://cloud.google.com/terms/) and the Google Cloud Platform Subject to the Deprecation Policy (https://cloud.google.com/terms/deprecation) documentation.
    """


class MetricDescriptorMetadataLaunchStage(str, Enum):
    """
    Deprecated. Must use the MetricDescriptor.launch_stage instead.
    """
    LAUNCH_STAGE_UNSPECIFIED = "LAUNCH_STAGE_UNSPECIFIED"
    """
    Do not use this default value.
    """
    UNIMPLEMENTED = "UNIMPLEMENTED"
    """
    The feature is not yet implemented. Users can not use it.
    """
    PRELAUNCH = "PRELAUNCH"
    """
    Prelaunch features are hidden from users and are only visible internally.
    """
    EARLY_ACCESS = "EARLY_ACCESS"
    """
    Early Access features are limited to a closed group of testers. To use these features, you must sign up in advance and sign a Trusted Tester agreement (which includes confidentiality provisions). These features may be unstable, changed in backward-incompatible ways, and are not guaranteed to be released.
    """
    ALPHA = "ALPHA"
    """
    Alpha is a limited availability test for releases before they are cleared for widespread use. By Alpha, all significant design issues are resolved and we are in the process of verifying functionality. Alpha customers need to apply for access, agree to applicable terms, and have their projects allowlisted. Alpha releases don't have to be feature complete, no SLAs are provided, and there are no technical support obligations, but they will be far enough along that customers can actually use them in test environments or for limited-use tests -- just like they would in normal production cases.
    """
    BETA = "BETA"
    """
    Beta is the point at which we are ready to open a release for any customer to use. There are no SLA or technical support obligations in a Beta release. Products will be complete from a feature perspective, but may have some open outstanding issues. Beta releases are suitable for limited production use cases.
    """
    GA = "GA"
    """
    GA features are open to all developers and are considered stable and fully qualified for production use.
    """
    DEPRECATED = "DEPRECATED"
    """
    Deprecated features are scheduled to be shut down and removed. For more information, see the "Deprecation Policy" section of our Terms of Service (https://cloud.google.com/terms/) and the Google Cloud Platform Subject to the Deprecation Policy (https://cloud.google.com/terms/deprecation) documentation.
    """


class MetricDescriptorMetricKind(str, Enum):
    """
    Whether the metric records instantaneous values, changes to a value, etc. Some combinations of metric_kind and value_type might not be supported.
    """
    METRIC_KIND_UNSPECIFIED = "METRIC_KIND_UNSPECIFIED"
    """
    Do not use this default value.
    """
    GAUGE = "GAUGE"
    """
    An instantaneous measurement of a value.
    """
    DELTA = "DELTA"
    """
    The change in a value during a time interval.
    """
    CUMULATIVE = "CUMULATIVE"
    """
    A value accumulated over a time interval. Cumulative measurements in a time series should have the same start time and increasing end times, until an event resets the cumulative value to zero and sets a new start time for the following points.
    """


class MetricDescriptorValueType(str, Enum):
    """
    Whether the measurement is an integer, a floating-point number, etc. Some combinations of metric_kind and value_type might not be supported.
    """
    VALUE_TYPE_UNSPECIFIED = "VALUE_TYPE_UNSPECIFIED"
    """
    Do not use this default value.
    """
    BOOL = "BOOL"
    """
    The value is a boolean. This value type can be used only if the metric kind is GAUGE.
    """
    INT64 = "INT64"
    """
    The value is a signed 64-bit integer.
    """
    DOUBLE = "DOUBLE"
    """
    The value is a double precision floating point number.
    """
    STRING = "STRING"
    """
    The value is a text string. This value type can be used only if the metric kind is GAUGE.
    """
    DISTRIBUTION = "DISTRIBUTION"
    """
    The value is a Distribution.
    """
    MONEY = "MONEY"
    """
    The value is money.
    """


class MetricVersion(str, Enum):
    """
    Deprecated. The API version that created or updated this metric. The v2 format is used by default and cannot be changed.
    """
    V2 = "V2"
    """
    Logging API v2.
    """
    V1 = "V1"
    """
    Logging API v1.
    """


class OrganizationSinkOutputVersionFormat(str, Enum):
    """
    Deprecated. This field is unused.
    """
    VERSION_FORMAT_UNSPECIFIED = "VERSION_FORMAT_UNSPECIFIED"
    """
    An unspecified format version that will default to V2.
    """
    V2 = "V2"
    """
    LogEntry version 2 format.
    """
    V1 = "V1"
    """
    LogEntry version 1 format.
    """


class SinkOutputVersionFormat(str, Enum):
    """
    Deprecated. This field is unused.
    """
    VERSION_FORMAT_UNSPECIFIED = "VERSION_FORMAT_UNSPECIFIED"
    """
    An unspecified format version that will default to V2.
    """
    V2 = "V2"
    """
    LogEntry version 2 format.
    """
    V1 = "V1"
    """
    LogEntry version 1 format.
    """
