# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AuditLogConfigLogType',
    'FilterProtocolVersion',
    'InternalRangeOverlapsItem',
    'InternalRangePeering',
    'InternalRangeUsage',
    'PolicyBasedRouteNextHopOtherRoutes',
]


class AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """


class FilterProtocolVersion(str, Enum):
    """
    Required. Internet protocol versions this policy-based route applies to. For this version, only IPV4 is supported.
    """
    PROTOCOL_VERSION_UNSPECIFIED = "PROTOCOL_VERSION_UNSPECIFIED"
    """
    Default value.
    """
    IPV4 = "IPV4"
    """
    The PBR is for IPv4 internet protocol traffic.
    """


class InternalRangeOverlapsItem(str, Enum):
    OVERLAP_UNSPECIFIED = "OVERLAP_UNSPECIFIED"
    """
    No overlap overrides.
    """
    OVERLAP_ROUTE_RANGE = "OVERLAP_ROUTE_RANGE"
    """
    Allow creation of static routes more specific that the current internal range.
    """
    OVERLAP_EXISTING_SUBNET_RANGE = "OVERLAP_EXISTING_SUBNET_RANGE"
    """
    Allow creation of internal ranges that overlap with existing subnets.
    """


class InternalRangePeering(str, Enum):
    """
    The type of peering set for this internal range.
    """
    PEERING_UNSPECIFIED = "PEERING_UNSPECIFIED"
    """
    If Peering is left unspecified in CreateInternalRange or UpdateInternalRange, it will be defaulted to FOR_SELF.
    """
    FOR_SELF = "FOR_SELF"
    """
    This is the default behavior and represents the case that this internal range is intended to be used in the VPC in which it is created and is accessible from its peers. This implies that peers or peers-of-peers cannot use this range.
    """
    FOR_PEER = "FOR_PEER"
    """
    This behavior can be set when the internal range is being reserved for usage by peers. This means that no resource within the VPC in which it is being created can use this to associate with a VPC resource, but one of the peers can. This represents donating a range for peers to use.
    """
    NOT_SHARED = "NOT_SHARED"
    """
    This behavior can be set when the internal range is being reserved for usage by the VPC in which it is created, but not shared with peers. In a sense, it is local to the VPC. This can be used to create internal ranges for various purposes like HTTP_INTERNAL_LOAD_BALANCER or for Interconnect routes that are not shared with peers. This also implies that peers cannot use this range in a way that is visible to this VPC, but can re-use this range as long as it is NOT_SHARED from the peer VPC, too.
    """


class InternalRangeUsage(str, Enum):
    """
    The type of usage set for this InternalRange.
    """
    USAGE_UNSPECIFIED = "USAGE_UNSPECIFIED"
    """
    Unspecified usage is allowed in calls which identify the resource by other fields and do not need Usage set to complete. These are, i.e.: GetInternalRange and DeleteInternalRange. Usage needs to be specified explicitly in CreateInternalRange or UpdateInternalRange calls.
    """
    FOR_VPC = "FOR_VPC"
    """
    A VPC resource can use the reserved CIDR block by associating it with the internal range resource if usage is set to FOR_VPC.
    """
    EXTERNAL_TO_VPC = "EXTERNAL_TO_VPC"
    """
    Ranges created with EXTERNAL_TO_VPC cannot be associated with VPC resources and are meant to block out address ranges for various use cases, like for example, usage on-prem, with dynamic route announcements via interconnect.
    """


class PolicyBasedRouteNextHopOtherRoutes(str, Enum):
    """
    Optional. Other routes that will be referenced to determine the next hop of the packet.
    """
    OTHER_ROUTES_UNSPECIFIED = "OTHER_ROUTES_UNSPECIFIED"
    """
    Default value.
    """
    DEFAULT_ROUTING = "DEFAULT_ROUTING"
    """
    Use the routes from the default routing tables (system-generated routes, custom routes, peering route) to determine the next hop. This will effectively exclude matching packets being applied on other PBRs with a lower priority.
    """
