# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'AuditConfigResponse',
    'AuditLogConfigResponse',
    'BindingResponse',
    'ConsumerPscConfigResponse',
    'ConsumerPscConnectionResponse',
    'ExprResponse',
    'FilterResponse',
    'GoogleRpcErrorInfoResponse',
    'GoogleRpcStatusResponse',
    'InterconnectAttachmentResponse',
    'LinkedInterconnectAttachmentsResponse',
    'LinkedRouterApplianceInstancesResponse',
    'LinkedVpcNetworkResponse',
    'LinkedVpnTunnelsResponse',
    'ProducerPscConfigResponse',
    'PscConfigResponse',
    'PscConnectionResponse',
    'RouterApplianceInstanceResponse',
    'RoutingVPCResponse',
    'SpokeStateCountResponse',
    'SpokeStateReasonCountResponse',
    'SpokeSummaryResponse',
    'SpokeTypeCountResponse',
    'StateReasonResponse',
    'VirtualMachineResponse',
    'WarningsResponse',
]

@pulumi.output_type
class AuditConfigResponse(dict):
    """
    Specifies the audit configuration for a service. The configuration determines which permission types are logged, and what identities, if any, are exempted from logging. An AuditConfig must have one or more AuditLogConfigs. If there are AuditConfigs for both `allServices` and a specific service, the union of the two AuditConfigs is used for that service: the log_types specified in each AuditConfig are enabled, and the exempted_members in each AuditLogConfig are exempted. Example Policy with multiple AuditConfigs: { "audit_configs": [ { "service": "allServices", "audit_log_configs": [ { "log_type": "DATA_READ", "exempted_members": [ "user:jose@example.com" ] }, { "log_type": "DATA_WRITE" }, { "log_type": "ADMIN_READ" } ] }, { "service": "sampleservice.googleapis.com", "audit_log_configs": [ { "log_type": "DATA_READ" }, { "log_type": "DATA_WRITE", "exempted_members": [ "user:aliya@example.com" ] } ] } ] } For sampleservice, this policy enables DATA_READ, DATA_WRITE and ADMIN_READ logging. It also exempts `jose@example.com` from DATA_READ logging, and `aliya@example.com` from DATA_WRITE logging.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "auditLogConfigs":
            suggest = "audit_log_configs"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AuditConfigResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AuditConfigResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AuditConfigResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 audit_log_configs: Sequence['outputs.AuditLogConfigResponse'],
                 service: str):
        """
        Specifies the audit configuration for a service. The configuration determines which permission types are logged, and what identities, if any, are exempted from logging. An AuditConfig must have one or more AuditLogConfigs. If there are AuditConfigs for both `allServices` and a specific service, the union of the two AuditConfigs is used for that service: the log_types specified in each AuditConfig are enabled, and the exempted_members in each AuditLogConfig are exempted. Example Policy with multiple AuditConfigs: { "audit_configs": [ { "service": "allServices", "audit_log_configs": [ { "log_type": "DATA_READ", "exempted_members": [ "user:jose@example.com" ] }, { "log_type": "DATA_WRITE" }, { "log_type": "ADMIN_READ" } ] }, { "service": "sampleservice.googleapis.com", "audit_log_configs": [ { "log_type": "DATA_READ" }, { "log_type": "DATA_WRITE", "exempted_members": [ "user:aliya@example.com" ] } ] } ] } For sampleservice, this policy enables DATA_READ, DATA_WRITE and ADMIN_READ logging. It also exempts `jose@example.com` from DATA_READ logging, and `aliya@example.com` from DATA_WRITE logging.
        :param Sequence['AuditLogConfigResponse'] audit_log_configs: The configuration for logging of each type of permission.
        :param str service: Specifies a service that will be enabled for audit logging. For example, `storage.googleapis.com`, `cloudsql.googleapis.com`. `allServices` is a special value that covers all services.
        """
        pulumi.set(__self__, "audit_log_configs", audit_log_configs)
        pulumi.set(__self__, "service", service)

    @property
    @pulumi.getter(name="auditLogConfigs")
    def audit_log_configs(self) -> Sequence['outputs.AuditLogConfigResponse']:
        """
        The configuration for logging of each type of permission.
        """
        return pulumi.get(self, "audit_log_configs")

    @property
    @pulumi.getter
    def service(self) -> str:
        """
        Specifies a service that will be enabled for audit logging. For example, `storage.googleapis.com`, `cloudsql.googleapis.com`. `allServices` is a special value that covers all services.
        """
        return pulumi.get(self, "service")


@pulumi.output_type
class AuditLogConfigResponse(dict):
    """
    Provides the configuration for logging a type of permissions. Example: { "audit_log_configs": [ { "log_type": "DATA_READ", "exempted_members": [ "user:jose@example.com" ] }, { "log_type": "DATA_WRITE" } ] } This enables 'DATA_READ' and 'DATA_WRITE' logging, while exempting jose@example.com from DATA_READ logging.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "exemptedMembers":
            suggest = "exempted_members"
        elif key == "logType":
            suggest = "log_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AuditLogConfigResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AuditLogConfigResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AuditLogConfigResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 exempted_members: Sequence[str],
                 log_type: str):
        """
        Provides the configuration for logging a type of permissions. Example: { "audit_log_configs": [ { "log_type": "DATA_READ", "exempted_members": [ "user:jose@example.com" ] }, { "log_type": "DATA_WRITE" } ] } This enables 'DATA_READ' and 'DATA_WRITE' logging, while exempting jose@example.com from DATA_READ logging.
        :param Sequence[str] exempted_members: Specifies the identities that do not cause logging for this type of permission. Follows the same format of Binding.members.
        :param str log_type: The log type that this config enables.
        """
        pulumi.set(__self__, "exempted_members", exempted_members)
        pulumi.set(__self__, "log_type", log_type)

    @property
    @pulumi.getter(name="exemptedMembers")
    def exempted_members(self) -> Sequence[str]:
        """
        Specifies the identities that do not cause logging for this type of permission. Follows the same format of Binding.members.
        """
        return pulumi.get(self, "exempted_members")

    @property
    @pulumi.getter(name="logType")
    def log_type(self) -> str:
        """
        The log type that this config enables.
        """
        return pulumi.get(self, "log_type")


@pulumi.output_type
class BindingResponse(dict):
    """
    Associates `members`, or principals, with a `role`.
    """
    def __init__(__self__, *,
                 condition: 'outputs.ExprResponse',
                 members: Sequence[str],
                 role: str):
        """
        Associates `members`, or principals, with a `role`.
        :param 'ExprResponse' condition: The condition that is associated with this binding. If the condition evaluates to `true`, then this binding applies to the current request. If the condition evaluates to `false`, then this binding does not apply to the current request. However, a different role binding might grant the same role to one or more of the principals in this binding. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).
        :param Sequence[str] members: Specifies the principals requesting access for a Google Cloud resource. `members` can have the following values: * `allUsers`: A special identifier that represents anyone who is on the internet; with or without a Google account. * `allAuthenticatedUsers`: A special identifier that represents anyone who is authenticated with a Google account or a service account. Does not include identities that come from external identity providers (IdPs) through identity federation. * `user:{emailid}`: An email address that represents a specific Google account. For example, `alice@example.com` . * `serviceAccount:{emailid}`: An email address that represents a Google service account. For example, `my-other-app@appspot.gserviceaccount.com`. * `serviceAccount:{projectid}.svc.id.goog[{namespace}/{kubernetes-sa}]`: An identifier for a [Kubernetes service account](https://cloud.google.com/kubernetes-engine/docs/how-to/kubernetes-service-accounts). For example, `my-project.svc.id.goog[my-namespace/my-kubernetes-sa]`. * `group:{emailid}`: An email address that represents a Google group. For example, `admins@example.com`. * `domain:{domain}`: The G Suite domain (primary) that represents all the users of that domain. For example, `google.com` or `example.com`. * `deleted:user:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a user that has been recently deleted. For example, `alice@example.com?uid=123456789012345678901`. If the user is recovered, this value reverts to `user:{emailid}` and the recovered user retains the role in the binding. * `deleted:serviceAccount:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a service account that has been recently deleted. For example, `my-other-app@appspot.gserviceaccount.com?uid=123456789012345678901`. If the service account is undeleted, this value reverts to `serviceAccount:{emailid}` and the undeleted service account retains the role in the binding. * `deleted:group:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a Google group that has been recently deleted. For example, `admins@example.com?uid=123456789012345678901`. If the group is recovered, this value reverts to `group:{emailid}` and the recovered group retains the role in the binding.
        :param str role: Role that is assigned to the list of `members`, or principals. For example, `roles/viewer`, `roles/editor`, or `roles/owner`.
        """
        pulumi.set(__self__, "condition", condition)
        pulumi.set(__self__, "members", members)
        pulumi.set(__self__, "role", role)

    @property
    @pulumi.getter
    def condition(self) -> 'outputs.ExprResponse':
        """
        The condition that is associated with this binding. If the condition evaluates to `true`, then this binding applies to the current request. If the condition evaluates to `false`, then this binding does not apply to the current request. However, a different role binding might grant the same role to one or more of the principals in this binding. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).
        """
        return pulumi.get(self, "condition")

    @property
    @pulumi.getter
    def members(self) -> Sequence[str]:
        """
        Specifies the principals requesting access for a Google Cloud resource. `members` can have the following values: * `allUsers`: A special identifier that represents anyone who is on the internet; with or without a Google account. * `allAuthenticatedUsers`: A special identifier that represents anyone who is authenticated with a Google account or a service account. Does not include identities that come from external identity providers (IdPs) through identity federation. * `user:{emailid}`: An email address that represents a specific Google account. For example, `alice@example.com` . * `serviceAccount:{emailid}`: An email address that represents a Google service account. For example, `my-other-app@appspot.gserviceaccount.com`. * `serviceAccount:{projectid}.svc.id.goog[{namespace}/{kubernetes-sa}]`: An identifier for a [Kubernetes service account](https://cloud.google.com/kubernetes-engine/docs/how-to/kubernetes-service-accounts). For example, `my-project.svc.id.goog[my-namespace/my-kubernetes-sa]`. * `group:{emailid}`: An email address that represents a Google group. For example, `admins@example.com`. * `domain:{domain}`: The G Suite domain (primary) that represents all the users of that domain. For example, `google.com` or `example.com`. * `deleted:user:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a user that has been recently deleted. For example, `alice@example.com?uid=123456789012345678901`. If the user is recovered, this value reverts to `user:{emailid}` and the recovered user retains the role in the binding. * `deleted:serviceAccount:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a service account that has been recently deleted. For example, `my-other-app@appspot.gserviceaccount.com?uid=123456789012345678901`. If the service account is undeleted, this value reverts to `serviceAccount:{emailid}` and the undeleted service account retains the role in the binding. * `deleted:group:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a Google group that has been recently deleted. For example, `admins@example.com?uid=123456789012345678901`. If the group is recovered, this value reverts to `group:{emailid}` and the recovered group retains the role in the binding.
        """
        return pulumi.get(self, "members")

    @property
    @pulumi.getter
    def role(self) -> str:
        """
        Role that is assigned to the list of `members`, or principals. For example, `roles/viewer`, `roles/editor`, or `roles/owner`.
        """
        return pulumi.get(self, "role")


@pulumi.output_type
class ConsumerPscConfigResponse(dict):
    """
    Allow the producer to specify which consumers can connect to it.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "disableGlobalAccess":
            suggest = "disable_global_access"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConsumerPscConfigResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConsumerPscConfigResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConsumerPscConfigResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 disable_global_access: bool,
                 network: str,
                 project: str,
                 state: str):
        """
        Allow the producer to specify which consumers can connect to it.
        :param bool disable_global_access: This is used in PSC consumer ForwardingRule to control whether the PSC endpoint can be accessed from another region.
        :param str network: The resource path of the consumer network where PSC connections are allowed to be created in. Note, this network does not need be in the ConsumerPscConfig.project in the case of SharedVPC. Example: projects/{projectNumOrId}/global/networks/{networkId}.
        :param str project: The consumer project where PSC connections are allowed to be created in.
        :param str state: Overall state of PSC Connections management for this consumer psc config.
        """
        pulumi.set(__self__, "disable_global_access", disable_global_access)
        pulumi.set(__self__, "network", network)
        pulumi.set(__self__, "project", project)
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="disableGlobalAccess")
    def disable_global_access(self) -> bool:
        """
        This is used in PSC consumer ForwardingRule to control whether the PSC endpoint can be accessed from another region.
        """
        return pulumi.get(self, "disable_global_access")

    @property
    @pulumi.getter
    def network(self) -> str:
        """
        The resource path of the consumer network where PSC connections are allowed to be created in. Note, this network does not need be in the ConsumerPscConfig.project in the case of SharedVPC. Example: projects/{projectNumOrId}/global/networks/{networkId}.
        """
        return pulumi.get(self, "network")

    @property
    @pulumi.getter
    def project(self) -> str:
        """
        The consumer project where PSC connections are allowed to be created in.
        """
        return pulumi.get(self, "project")

    @property
    @pulumi.getter
    def state(self) -> str:
        """
        Overall state of PSC Connections management for this consumer psc config.
        """
        return pulumi.get(self, "state")


@pulumi.output_type
class ConsumerPscConnectionResponse(dict):
    """
    PSC connection details on consumer side.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "errorInfo":
            suggest = "error_info"
        elif key == "errorType":
            suggest = "error_type"
        elif key == "forwardingRule":
            suggest = "forwarding_rule"
        elif key == "gceOperation":
            suggest = "gce_operation"
        elif key == "pscConnectionId":
            suggest = "psc_connection_id"
        elif key == "serviceAttachmentUri":
            suggest = "service_attachment_uri"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConsumerPscConnectionResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConsumerPscConnectionResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConsumerPscConnectionResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 error: 'outputs.GoogleRpcStatusResponse',
                 error_info: 'outputs.GoogleRpcErrorInfoResponse',
                 error_type: str,
                 forwarding_rule: str,
                 gce_operation: str,
                 ip: str,
                 network: str,
                 project: str,
                 psc_connection_id: str,
                 service_attachment_uri: str,
                 state: str):
        """
        PSC connection details on consumer side.
        :param 'GoogleRpcStatusResponse' error: The most recent error during operating this connection.
        :param 'GoogleRpcErrorInfoResponse' error_info: The error info for the latest error during operating this connection.
        :param str error_type: The error type indicates whether the error is consumer facing, producer facing or system internal.
        :param str forwarding_rule: The URI of the consumer forwarding rule created. Example: projects/{projectNumOrId}/regions/us-east1/networks/{resourceId}.
        :param str gce_operation: The last Compute Engine operation to setup PSC connection.
        :param str ip: The IP literal allocated on the consumer network for the PSC forwarding rule that is created to connect to the producer service attachment in this service connection map.
        :param str network: The consumer network whose PSC forwarding rule is connected to the service attachments in this service connection map. Note that the network could be on a different project (shared VPC).
        :param str project: The consumer project whose PSC forwarding rule is connected to the service attachments in this service connection map.
        :param str psc_connection_id: The PSC connection id of the PSC forwarding rule connected to the service attachments in this service connection map.
        :param str service_attachment_uri: The URI of a service attachment which is the target of the PSC connection.
        :param str state: The state of the PSC connection.
        """
        pulumi.set(__self__, "error", error)
        pulumi.set(__self__, "error_info", error_info)
        pulumi.set(__self__, "error_type", error_type)
        pulumi.set(__self__, "forwarding_rule", forwarding_rule)
        pulumi.set(__self__, "gce_operation", gce_operation)
        pulumi.set(__self__, "ip", ip)
        pulumi.set(__self__, "network", network)
        pulumi.set(__self__, "project", project)
        pulumi.set(__self__, "psc_connection_id", psc_connection_id)
        pulumi.set(__self__, "service_attachment_uri", service_attachment_uri)
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter
    def error(self) -> 'outputs.GoogleRpcStatusResponse':
        """
        The most recent error during operating this connection.
        """
        return pulumi.get(self, "error")

    @property
    @pulumi.getter(name="errorInfo")
    def error_info(self) -> 'outputs.GoogleRpcErrorInfoResponse':
        """
        The error info for the latest error during operating this connection.
        """
        return pulumi.get(self, "error_info")

    @property
    @pulumi.getter(name="errorType")
    def error_type(self) -> str:
        """
        The error type indicates whether the error is consumer facing, producer facing or system internal.
        """
        return pulumi.get(self, "error_type")

    @property
    @pulumi.getter(name="forwardingRule")
    def forwarding_rule(self) -> str:
        """
        The URI of the consumer forwarding rule created. Example: projects/{projectNumOrId}/regions/us-east1/networks/{resourceId}.
        """
        return pulumi.get(self, "forwarding_rule")

    @property
    @pulumi.getter(name="gceOperation")
    def gce_operation(self) -> str:
        """
        The last Compute Engine operation to setup PSC connection.
        """
        return pulumi.get(self, "gce_operation")

    @property
    @pulumi.getter
    def ip(self) -> str:
        """
        The IP literal allocated on the consumer network for the PSC forwarding rule that is created to connect to the producer service attachment in this service connection map.
        """
        return pulumi.get(self, "ip")

    @property
    @pulumi.getter
    def network(self) -> str:
        """
        The consumer network whose PSC forwarding rule is connected to the service attachments in this service connection map. Note that the network could be on a different project (shared VPC).
        """
        return pulumi.get(self, "network")

    @property
    @pulumi.getter
    def project(self) -> str:
        """
        The consumer project whose PSC forwarding rule is connected to the service attachments in this service connection map.
        """
        return pulumi.get(self, "project")

    @property
    @pulumi.getter(name="pscConnectionId")
    def psc_connection_id(self) -> str:
        """
        The PSC connection id of the PSC forwarding rule connected to the service attachments in this service connection map.
        """
        return pulumi.get(self, "psc_connection_id")

    @property
    @pulumi.getter(name="serviceAttachmentUri")
    def service_attachment_uri(self) -> str:
        """
        The URI of a service attachment which is the target of the PSC connection.
        """
        return pulumi.get(self, "service_attachment_uri")

    @property
    @pulumi.getter
    def state(self) -> str:
        """
        The state of the PSC connection.
        """
        return pulumi.get(self, "state")


@pulumi.output_type
class ExprResponse(dict):
    """
    Represents a textual expression in the Common Expression Language (CEL) syntax. CEL is a C-like expression language. The syntax and semantics of CEL are documented at https://github.com/google/cel-spec. Example (Comparison): title: "Summary size limit" description: "Determines if a summary is less than 100 chars" expression: "document.summary.size() < 100" Example (Equality): title: "Requestor is owner" description: "Determines if requestor is the document owner" expression: "document.owner == request.auth.claims.email" Example (Logic): title: "Public documents" description: "Determine whether the document should be publicly visible" expression: "document.type != 'private' && document.type != 'internal'" Example (Data Manipulation): title: "Notification string" description: "Create a notification string with a timestamp." expression: "'New message received at ' + string(document.create_time)" The exact variables and functions that may be referenced within an expression are determined by the service that evaluates it. See the service documentation for additional information.
    """
    def __init__(__self__, *,
                 description: str,
                 expression: str,
                 location: str,
                 title: str):
        """
        Represents a textual expression in the Common Expression Language (CEL) syntax. CEL is a C-like expression language. The syntax and semantics of CEL are documented at https://github.com/google/cel-spec. Example (Comparison): title: "Summary size limit" description: "Determines if a summary is less than 100 chars" expression: "document.summary.size() < 100" Example (Equality): title: "Requestor is owner" description: "Determines if requestor is the document owner" expression: "document.owner == request.auth.claims.email" Example (Logic): title: "Public documents" description: "Determine whether the document should be publicly visible" expression: "document.type != 'private' && document.type != 'internal'" Example (Data Manipulation): title: "Notification string" description: "Create a notification string with a timestamp." expression: "'New message received at ' + string(document.create_time)" The exact variables and functions that may be referenced within an expression are determined by the service that evaluates it. See the service documentation for additional information.
        :param str description: Optional. Description of the expression. This is a longer text which describes the expression, e.g. when hovered over it in a UI.
        :param str expression: Textual representation of an expression in Common Expression Language syntax.
        :param str location: Optional. String indicating the location of the expression for error reporting, e.g. a file name and a position in the file.
        :param str title: Optional. Title for the expression, i.e. a short string describing its purpose. This can be used e.g. in UIs which allow to enter the expression.
        """
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "expression", expression)
        pulumi.set(__self__, "location", location)
        pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Optional. Description of the expression. This is a longer text which describes the expression, e.g. when hovered over it in a UI.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def expression(self) -> str:
        """
        Textual representation of an expression in Common Expression Language syntax.
        """
        return pulumi.get(self, "expression")

    @property
    @pulumi.getter
    def location(self) -> str:
        """
        Optional. String indicating the location of the expression for error reporting, e.g. a file name and a position in the file.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        Optional. Title for the expression, i.e. a short string describing its purpose. This can be used e.g. in UIs which allow to enter the expression.
        """
        return pulumi.get(self, "title")


@pulumi.output_type
class FilterResponse(dict):
    """
    Filter matches L4 traffic.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "destRange":
            suggest = "dest_range"
        elif key == "ipProtocol":
            suggest = "ip_protocol"
        elif key == "protocolVersion":
            suggest = "protocol_version"
        elif key == "srcRange":
            suggest = "src_range"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in FilterResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        FilterResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        FilterResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dest_range: str,
                 ip_protocol: str,
                 protocol_version: str,
                 src_range: str):
        """
        Filter matches L4 traffic.
        :param str dest_range: Optional. The destination IP range of outgoing packets that this policy-based route applies to. Default is "0.0.0.0/0" if protocol version is IPv4.
        :param str ip_protocol: Optional. The IP protocol that this policy-based route applies to. Valid values are 'TCP', 'UDP', and 'ALL'. Default is 'ALL'.
        :param str protocol_version: Internet protocol versions this policy-based route applies to. For this version, only IPV4 is supported.
        :param str src_range: Optional. The source IP range of outgoing packets that this policy-based route applies to. Default is "0.0.0.0/0" if protocol version is IPv4.
        """
        pulumi.set(__self__, "dest_range", dest_range)
        pulumi.set(__self__, "ip_protocol", ip_protocol)
        pulumi.set(__self__, "protocol_version", protocol_version)
        pulumi.set(__self__, "src_range", src_range)

    @property
    @pulumi.getter(name="destRange")
    def dest_range(self) -> str:
        """
        Optional. The destination IP range of outgoing packets that this policy-based route applies to. Default is "0.0.0.0/0" if protocol version is IPv4.
        """
        return pulumi.get(self, "dest_range")

    @property
    @pulumi.getter(name="ipProtocol")
    def ip_protocol(self) -> str:
        """
        Optional. The IP protocol that this policy-based route applies to. Valid values are 'TCP', 'UDP', and 'ALL'. Default is 'ALL'.
        """
        return pulumi.get(self, "ip_protocol")

    @property
    @pulumi.getter(name="protocolVersion")
    def protocol_version(self) -> str:
        """
        Internet protocol versions this policy-based route applies to. For this version, only IPV4 is supported.
        """
        return pulumi.get(self, "protocol_version")

    @property
    @pulumi.getter(name="srcRange")
    def src_range(self) -> str:
        """
        Optional. The source IP range of outgoing packets that this policy-based route applies to. Default is "0.0.0.0/0" if protocol version is IPv4.
        """
        return pulumi.get(self, "src_range")


@pulumi.output_type
class GoogleRpcErrorInfoResponse(dict):
    """
    Describes the cause of the error with structured details. Example of an error when contacting the "pubsub.googleapis.com" API when it is not enabled: { "reason": "API_DISABLED" "domain": "googleapis.com" "metadata": { "resource": "projects/123", "service": "pubsub.googleapis.com" } } This response indicates that the pubsub.googleapis.com API is not enabled. Example of an error that is returned when attempting to create a Spanner instance in a region that is out of stock: { "reason": "STOCKOUT" "domain": "spanner.googleapis.com", "metadata": { "availableRegions": "us-central1,us-east2" } }
    """
    def __init__(__self__, *,
                 domain: str,
                 metadata: Mapping[str, str],
                 reason: str):
        """
        Describes the cause of the error with structured details. Example of an error when contacting the "pubsub.googleapis.com" API when it is not enabled: { "reason": "API_DISABLED" "domain": "googleapis.com" "metadata": { "resource": "projects/123", "service": "pubsub.googleapis.com" } } This response indicates that the pubsub.googleapis.com API is not enabled. Example of an error that is returned when attempting to create a Spanner instance in a region that is out of stock: { "reason": "STOCKOUT" "domain": "spanner.googleapis.com", "metadata": { "availableRegions": "us-central1,us-east2" } }
        :param str domain: The logical grouping to which the "reason" belongs. The error domain is typically the registered service name of the tool or product that generates the error. Example: "pubsub.googleapis.com". If the error is generated by some common infrastructure, the error domain must be a globally unique value that identifies the infrastructure. For Google API infrastructure, the error domain is "googleapis.com".
        :param Mapping[str, str] metadata: Additional structured details about this error. Keys should match /[a-zA-Z0-9-_]/ and be limited to 64 characters in length. When identifying the current value of an exceeded limit, the units should be contained in the key, not the value. For example, rather than {"instanceLimit": "100/request"}, should be returned as, {"instanceLimitPerRequest": "100"}, if the client exceeds the number of instances that can be created in a single (batch) request.
        :param str reason: The reason of the error. This is a constant value that identifies the proximate cause of the error. Error reasons are unique within a particular domain of errors. This should be at most 63 characters and match a regular expression of `A-Z+[A-Z0-9]`, which represents UPPER_SNAKE_CASE.
        """
        pulumi.set(__self__, "domain", domain)
        pulumi.set(__self__, "metadata", metadata)
        pulumi.set(__self__, "reason", reason)

    @property
    @pulumi.getter
    def domain(self) -> str:
        """
        The logical grouping to which the "reason" belongs. The error domain is typically the registered service name of the tool or product that generates the error. Example: "pubsub.googleapis.com". If the error is generated by some common infrastructure, the error domain must be a globally unique value that identifies the infrastructure. For Google API infrastructure, the error domain is "googleapis.com".
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter
    def metadata(self) -> Mapping[str, str]:
        """
        Additional structured details about this error. Keys should match /[a-zA-Z0-9-_]/ and be limited to 64 characters in length. When identifying the current value of an exceeded limit, the units should be contained in the key, not the value. For example, rather than {"instanceLimit": "100/request"}, should be returned as, {"instanceLimitPerRequest": "100"}, if the client exceeds the number of instances that can be created in a single (batch) request.
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def reason(self) -> str:
        """
        The reason of the error. This is a constant value that identifies the proximate cause of the error. Error reasons are unique within a particular domain of errors. This should be at most 63 characters and match a regular expression of `A-Z+[A-Z0-9]`, which represents UPPER_SNAKE_CASE.
        """
        return pulumi.get(self, "reason")


@pulumi.output_type
class GoogleRpcStatusResponse(dict):
    """
    The `Status` type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by [gRPC](https://github.com/grpc). Each `Status` message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the [API Design Guide](https://cloud.google.com/apis/design/errors).
    """
    def __init__(__self__, *,
                 code: int,
                 details: Sequence[Mapping[str, Any]],
                 message: str):
        """
        The `Status` type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by [gRPC](https://github.com/grpc). Each `Status` message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the [API Design Guide](https://cloud.google.com/apis/design/errors).
        :param int code: The status code, which should be an enum value of google.rpc.Code.
        :param Sequence[Mapping[str, Any]] details: A list of messages that carry the error details. There is a common set of message types for APIs to use.
        :param str message: A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.
        """
        pulumi.set(__self__, "code", code)
        pulumi.set(__self__, "details", details)
        pulumi.set(__self__, "message", message)

    @property
    @pulumi.getter
    def code(self) -> int:
        """
        The status code, which should be an enum value of google.rpc.Code.
        """
        return pulumi.get(self, "code")

    @property
    @pulumi.getter
    def details(self) -> Sequence[Mapping[str, Any]]:
        """
        A list of messages that carry the error details. There is a common set of message types for APIs to use.
        """
        return pulumi.get(self, "details")

    @property
    @pulumi.getter
    def message(self) -> str:
        """
        A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.
        """
        return pulumi.get(self, "message")


@pulumi.output_type
class InterconnectAttachmentResponse(dict):
    """
    InterconnectAttachment that this route applies to.
    """
    def __init__(__self__, *,
                 region: str):
        """
        InterconnectAttachment that this route applies to.
        :param str region: Optional. Cloud region to install this policy-based route on interconnect attachment. Use `all` to install it on all interconnect attachments.
        """
        pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter
    def region(self) -> str:
        """
        Optional. Cloud region to install this policy-based route on interconnect attachment. Use `all` to install it on all interconnect attachments.
        """
        return pulumi.get(self, "region")


@pulumi.output_type
class LinkedInterconnectAttachmentsResponse(dict):
    """
    A collection of VLAN attachment resources. These resources should be redundant attachments that all advertise the same prefixes to Google Cloud. Alternatively, in active/passive configurations, all attachments should be capable of advertising the same prefixes.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "siteToSiteDataTransfer":
            suggest = "site_to_site_data_transfer"
        elif key == "vpcNetwork":
            suggest = "vpc_network"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LinkedInterconnectAttachmentsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LinkedInterconnectAttachmentsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LinkedInterconnectAttachmentsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 site_to_site_data_transfer: bool,
                 uris: Sequence[str],
                 vpc_network: str):
        """
        A collection of VLAN attachment resources. These resources should be redundant attachments that all advertise the same prefixes to Google Cloud. Alternatively, in active/passive configurations, all attachments should be capable of advertising the same prefixes.
        :param bool site_to_site_data_transfer: A value that controls whether site-to-site data transfer is enabled for these resources. Data transfer is available only in [supported locations](https://cloud.google.com/network-connectivity/docs/network-connectivity-center/concepts/locations).
        :param Sequence[str] uris: The URIs of linked interconnect attachment resources
        :param str vpc_network: The VPC network where these VLAN attachments are located.
        """
        pulumi.set(__self__, "site_to_site_data_transfer", site_to_site_data_transfer)
        pulumi.set(__self__, "uris", uris)
        pulumi.set(__self__, "vpc_network", vpc_network)

    @property
    @pulumi.getter(name="siteToSiteDataTransfer")
    def site_to_site_data_transfer(self) -> bool:
        """
        A value that controls whether site-to-site data transfer is enabled for these resources. Data transfer is available only in [supported locations](https://cloud.google.com/network-connectivity/docs/network-connectivity-center/concepts/locations).
        """
        return pulumi.get(self, "site_to_site_data_transfer")

    @property
    @pulumi.getter
    def uris(self) -> Sequence[str]:
        """
        The URIs of linked interconnect attachment resources
        """
        return pulumi.get(self, "uris")

    @property
    @pulumi.getter(name="vpcNetwork")
    def vpc_network(self) -> str:
        """
        The VPC network where these VLAN attachments are located.
        """
        return pulumi.get(self, "vpc_network")


@pulumi.output_type
class LinkedRouterApplianceInstancesResponse(dict):
    """
    A collection of router appliance instances. If you configure multiple router appliance instances to receive data from the same set of sites outside of Google Cloud, we recommend that you associate those instances with the same spoke.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "siteToSiteDataTransfer":
            suggest = "site_to_site_data_transfer"
        elif key == "vpcNetwork":
            suggest = "vpc_network"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LinkedRouterApplianceInstancesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LinkedRouterApplianceInstancesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LinkedRouterApplianceInstancesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 instances: Sequence['outputs.RouterApplianceInstanceResponse'],
                 site_to_site_data_transfer: bool,
                 vpc_network: str):
        """
        A collection of router appliance instances. If you configure multiple router appliance instances to receive data from the same set of sites outside of Google Cloud, we recommend that you associate those instances with the same spoke.
        :param Sequence['RouterApplianceInstanceResponse'] instances: The list of router appliance instances.
        :param bool site_to_site_data_transfer: A value that controls whether site-to-site data transfer is enabled for these resources. Data transfer is available only in [supported locations](https://cloud.google.com/network-connectivity/docs/network-connectivity-center/concepts/locations).
        :param str vpc_network: The VPC network where these router appliance instances are located.
        """
        pulumi.set(__self__, "instances", instances)
        pulumi.set(__self__, "site_to_site_data_transfer", site_to_site_data_transfer)
        pulumi.set(__self__, "vpc_network", vpc_network)

    @property
    @pulumi.getter
    def instances(self) -> Sequence['outputs.RouterApplianceInstanceResponse']:
        """
        The list of router appliance instances.
        """
        return pulumi.get(self, "instances")

    @property
    @pulumi.getter(name="siteToSiteDataTransfer")
    def site_to_site_data_transfer(self) -> bool:
        """
        A value that controls whether site-to-site data transfer is enabled for these resources. Data transfer is available only in [supported locations](https://cloud.google.com/network-connectivity/docs/network-connectivity-center/concepts/locations).
        """
        return pulumi.get(self, "site_to_site_data_transfer")

    @property
    @pulumi.getter(name="vpcNetwork")
    def vpc_network(self) -> str:
        """
        The VPC network where these router appliance instances are located.
        """
        return pulumi.get(self, "vpc_network")


@pulumi.output_type
class LinkedVpcNetworkResponse(dict):
    """
    An existing VPC network.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "excludeExportRanges":
            suggest = "exclude_export_ranges"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LinkedVpcNetworkResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LinkedVpcNetworkResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LinkedVpcNetworkResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 exclude_export_ranges: Sequence[str],
                 uri: str):
        """
        An existing VPC network.
        :param Sequence[str] exclude_export_ranges: Optional. IP ranges encompassing the subnets to be excluded from peering.
        :param str uri: The URI of the VPC network resource.
        """
        pulumi.set(__self__, "exclude_export_ranges", exclude_export_ranges)
        pulumi.set(__self__, "uri", uri)

    @property
    @pulumi.getter(name="excludeExportRanges")
    def exclude_export_ranges(self) -> Sequence[str]:
        """
        Optional. IP ranges encompassing the subnets to be excluded from peering.
        """
        return pulumi.get(self, "exclude_export_ranges")

    @property
    @pulumi.getter
    def uri(self) -> str:
        """
        The URI of the VPC network resource.
        """
        return pulumi.get(self, "uri")


@pulumi.output_type
class LinkedVpnTunnelsResponse(dict):
    """
    A collection of Cloud VPN tunnel resources. These resources should be redundant HA VPN tunnels that all advertise the same prefixes to Google Cloud. Alternatively, in a passive/active configuration, all tunnels should be capable of advertising the same prefixes.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "siteToSiteDataTransfer":
            suggest = "site_to_site_data_transfer"
        elif key == "vpcNetwork":
            suggest = "vpc_network"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LinkedVpnTunnelsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LinkedVpnTunnelsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LinkedVpnTunnelsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 site_to_site_data_transfer: bool,
                 uris: Sequence[str],
                 vpc_network: str):
        """
        A collection of Cloud VPN tunnel resources. These resources should be redundant HA VPN tunnels that all advertise the same prefixes to Google Cloud. Alternatively, in a passive/active configuration, all tunnels should be capable of advertising the same prefixes.
        :param bool site_to_site_data_transfer: A value that controls whether site-to-site data transfer is enabled for these resources. Data transfer is available only in [supported locations](https://cloud.google.com/network-connectivity/docs/network-connectivity-center/concepts/locations).
        :param Sequence[str] uris: The URIs of linked VPN tunnel resources.
        :param str vpc_network: The VPC network where these VPN tunnels are located.
        """
        pulumi.set(__self__, "site_to_site_data_transfer", site_to_site_data_transfer)
        pulumi.set(__self__, "uris", uris)
        pulumi.set(__self__, "vpc_network", vpc_network)

    @property
    @pulumi.getter(name="siteToSiteDataTransfer")
    def site_to_site_data_transfer(self) -> bool:
        """
        A value that controls whether site-to-site data transfer is enabled for these resources. Data transfer is available only in [supported locations](https://cloud.google.com/network-connectivity/docs/network-connectivity-center/concepts/locations).
        """
        return pulumi.get(self, "site_to_site_data_transfer")

    @property
    @pulumi.getter
    def uris(self) -> Sequence[str]:
        """
        The URIs of linked VPN tunnel resources.
        """
        return pulumi.get(self, "uris")

    @property
    @pulumi.getter(name="vpcNetwork")
    def vpc_network(self) -> str:
        """
        The VPC network where these VPN tunnels are located.
        """
        return pulumi.get(self, "vpc_network")


@pulumi.output_type
class ProducerPscConfigResponse(dict):
    """
    The PSC configurations on producer side.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "serviceAttachmentUri":
            suggest = "service_attachment_uri"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProducerPscConfigResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProducerPscConfigResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProducerPscConfigResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 service_attachment_uri: str):
        """
        The PSC configurations on producer side.
        :param str service_attachment_uri: The resource path of a service attachment. Example: projects/{projectNumOrId}/regions/{region}/serviceAttachments/{resourceId}.
        """
        pulumi.set(__self__, "service_attachment_uri", service_attachment_uri)

    @property
    @pulumi.getter(name="serviceAttachmentUri")
    def service_attachment_uri(self) -> str:
        """
        The resource path of a service attachment. Example: projects/{projectNumOrId}/regions/{region}/serviceAttachments/{resourceId}.
        """
        return pulumi.get(self, "service_attachment_uri")


@pulumi.output_type
class PscConfigResponse(dict):
    """
    Configuration used for Private Service Connect connections. Used when Infrastructure is PSC.
    """
    def __init__(__self__, *,
                 limit: str,
                 subnetworks: Sequence[str]):
        """
        Configuration used for Private Service Connect connections. Used when Infrastructure is PSC.
        :param str limit: Optional. Max number of PSC connections for this policy.
        :param Sequence[str] subnetworks: The resource paths of subnetworks to use for IP address management. Example: projects/{projectNumOrId}/regions/{region}/subnetworks/{resourceId}.
        """
        pulumi.set(__self__, "limit", limit)
        pulumi.set(__self__, "subnetworks", subnetworks)

    @property
    @pulumi.getter
    def limit(self) -> str:
        """
        Optional. Max number of PSC connections for this policy.
        """
        return pulumi.get(self, "limit")

    @property
    @pulumi.getter
    def subnetworks(self) -> Sequence[str]:
        """
        The resource paths of subnetworks to use for IP address management. Example: projects/{projectNumOrId}/regions/{region}/subnetworks/{resourceId}.
        """
        return pulumi.get(self, "subnetworks")


@pulumi.output_type
class PscConnectionResponse(dict):
    """
    Information about a specific Private Service Connect connection.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "consumerAddress":
            suggest = "consumer_address"
        elif key == "consumerForwardingRule":
            suggest = "consumer_forwarding_rule"
        elif key == "consumerTargetProject":
            suggest = "consumer_target_project"
        elif key == "errorInfo":
            suggest = "error_info"
        elif key == "errorType":
            suggest = "error_type"
        elif key == "gceOperation":
            suggest = "gce_operation"
        elif key == "pscConnectionId":
            suggest = "psc_connection_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PscConnectionResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PscConnectionResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PscConnectionResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 consumer_address: str,
                 consumer_forwarding_rule: str,
                 consumer_target_project: str,
                 error: 'outputs.GoogleRpcStatusResponse',
                 error_info: 'outputs.GoogleRpcErrorInfoResponse',
                 error_type: str,
                 gce_operation: str,
                 psc_connection_id: str,
                 state: str):
        """
        Information about a specific Private Service Connect connection.
        :param str consumer_address: The resource reference of the consumer address.
        :param str consumer_forwarding_rule: The resource reference of the PSC Forwarding Rule within the consumer VPC.
        :param str consumer_target_project: The project where the PSC connection is created.
        :param 'GoogleRpcStatusResponse' error: The most recent error during operating this connection.
        :param 'GoogleRpcErrorInfoResponse' error_info: The error info for the latest error during operating this connection.
        :param str error_type: The error type indicates whether the error is consumer facing, producer facing or system internal.
        :param str gce_operation: The last Compute Engine operation to setup PSC connection.
        :param str psc_connection_id: The PSC connection id of the PSC forwarding rule.
        :param str state: State of the PSC Connection
        """
        pulumi.set(__self__, "consumer_address", consumer_address)
        pulumi.set(__self__, "consumer_forwarding_rule", consumer_forwarding_rule)
        pulumi.set(__self__, "consumer_target_project", consumer_target_project)
        pulumi.set(__self__, "error", error)
        pulumi.set(__self__, "error_info", error_info)
        pulumi.set(__self__, "error_type", error_type)
        pulumi.set(__self__, "gce_operation", gce_operation)
        pulumi.set(__self__, "psc_connection_id", psc_connection_id)
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="consumerAddress")
    def consumer_address(self) -> str:
        """
        The resource reference of the consumer address.
        """
        return pulumi.get(self, "consumer_address")

    @property
    @pulumi.getter(name="consumerForwardingRule")
    def consumer_forwarding_rule(self) -> str:
        """
        The resource reference of the PSC Forwarding Rule within the consumer VPC.
        """
        return pulumi.get(self, "consumer_forwarding_rule")

    @property
    @pulumi.getter(name="consumerTargetProject")
    def consumer_target_project(self) -> str:
        """
        The project where the PSC connection is created.
        """
        return pulumi.get(self, "consumer_target_project")

    @property
    @pulumi.getter
    def error(self) -> 'outputs.GoogleRpcStatusResponse':
        """
        The most recent error during operating this connection.
        """
        return pulumi.get(self, "error")

    @property
    @pulumi.getter(name="errorInfo")
    def error_info(self) -> 'outputs.GoogleRpcErrorInfoResponse':
        """
        The error info for the latest error during operating this connection.
        """
        return pulumi.get(self, "error_info")

    @property
    @pulumi.getter(name="errorType")
    def error_type(self) -> str:
        """
        The error type indicates whether the error is consumer facing, producer facing or system internal.
        """
        return pulumi.get(self, "error_type")

    @property
    @pulumi.getter(name="gceOperation")
    def gce_operation(self) -> str:
        """
        The last Compute Engine operation to setup PSC connection.
        """
        return pulumi.get(self, "gce_operation")

    @property
    @pulumi.getter(name="pscConnectionId")
    def psc_connection_id(self) -> str:
        """
        The PSC connection id of the PSC forwarding rule.
        """
        return pulumi.get(self, "psc_connection_id")

    @property
    @pulumi.getter
    def state(self) -> str:
        """
        State of the PSC Connection
        """
        return pulumi.get(self, "state")


@pulumi.output_type
class RouterApplianceInstanceResponse(dict):
    """
    A router appliance instance is a Compute Engine virtual machine (VM) instance that acts as a BGP speaker. A router appliance instance is specified by the URI of the VM and the internal IP address of one of the VM's network interfaces.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ipAddress":
            suggest = "ip_address"
        elif key == "virtualMachine":
            suggest = "virtual_machine"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in RouterApplianceInstanceResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        RouterApplianceInstanceResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        RouterApplianceInstanceResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ip_address: str,
                 virtual_machine: str):
        """
        A router appliance instance is a Compute Engine virtual machine (VM) instance that acts as a BGP speaker. A router appliance instance is specified by the URI of the VM and the internal IP address of one of the VM's network interfaces.
        :param str ip_address: The IP address on the VM to use for peering.
        :param str virtual_machine: The URI of the VM.
        """
        pulumi.set(__self__, "ip_address", ip_address)
        pulumi.set(__self__, "virtual_machine", virtual_machine)

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> str:
        """
        The IP address on the VM to use for peering.
        """
        return pulumi.get(self, "ip_address")

    @property
    @pulumi.getter(name="virtualMachine")
    def virtual_machine(self) -> str:
        """
        The URI of the VM.
        """
        return pulumi.get(self, "virtual_machine")


@pulumi.output_type
class RoutingVPCResponse(dict):
    """
    RoutingVPC contains information about the VPC networks associated with the spokes of a Network Connectivity Center hub.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "requiredForNewSiteToSiteDataTransferSpokes":
            suggest = "required_for_new_site_to_site_data_transfer_spokes"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in RoutingVPCResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        RoutingVPCResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        RoutingVPCResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 required_for_new_site_to_site_data_transfer_spokes: bool,
                 uri: str):
        """
        RoutingVPC contains information about the VPC networks associated with the spokes of a Network Connectivity Center hub.
        :param bool required_for_new_site_to_site_data_transfer_spokes: If true, indicates that this VPC network is currently associated with spokes that use the data transfer feature (spokes where the site_to_site_data_transfer field is set to true). If you create new spokes that use data transfer, they must be associated with this VPC network. At most, one VPC network will have this field set to true.
        :param str uri: The URI of the VPC network.
        """
        pulumi.set(__self__, "required_for_new_site_to_site_data_transfer_spokes", required_for_new_site_to_site_data_transfer_spokes)
        pulumi.set(__self__, "uri", uri)

    @property
    @pulumi.getter(name="requiredForNewSiteToSiteDataTransferSpokes")
    def required_for_new_site_to_site_data_transfer_spokes(self) -> bool:
        """
        If true, indicates that this VPC network is currently associated with spokes that use the data transfer feature (spokes where the site_to_site_data_transfer field is set to true). If you create new spokes that use data transfer, they must be associated with this VPC network. At most, one VPC network will have this field set to true.
        """
        return pulumi.get(self, "required_for_new_site_to_site_data_transfer_spokes")

    @property
    @pulumi.getter
    def uri(self) -> str:
        """
        The URI of the VPC network.
        """
        return pulumi.get(self, "uri")


@pulumi.output_type
class SpokeStateCountResponse(dict):
    """
    The number of spokes that are in a particular state and associated with a given hub.
    """
    def __init__(__self__, *,
                 count: str,
                 state: str):
        """
        The number of spokes that are in a particular state and associated with a given hub.
        :param str count: The total number of spokes that are in this state and associated with a given hub.
        :param str state: The state of the spokes.
        """
        pulumi.set(__self__, "count", count)
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter
    def count(self) -> str:
        """
        The total number of spokes that are in this state and associated with a given hub.
        """
        return pulumi.get(self, "count")

    @property
    @pulumi.getter
    def state(self) -> str:
        """
        The state of the spokes.
        """
        return pulumi.get(self, "state")


@pulumi.output_type
class SpokeStateReasonCountResponse(dict):
    """
    The number of spokes in the hub that are inactive for this reason.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "stateReasonCode":
            suggest = "state_reason_code"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SpokeStateReasonCountResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SpokeStateReasonCountResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SpokeStateReasonCountResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 count: str,
                 state_reason_code: str):
        """
        The number of spokes in the hub that are inactive for this reason.
        :param str count: The total number of spokes that are inactive for a particular reason and associated with a given hub.
        :param str state_reason_code: The reason that a spoke is inactive.
        """
        pulumi.set(__self__, "count", count)
        pulumi.set(__self__, "state_reason_code", state_reason_code)

    @property
    @pulumi.getter
    def count(self) -> str:
        """
        The total number of spokes that are inactive for a particular reason and associated with a given hub.
        """
        return pulumi.get(self, "count")

    @property
    @pulumi.getter(name="stateReasonCode")
    def state_reason_code(self) -> str:
        """
        The reason that a spoke is inactive.
        """
        return pulumi.get(self, "state_reason_code")


@pulumi.output_type
class SpokeSummaryResponse(dict):
    """
    Summarizes information about the spokes associated with a hub. The summary includes a count of spokes according to type and according to state. If any spokes are inactive, the summary also lists the reasons they are inactive, including a count for each reason.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "spokeStateCounts":
            suggest = "spoke_state_counts"
        elif key == "spokeStateReasonCounts":
            suggest = "spoke_state_reason_counts"
        elif key == "spokeTypeCounts":
            suggest = "spoke_type_counts"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SpokeSummaryResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SpokeSummaryResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SpokeSummaryResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 spoke_state_counts: Sequence['outputs.SpokeStateCountResponse'],
                 spoke_state_reason_counts: Sequence['outputs.SpokeStateReasonCountResponse'],
                 spoke_type_counts: Sequence['outputs.SpokeTypeCountResponse']):
        """
        Summarizes information about the spokes associated with a hub. The summary includes a count of spokes according to type and according to state. If any spokes are inactive, the summary also lists the reasons they are inactive, including a count for each reason.
        :param Sequence['SpokeStateCountResponse'] spoke_state_counts: Counts the number of spokes that are in each state and associated with a given hub.
        :param Sequence['SpokeStateReasonCountResponse'] spoke_state_reason_counts: Counts the number of spokes that are inactive for each possible reason and associated with a given hub.
        :param Sequence['SpokeTypeCountResponse'] spoke_type_counts: Counts the number of spokes of each type that are associated with a specific hub.
        """
        pulumi.set(__self__, "spoke_state_counts", spoke_state_counts)
        pulumi.set(__self__, "spoke_state_reason_counts", spoke_state_reason_counts)
        pulumi.set(__self__, "spoke_type_counts", spoke_type_counts)

    @property
    @pulumi.getter(name="spokeStateCounts")
    def spoke_state_counts(self) -> Sequence['outputs.SpokeStateCountResponse']:
        """
        Counts the number of spokes that are in each state and associated with a given hub.
        """
        return pulumi.get(self, "spoke_state_counts")

    @property
    @pulumi.getter(name="spokeStateReasonCounts")
    def spoke_state_reason_counts(self) -> Sequence['outputs.SpokeStateReasonCountResponse']:
        """
        Counts the number of spokes that are inactive for each possible reason and associated with a given hub.
        """
        return pulumi.get(self, "spoke_state_reason_counts")

    @property
    @pulumi.getter(name="spokeTypeCounts")
    def spoke_type_counts(self) -> Sequence['outputs.SpokeTypeCountResponse']:
        """
        Counts the number of spokes of each type that are associated with a specific hub.
        """
        return pulumi.get(self, "spoke_type_counts")


@pulumi.output_type
class SpokeTypeCountResponse(dict):
    """
    The number of spokes of a given type that are associated with a specific hub. The type indicates what kind of resource is associated with the spoke.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "spokeType":
            suggest = "spoke_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SpokeTypeCountResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SpokeTypeCountResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SpokeTypeCountResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 count: str,
                 spoke_type: str):
        """
        The number of spokes of a given type that are associated with a specific hub. The type indicates what kind of resource is associated with the spoke.
        :param str count: The total number of spokes of this type that are associated with the hub.
        :param str spoke_type: The type of the spokes.
        """
        pulumi.set(__self__, "count", count)
        pulumi.set(__self__, "spoke_type", spoke_type)

    @property
    @pulumi.getter
    def count(self) -> str:
        """
        The total number of spokes of this type that are associated with the hub.
        """
        return pulumi.get(self, "count")

    @property
    @pulumi.getter(name="spokeType")
    def spoke_type(self) -> str:
        """
        The type of the spokes.
        """
        return pulumi.get(self, "spoke_type")


@pulumi.output_type
class StateReasonResponse(dict):
    """
    The reason a spoke is inactive.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "userDetails":
            suggest = "user_details"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in StateReasonResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        StateReasonResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        StateReasonResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 code: str,
                 message: str,
                 user_details: str):
        """
        The reason a spoke is inactive.
        :param str code: The code associated with this reason.
        :param str message: Human-readable details about this reason.
        :param str user_details: Additional information provided by the user in the RejectSpoke call.
        """
        pulumi.set(__self__, "code", code)
        pulumi.set(__self__, "message", message)
        pulumi.set(__self__, "user_details", user_details)

    @property
    @pulumi.getter
    def code(self) -> str:
        """
        The code associated with this reason.
        """
        return pulumi.get(self, "code")

    @property
    @pulumi.getter
    def message(self) -> str:
        """
        Human-readable details about this reason.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter(name="userDetails")
    def user_details(self) -> str:
        """
        Additional information provided by the user in the RejectSpoke call.
        """
        return pulumi.get(self, "user_details")


@pulumi.output_type
class VirtualMachineResponse(dict):
    """
    VM instances to which this policy-based route applies to.
    """
    def __init__(__self__, *,
                 tags: Sequence[str]):
        """
        VM instances to which this policy-based route applies to.
        :param Sequence[str] tags: Optional. A list of VM instance tags the this policy-based route applies to. VM instances that have ANY of tags specified here will install this PBR.
        """
        pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def tags(self) -> Sequence[str]:
        """
        Optional. A list of VM instance tags the this policy-based route applies to. VM instances that have ANY of tags specified here will install this PBR.
        """
        return pulumi.get(self, "tags")


@pulumi.output_type
class WarningsResponse(dict):
    """
    Informational warning message.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "warningMessage":
            suggest = "warning_message"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in WarningsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        WarningsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        WarningsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 code: str,
                 data: Mapping[str, str],
                 warning_message: str):
        """
        Informational warning message.
        :param str code: A warning code, if applicable.
        :param Mapping[str, str] data: Metadata about this warning in key: value format. The key should provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be scope and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement.
        :param str warning_message: A human-readable description of the warning code.
        """
        pulumi.set(__self__, "code", code)
        pulumi.set(__self__, "data", data)
        pulumi.set(__self__, "warning_message", warning_message)

    @property
    @pulumi.getter
    def code(self) -> str:
        """
        A warning code, if applicable.
        """
        return pulumi.get(self, "code")

    @property
    @pulumi.getter
    def data(self) -> Mapping[str, str]:
        """
        Metadata about this warning in key: value format. The key should provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be scope and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement.
        """
        return pulumi.get(self, "data")

    @property
    @pulumi.getter(name="warningMessage")
    def warning_message(self) -> str:
        """
        A human-readable description of the warning code.
        """
        return pulumi.get(self, "warning_message")


