# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities

__all__ = [
    'GetGatewaySecurityPolicyResult',
    'AwaitableGetGatewaySecurityPolicyResult',
    'get_gateway_security_policy',
    'get_gateway_security_policy_output',
]

@pulumi.output_type
class GetGatewaySecurityPolicyResult:
    def __init__(__self__, create_time=None, description=None, name=None, tls_inspection_policy=None, update_time=None):
        if create_time and not isinstance(create_time, str):
            raise TypeError("Expected argument 'create_time' to be a str")
        pulumi.set(__self__, "create_time", create_time)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if tls_inspection_policy and not isinstance(tls_inspection_policy, str):
            raise TypeError("Expected argument 'tls_inspection_policy' to be a str")
        pulumi.set(__self__, "tls_inspection_policy", tls_inspection_policy)
        if update_time and not isinstance(update_time, str):
            raise TypeError("Expected argument 'update_time' to be a str")
        pulumi.set(__self__, "update_time", update_time)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The timestamp when the resource was created.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Optional. Free-text description of the resource.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the resource. Name is of the form projects/{project}/locations/{location}/gatewaySecurityPolicies/{gateway_security_policy} gateway_security_policy should match the pattern:(^[a-z]([a-z0-9-]{0,61}[a-z0-9])?$).
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="tlsInspectionPolicy")
    def tls_inspection_policy(self) -> str:
        """
        Optional. Name of a TLS Inspection Policy resource that defines how TLS inspection will be performed for any rule(s) which enables it.
        """
        return pulumi.get(self, "tls_inspection_policy")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> str:
        """
        The timestamp when the resource was updated.
        """
        return pulumi.get(self, "update_time")


class AwaitableGetGatewaySecurityPolicyResult(GetGatewaySecurityPolicyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetGatewaySecurityPolicyResult(
            create_time=self.create_time,
            description=self.description,
            name=self.name,
            tls_inspection_policy=self.tls_inspection_policy,
            update_time=self.update_time)


def get_gateway_security_policy(gateway_security_policy_id: Optional[str] = None,
                                location: Optional[str] = None,
                                project: Optional[str] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetGatewaySecurityPolicyResult:
    """
    Gets details of a single GatewaySecurityPolicy.
    """
    __args__ = dict()
    __args__['gatewaySecurityPolicyId'] = gateway_security_policy_id
    __args__['location'] = location
    __args__['project'] = project
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('google-native:networksecurity/v1:getGatewaySecurityPolicy', __args__, opts=opts, typ=GetGatewaySecurityPolicyResult).value

    return AwaitableGetGatewaySecurityPolicyResult(
        create_time=pulumi.get(__ret__, 'create_time'),
        description=pulumi.get(__ret__, 'description'),
        name=pulumi.get(__ret__, 'name'),
        tls_inspection_policy=pulumi.get(__ret__, 'tls_inspection_policy'),
        update_time=pulumi.get(__ret__, 'update_time'))


@_utilities.lift_output_func(get_gateway_security_policy)
def get_gateway_security_policy_output(gateway_security_policy_id: Optional[pulumi.Input[str]] = None,
                                       location: Optional[pulumi.Input[str]] = None,
                                       project: Optional[pulumi.Input[Optional[str]]] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetGatewaySecurityPolicyResult]:
    """
    Gets details of a single GatewaySecurityPolicy.
    """
    ...
