# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AptSettingsType',
    'ExecStepConfigInterpreter',
    'OSPolicyMode',
    'OSPolicyResourceExecResourceExecInterpreter',
    'OSPolicyResourceFileResourceState',
    'OSPolicyResourcePackageResourceDesiredState',
    'OSPolicyResourceRepositoryResourceAptRepositoryArchiveType',
    'PatchConfigRebootConfig',
    'PatchRolloutMode',
    'RecurringScheduleFrequency',
    'WeekDayOfMonthDayOfWeek',
    'WeeklyScheduleDayOfWeek',
    'WindowsUpdateSettingsClassificationsItem',
]


class AptSettingsType(str, Enum):
    """
    By changing the type to DIST, the patching is performed using `apt-get dist-upgrade` instead.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    By default, upgrade will be performed.
    """
    DIST = "DIST"
    """
    Runs `apt-get dist-upgrade`.
    """
    UPGRADE = "UPGRADE"
    """
    Runs `apt-get upgrade`.
    """


class ExecStepConfigInterpreter(str, Enum):
    """
    The script interpreter to use to run the script. If no interpreter is specified the script will be executed directly, which will likely only succeed for scripts with [shebang lines] (https://en.wikipedia.org/wiki/Shebang_\\(Unix\\)).
    """
    INTERPRETER_UNSPECIFIED = "INTERPRETER_UNSPECIFIED"
    """
    If the interpreter is not specified, the value defaults to `NONE`.
    """
    NONE = "NONE"
    """
    Indicates that the file is run as follows on each operating system: + For Linux VMs, the file is ran as an executable and the interpreter might be parsed from the [shebang line](https://wikipedia.org/wiki/Shebang_(Unix)) of the file. + For Windows VM, this value is not supported.
    """
    SHELL = "SHELL"
    """
    Indicates that the file is run with `/bin/sh` on Linux and `cmd` on Windows.
    """
    POWERSHELL = "POWERSHELL"
    """
    Indicates that the file is run with PowerShell.
    """


class OSPolicyMode(str, Enum):
    """
    Required. Policy mode
    """
    MODE_UNSPECIFIED = "MODE_UNSPECIFIED"
    """
    Invalid mode
    """
    VALIDATION = "VALIDATION"
    """
    This mode checks if the configuration resources in the policy are in their desired state. No actions are performed if they are not in the desired state. This mode is used for reporting purposes.
    """
    ENFORCEMENT = "ENFORCEMENT"
    """
    This mode checks if the configuration resources in the policy are in their desired state, and if not, enforces the desired state.
    """


class OSPolicyResourceExecResourceExecInterpreter(str, Enum):
    """
    Required. The script interpreter to use.
    """
    INTERPRETER_UNSPECIFIED = "INTERPRETER_UNSPECIFIED"
    """
    Invalid value, the request will return validation error.
    """
    NONE = "NONE"
    """
    If an interpreter is not specified, the source is executed directly. This execution, without an interpreter, only succeeds for executables and scripts that have shebang lines.
    """
    SHELL = "SHELL"
    """
    Indicates that the script runs with `/bin/sh` on Linux and `cmd.exe` on Windows.
    """
    POWERSHELL = "POWERSHELL"
    """
    Indicates that the script runs with PowerShell.
    """


class OSPolicyResourceFileResourceState(str, Enum):
    """
    Required. Desired state of the file.
    """
    DESIRED_STATE_UNSPECIFIED = "DESIRED_STATE_UNSPECIFIED"
    """
    Unspecified is invalid.
    """
    PRESENT = "PRESENT"
    """
    Ensure file at path is present.
    """
    ABSENT = "ABSENT"
    """
    Ensure file at path is absent.
    """
    CONTENTS_MATCH = "CONTENTS_MATCH"
    """
    Ensure the contents of the file at path matches. If the file does not exist it will be created.
    """


class OSPolicyResourcePackageResourceDesiredState(str, Enum):
    """
    Required. The desired state the agent should maintain for this package.
    """
    DESIRED_STATE_UNSPECIFIED = "DESIRED_STATE_UNSPECIFIED"
    """
    Unspecified is invalid.
    """
    INSTALLED = "INSTALLED"
    """
    Ensure that the package is installed.
    """
    REMOVED = "REMOVED"
    """
    The agent ensures that the package is not installed and uninstalls it if detected.
    """


class OSPolicyResourceRepositoryResourceAptRepositoryArchiveType(str, Enum):
    """
    Required. Type of archive files in this repository.
    """
    ARCHIVE_TYPE_UNSPECIFIED = "ARCHIVE_TYPE_UNSPECIFIED"
    """
    Unspecified is invalid.
    """
    DEB = "DEB"
    """
    Deb indicates that the archive contains binary files.
    """
    DEB_SRC = "DEB_SRC"
    """
    Deb-src indicates that the archive contains source files.
    """


class PatchConfigRebootConfig(str, Enum):
    """
    Post-patch reboot settings.
    """
    REBOOT_CONFIG_UNSPECIFIED = "REBOOT_CONFIG_UNSPECIFIED"
    """
    The default behavior is DEFAULT.
    """
    DEFAULT = "DEFAULT"
    """
    The agent decides if a reboot is necessary by checking signals such as registry keys on Windows or `/var/run/reboot-required` on APT based systems. On RPM based systems, a set of core system package install times are compared with system boot time.
    """
    ALWAYS = "ALWAYS"
    """
    Always reboot the machine after the update completes.
    """
    NEVER = "NEVER"
    """
    Never reboot the machine after the update completes.
    """


class PatchRolloutMode(str, Enum):
    """
    Mode of the patch rollout.
    """
    MODE_UNSPECIFIED = "MODE_UNSPECIFIED"
    """
    Mode must be specified.
    """
    ZONE_BY_ZONE = "ZONE_BY_ZONE"
    """
    Patches are applied one zone at a time. The patch job begins in the region with the lowest number of targeted VMs. Within the region, patching begins in the zone with the lowest number of targeted VMs. If multiple regions (or zones within a region) have the same number of targeted VMs, a tie-breaker is achieved by sorting the regions or zones in alphabetical order.
    """
    CONCURRENT_ZONES = "CONCURRENT_ZONES"
    """
    Patches are applied to VMs in all zones at the same time.
    """


class RecurringScheduleFrequency(str, Enum):
    """
    Required. The frequency unit of this recurring schedule.
    """
    FREQUENCY_UNSPECIFIED = "FREQUENCY_UNSPECIFIED"
    """
    Invalid. A frequency must be specified.
    """
    WEEKLY = "WEEKLY"
    """
    Indicates that the frequency of recurrence should be expressed in terms of weeks.
    """
    MONTHLY = "MONTHLY"
    """
    Indicates that the frequency of recurrence should be expressed in terms of months.
    """
    DAILY = "DAILY"
    """
    Indicates that the frequency of recurrence should be expressed in terms of days.
    """


class WeekDayOfMonthDayOfWeek(str, Enum):
    """
    Required. A day of the week.
    """
    DAY_OF_WEEK_UNSPECIFIED = "DAY_OF_WEEK_UNSPECIFIED"
    """
    The day of the week is unspecified.
    """
    MONDAY = "MONDAY"
    """
    Monday
    """
    TUESDAY = "TUESDAY"
    """
    Tuesday
    """
    WEDNESDAY = "WEDNESDAY"
    """
    Wednesday
    """
    THURSDAY = "THURSDAY"
    """
    Thursday
    """
    FRIDAY = "FRIDAY"
    """
    Friday
    """
    SATURDAY = "SATURDAY"
    """
    Saturday
    """
    SUNDAY = "SUNDAY"
    """
    Sunday
    """


class WeeklyScheduleDayOfWeek(str, Enum):
    """
    Required. Day of the week.
    """
    DAY_OF_WEEK_UNSPECIFIED = "DAY_OF_WEEK_UNSPECIFIED"
    """
    The day of the week is unspecified.
    """
    MONDAY = "MONDAY"
    """
    Monday
    """
    TUESDAY = "TUESDAY"
    """
    Tuesday
    """
    WEDNESDAY = "WEDNESDAY"
    """
    Wednesday
    """
    THURSDAY = "THURSDAY"
    """
    Thursday
    """
    FRIDAY = "FRIDAY"
    """
    Friday
    """
    SATURDAY = "SATURDAY"
    """
    Saturday
    """
    SUNDAY = "SUNDAY"
    """
    Sunday
    """


class WindowsUpdateSettingsClassificationsItem(str, Enum):
    CLASSIFICATION_UNSPECIFIED = "CLASSIFICATION_UNSPECIFIED"
    """
    Invalid. If classifications are included, they must be specified.
    """
    CRITICAL = "CRITICAL"
    """
    "A widely released fix for a specific problem that addresses a critical, non-security-related bug." [1]
    """
    SECURITY = "SECURITY"
    """
    "A widely released fix for a product-specific, security-related vulnerability. Security vulnerabilities are rated by their severity. The severity rating is indicated in the Microsoft security bulletin as critical, important, moderate, or low." [1]
    """
    DEFINITION = "DEFINITION"
    """
    "A widely released and frequent software update that contains additions to a product's definition database. Definition databases are often used to detect objects that have specific attributes, such as malicious code, phishing websites, or junk mail." [1]
    """
    DRIVER = "DRIVER"
    """
    "Software that controls the input and output of a device." [1]
    """
    FEATURE_PACK = "FEATURE_PACK"
    """
    "New product functionality that is first distributed outside the context of a product release and that is typically included in the next full product release." [1]
    """
    SERVICE_PACK = "SERVICE_PACK"
    """
    "A tested, cumulative set of all hotfixes, security updates, critical updates, and updates. Additionally, service packs may contain additional fixes for problems that are found internally since the release of the product. Service packs my also contain a limited number of customer-requested design changes or features." [1]
    """
    TOOL = "TOOL"
    """
    "A utility or feature that helps complete a task or set of tasks." [1]
    """
    UPDATE_ROLLUP = "UPDATE_ROLLUP"
    """
    "A tested, cumulative set of hotfixes, security updates, critical updates, and updates that are packaged together for easy deployment. A rollup generally targets a specific area, such as security, or a component of a product, such as Internet Information Services (IIS)." [1]
    """
    UPDATE = "UPDATE"
    """
    "A widely released fix for a specific problem. An update addresses a noncritical, non-security-related bug." [1]
    """
