# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ControlSearchSolutionUseCaseItem',
    'ControlSolutionTypesItem',
    'GoogleCloudRetailV2ModelFrequentlyBoughtTogetherFeaturesConfigContextProductsType',
    'GoogleCloudRetailV2SearchRequestDynamicFacetSpecMode',
    'GoogleCloudRetailV2SearchRequestPersonalizationSpecMode',
    'ModelFilteringOption',
    'ModelPeriodicTuningState',
    'ModelTrainingState',
    'ProductAvailability',
    'ProductType',
    'ServingConfigDiversityType',
    'ServingConfigSolutionTypesItem',
]


class ControlSearchSolutionUseCaseItem(str, Enum):
    SEARCH_SOLUTION_USE_CASE_UNSPECIFIED = "SEARCH_SOLUTION_USE_CASE_UNSPECIFIED"
    """
    The value when it's unspecified. In this case, server behavior defaults to SEARCH_SOLUTION_USE_CASE_SEARCH.
    """
    SEARCH_SOLUTION_USE_CASE_SEARCH = "SEARCH_SOLUTION_USE_CASE_SEARCH"
    """
    Search use case. Expects the traffic has a non-empty query.
    """
    SEARCH_SOLUTION_USE_CASE_BROWSE = "SEARCH_SOLUTION_USE_CASE_BROWSE"
    """
    Browse use case. Expects the traffic has an empty query.
    """


class ControlSolutionTypesItem(str, Enum):
    SOLUTION_TYPE_UNSPECIFIED = "SOLUTION_TYPE_UNSPECIFIED"
    """
    Default value.
    """
    SOLUTION_TYPE_RECOMMENDATION = "SOLUTION_TYPE_RECOMMENDATION"
    """
    Used for Recommendations AI.
    """
    SOLUTION_TYPE_SEARCH = "SOLUTION_TYPE_SEARCH"
    """
    Used for Retail Search.
    """


class GoogleCloudRetailV2ModelFrequentlyBoughtTogetherFeaturesConfigContextProductsType(str, Enum):
    """
    Optional. Specifies the context of the model when it is used in predict requests. Can only be set for the `frequently-bought-together` type. If it isn't specified, it defaults to MULTIPLE_CONTEXT_PRODUCTS.
    """
    CONTEXT_PRODUCTS_TYPE_UNSPECIFIED = "CONTEXT_PRODUCTS_TYPE_UNSPECIFIED"
    """
    Unspecified default value, should never be explicitly set. Defaults to MULTIPLE_CONTEXT_PRODUCTS.
    """
    SINGLE_CONTEXT_PRODUCT = "SINGLE_CONTEXT_PRODUCT"
    """
    Use only a single product as context for the recommendation. Typically used on pages like add-to-cart or product details.
    """
    MULTIPLE_CONTEXT_PRODUCTS = "MULTIPLE_CONTEXT_PRODUCTS"
    """
    Use one or multiple products as context for the recommendation. Typically used on shopping cart pages.
    """


class GoogleCloudRetailV2SearchRequestDynamicFacetSpecMode(str, Enum):
    """
    Mode of the DynamicFacet feature. Defaults to Mode.DISABLED if it's unset.
    """
    MODE_UNSPECIFIED = "MODE_UNSPECIFIED"
    """
    Default value.
    """
    DISABLED = "DISABLED"
    """
    Disable Dynamic Facet.
    """
    ENABLED = "ENABLED"
    """
    Automatic mode built by Google Retail Search.
    """


class GoogleCloudRetailV2SearchRequestPersonalizationSpecMode(str, Enum):
    """
    Defaults to Mode.AUTO.
    """
    MODE_UNSPECIFIED = "MODE_UNSPECIFIED"
    """
    Default value. In this case, server behavior defaults to Mode.AUTO.
    """
    AUTO = "AUTO"
    """
    Let CRS decide whether to use personalization based on quality of user event data.
    """
    DISABLED = "DISABLED"
    """
    Disable personalization.
    """


class ModelFilteringOption(str, Enum):
    """
    Optional. If `RECOMMENDATIONS_FILTERING_ENABLED`, recommendation filtering by attributes is enabled for the model.
    """
    RECOMMENDATIONS_FILTERING_OPTION_UNSPECIFIED = "RECOMMENDATIONS_FILTERING_OPTION_UNSPECIFIED"
    """
    Value used when unset. In this case, server behavior defaults to RECOMMENDATIONS_FILTERING_DISABLED.
    """
    RECOMMENDATIONS_FILTERING_DISABLED = "RECOMMENDATIONS_FILTERING_DISABLED"
    """
    Recommendation filtering is disabled.
    """
    RECOMMENDATIONS_FILTERING_ENABLED = "RECOMMENDATIONS_FILTERING_ENABLED"
    """
    Recommendation filtering is enabled.
    """


class ModelPeriodicTuningState(str, Enum):
    """
    Optional. The state of periodic tuning. The period we use is 3 months - to do a one-off tune earlier use the `TuneModel` method. Default value is `PERIODIC_TUNING_ENABLED`.
    """
    PERIODIC_TUNING_STATE_UNSPECIFIED = "PERIODIC_TUNING_STATE_UNSPECIFIED"
    """
    Unspecified default value, should never be explicitly set.
    """
    PERIODIC_TUNING_DISABLED = "PERIODIC_TUNING_DISABLED"
    """
    The model has periodic tuning disabled. Tuning can be reenabled by calling the `EnableModelPeriodicTuning` method or by calling the `TuneModel` method.
    """
    ALL_TUNING_DISABLED = "ALL_TUNING_DISABLED"
    """
    The model cannot be tuned with periodic tuning OR the `TuneModel` method. Hide the options in customer UI and reject any requests through the backend self serve API.
    """
    PERIODIC_TUNING_ENABLED = "PERIODIC_TUNING_ENABLED"
    """
    The model has periodic tuning enabled. Tuning can be disabled by calling the `DisableModelPeriodicTuning` method.
    """


class ModelTrainingState(str, Enum):
    """
    Optional. The training state that the model is in (e.g. `TRAINING` or `PAUSED`). Since part of the cost of running the service is frequency of training - this can be used to determine when to train model in order to control cost. If not specified: the default value for `CreateModel` method is `TRAINING`. The default value for `UpdateModel` method is to keep the state the same as before.
    """
    TRAINING_STATE_UNSPECIFIED = "TRAINING_STATE_UNSPECIFIED"
    """
    Unspecified training state.
    """
    PAUSED = "PAUSED"
    """
    The model training is paused.
    """
    TRAINING = "TRAINING"
    """
    The model is training.
    """


class ProductAvailability(str, Enum):
    """
    The online availability of the Product. Default to Availability.IN_STOCK. Corresponding properties: Google Merchant Center property [availability](https://support.google.com/merchants/answer/6324448). Schema.org property [Offer.availability](https://schema.org/availability).
    """
    AVAILABILITY_UNSPECIFIED = "AVAILABILITY_UNSPECIFIED"
    """
    Default product availability. Default to Availability.IN_STOCK if unset.
    """
    IN_STOCK = "IN_STOCK"
    """
    Product in stock.
    """
    OUT_OF_STOCK = "OUT_OF_STOCK"
    """
    Product out of stock.
    """
    PREORDER = "PREORDER"
    """
    Product that is in pre-order state.
    """
    BACKORDER = "BACKORDER"
    """
    Product that is back-ordered (i.e. temporarily out of stock).
    """


class ProductType(str, Enum):
    """
    Immutable. The type of the product. Default to Catalog.product_level_config.ingestion_product_type if unset.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Default value. Default to Catalog.product_level_config.ingestion_product_type if unset.
    """
    PRIMARY = "PRIMARY"
    """
    The primary type. As the primary unit for predicting, indexing and search serving, a Type.PRIMARY Product is grouped with multiple Type.VARIANT Products.
    """
    VARIANT = "VARIANT"
    """
    The variant type. Type.VARIANT Products usually share some common attributes on the same Type.PRIMARY Products, but they have variant attributes like different colors, sizes and prices, etc.
    """
    COLLECTION = "COLLECTION"
    """
    The collection type. Collection products are bundled Type.PRIMARY Products or Type.VARIANT Products that are sold together, such as a jewelry set with necklaces, earrings and rings, etc.
    """


class ServingConfigDiversityType(str, Enum):
    """
    What kind of diversity to use - data driven or rule based. If unset, the server behavior defaults to RULE_BASED_DIVERSITY.
    """
    DIVERSITY_TYPE_UNSPECIFIED = "DIVERSITY_TYPE_UNSPECIFIED"
    """
    Default value.
    """
    RULE_BASED_DIVERSITY = "RULE_BASED_DIVERSITY"
    """
    Rule based diversity.
    """
    DATA_DRIVEN_DIVERSITY = "DATA_DRIVEN_DIVERSITY"
    """
    Data driven diversity.
    """


class ServingConfigSolutionTypesItem(str, Enum):
    SOLUTION_TYPE_UNSPECIFIED = "SOLUTION_TYPE_UNSPECIFIED"
    """
    Default value.
    """
    SOLUTION_TYPE_RECOMMENDATION = "SOLUTION_TYPE_RECOMMENDATION"
    """
    Used for Recommendations AI.
    """
    SOLUTION_TYPE_SEARCH = "SOLUTION_TYPE_SEARCH"
    """
    Used for Retail Search.
    """
