# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ApiSyntax',
    'AuditLogConfigLogType',
    'BackendRulePathTranslation',
    'ClientLibrarySettingsLaunchStage',
    'CommonLanguageSettingsDestinationsItem',
    'EnumSyntax',
    'FieldCardinality',
    'FieldKind',
    'LabelDescriptorValueType',
    'MethodSyntax',
    'MetricDescriptorLaunchStage',
    'MetricDescriptorMetadataLaunchStage',
    'MetricDescriptorMetricKind',
    'MetricDescriptorValueType',
    'MonitoredResourceDescriptorLaunchStage',
    'PublishingOrganization',
    'RolloutStatus',
    'TypeSyntax',
]


class ApiSyntax(str, Enum):
    """
    The source syntax of the service.
    """
    SYNTAX_PROTO2 = "SYNTAX_PROTO2"
    """
    Syntax `proto2`.
    """
    SYNTAX_PROTO3 = "SYNTAX_PROTO3"
    """
    Syntax `proto3`.
    """
    SYNTAX_EDITIONS = "SYNTAX_EDITIONS"
    """
    Syntax `editions`.
    """


class AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """


class BackendRulePathTranslation(str, Enum):
    PATH_TRANSLATION_UNSPECIFIED = "PATH_TRANSLATION_UNSPECIFIED"
    CONSTANT_ADDRESS = "CONSTANT_ADDRESS"
    """
    Use the backend address as-is, with no modification to the path. If the URL pattern contains variables, the variable names and values will be appended to the query string. If a query string parameter and a URL pattern variable have the same name, this may result in duplicate keys in the query string. # Examples Given the following operation config: Method path: /api/company/{cid}/user/{uid} Backend address: https://example.cloudfunctions.net/getUser Requests to the following request paths will call the backend at the translated path: Request path: /api/company/widgetworks/user/johndoe Translated: https://example.cloudfunctions.net/getUser?cid=widgetworks&uid=johndoe Request path: /api/company/widgetworks/user/johndoe?timezone=EST Translated: https://example.cloudfunctions.net/getUser?timezone=EST&cid=widgetworks&uid=johndoe
    """
    APPEND_PATH_TO_ADDRESS = "APPEND_PATH_TO_ADDRESS"
    """
    The request path will be appended to the backend address. # Examples Given the following operation config: Method path: /api/company/{cid}/user/{uid} Backend address: https://example.appspot.com Requests to the following request paths will call the backend at the translated path: Request path: /api/company/widgetworks/user/johndoe Translated: https://example.appspot.com/api/company/widgetworks/user/johndoe Request path: /api/company/widgetworks/user/johndoe?timezone=EST Translated: https://example.appspot.com/api/company/widgetworks/user/johndoe?timezone=EST
    """


class ClientLibrarySettingsLaunchStage(str, Enum):
    """
    Launch stage of this version of the API.
    """
    LAUNCH_STAGE_UNSPECIFIED = "LAUNCH_STAGE_UNSPECIFIED"
    """
    Do not use this default value.
    """
    UNIMPLEMENTED = "UNIMPLEMENTED"
    """
    The feature is not yet implemented. Users can not use it.
    """
    PRELAUNCH = "PRELAUNCH"
    """
    Prelaunch features are hidden from users and are only visible internally.
    """
    EARLY_ACCESS = "EARLY_ACCESS"
    """
    Early Access features are limited to a closed group of testers. To use these features, you must sign up in advance and sign a Trusted Tester agreement (which includes confidentiality provisions). These features may be unstable, changed in backward-incompatible ways, and are not guaranteed to be released.
    """
    ALPHA = "ALPHA"
    """
    Alpha is a limited availability test for releases before they are cleared for widespread use. By Alpha, all significant design issues are resolved and we are in the process of verifying functionality. Alpha customers need to apply for access, agree to applicable terms, and have their projects allowlisted. Alpha releases don't have to be feature complete, no SLAs are provided, and there are no technical support obligations, but they will be far enough along that customers can actually use them in test environments or for limited-use tests -- just like they would in normal production cases.
    """
    BETA = "BETA"
    """
    Beta is the point at which we are ready to open a release for any customer to use. There are no SLA or technical support obligations in a Beta release. Products will be complete from a feature perspective, but may have some open outstanding issues. Beta releases are suitable for limited production use cases.
    """
    GA = "GA"
    """
    GA features are open to all developers and are considered stable and fully qualified for production use.
    """
    DEPRECATED = "DEPRECATED"
    """
    Deprecated features are scheduled to be shut down and removed. For more information, see the "Deprecation Policy" section of our [Terms of Service](https://cloud.google.com/terms/) and the [Google Cloud Platform Subject to the Deprecation Policy](https://cloud.google.com/terms/deprecation) documentation.
    """


class CommonLanguageSettingsDestinationsItem(str, Enum):
    CLIENT_LIBRARY_DESTINATION_UNSPECIFIED = "CLIENT_LIBRARY_DESTINATION_UNSPECIFIED"
    """
    Client libraries will neither be generated nor published to package managers.
    """
    GITHUB = "GITHUB"
    """
    Generate the client library in a repo under github.com/googleapis, but don't publish it to package managers.
    """
    PACKAGE_MANAGER = "PACKAGE_MANAGER"
    """
    Publish the library to package managers like nuget.org and npmjs.com.
    """


class EnumSyntax(str, Enum):
    """
    The source syntax.
    """
    SYNTAX_PROTO2 = "SYNTAX_PROTO2"
    """
    Syntax `proto2`.
    """
    SYNTAX_PROTO3 = "SYNTAX_PROTO3"
    """
    Syntax `proto3`.
    """
    SYNTAX_EDITIONS = "SYNTAX_EDITIONS"
    """
    Syntax `editions`.
    """


class FieldCardinality(str, Enum):
    """
    The field cardinality.
    """
    CARDINALITY_UNKNOWN = "CARDINALITY_UNKNOWN"
    """
    For fields with unknown cardinality.
    """
    CARDINALITY_OPTIONAL = "CARDINALITY_OPTIONAL"
    """
    For optional fields.
    """
    CARDINALITY_REQUIRED = "CARDINALITY_REQUIRED"
    """
    For required fields. Proto2 syntax only.
    """
    CARDINALITY_REPEATED = "CARDINALITY_REPEATED"
    """
    For repeated fields.
    """


class FieldKind(str, Enum):
    """
    The field type.
    """
    TYPE_UNKNOWN = "TYPE_UNKNOWN"
    """
    Field type unknown.
    """
    TYPE_DOUBLE = "TYPE_DOUBLE"
    """
    Field type double.
    """
    TYPE_FLOAT = "TYPE_FLOAT"
    """
    Field type float.
    """
    TYPE_INT64 = "TYPE_INT64"
    """
    Field type int64.
    """
    TYPE_UINT64 = "TYPE_UINT64"
    """
    Field type uint64.
    """
    TYPE_INT32 = "TYPE_INT32"
    """
    Field type int32.
    """
    TYPE_FIXED64 = "TYPE_FIXED64"
    """
    Field type fixed64.
    """
    TYPE_FIXED32 = "TYPE_FIXED32"
    """
    Field type fixed32.
    """
    TYPE_BOOL = "TYPE_BOOL"
    """
    Field type bool.
    """
    TYPE_STRING = "TYPE_STRING"
    """
    Field type string.
    """
    TYPE_GROUP = "TYPE_GROUP"
    """
    Field type group. Proto2 syntax only, and deprecated.
    """
    TYPE_MESSAGE = "TYPE_MESSAGE"
    """
    Field type message.
    """
    TYPE_BYTES = "TYPE_BYTES"
    """
    Field type bytes.
    """
    TYPE_UINT32 = "TYPE_UINT32"
    """
    Field type uint32.
    """
    TYPE_ENUM = "TYPE_ENUM"
    """
    Field type enum.
    """
    TYPE_SFIXED32 = "TYPE_SFIXED32"
    """
    Field type sfixed32.
    """
    TYPE_SFIXED64 = "TYPE_SFIXED64"
    """
    Field type sfixed64.
    """
    TYPE_SINT32 = "TYPE_SINT32"
    """
    Field type sint32.
    """
    TYPE_SINT64 = "TYPE_SINT64"
    """
    Field type sint64.
    """


class LabelDescriptorValueType(str, Enum):
    """
    The type of data that can be assigned to the label.
    """
    STRING = "STRING"
    """
    A variable-length string. This is the default.
    """
    BOOL = "BOOL"
    """
    Boolean; true or false.
    """
    INT64 = "INT64"
    """
    A 64-bit signed integer.
    """


class MethodSyntax(str, Enum):
    """
    The source syntax of this method.
    """
    SYNTAX_PROTO2 = "SYNTAX_PROTO2"
    """
    Syntax `proto2`.
    """
    SYNTAX_PROTO3 = "SYNTAX_PROTO3"
    """
    Syntax `proto3`.
    """
    SYNTAX_EDITIONS = "SYNTAX_EDITIONS"
    """
    Syntax `editions`.
    """


class MetricDescriptorLaunchStage(str, Enum):
    """
    Optional. The launch stage of the metric definition.
    """
    LAUNCH_STAGE_UNSPECIFIED = "LAUNCH_STAGE_UNSPECIFIED"
    """
    Do not use this default value.
    """
    UNIMPLEMENTED = "UNIMPLEMENTED"
    """
    The feature is not yet implemented. Users can not use it.
    """
    PRELAUNCH = "PRELAUNCH"
    """
    Prelaunch features are hidden from users and are only visible internally.
    """
    EARLY_ACCESS = "EARLY_ACCESS"
    """
    Early Access features are limited to a closed group of testers. To use these features, you must sign up in advance and sign a Trusted Tester agreement (which includes confidentiality provisions). These features may be unstable, changed in backward-incompatible ways, and are not guaranteed to be released.
    """
    ALPHA = "ALPHA"
    """
    Alpha is a limited availability test for releases before they are cleared for widespread use. By Alpha, all significant design issues are resolved and we are in the process of verifying functionality. Alpha customers need to apply for access, agree to applicable terms, and have their projects allowlisted. Alpha releases don't have to be feature complete, no SLAs are provided, and there are no technical support obligations, but they will be far enough along that customers can actually use them in test environments or for limited-use tests -- just like they would in normal production cases.
    """
    BETA = "BETA"
    """
    Beta is the point at which we are ready to open a release for any customer to use. There are no SLA or technical support obligations in a Beta release. Products will be complete from a feature perspective, but may have some open outstanding issues. Beta releases are suitable for limited production use cases.
    """
    GA = "GA"
    """
    GA features are open to all developers and are considered stable and fully qualified for production use.
    """
    DEPRECATED = "DEPRECATED"
    """
    Deprecated features are scheduled to be shut down and removed. For more information, see the "Deprecation Policy" section of our [Terms of Service](https://cloud.google.com/terms/) and the [Google Cloud Platform Subject to the Deprecation Policy](https://cloud.google.com/terms/deprecation) documentation.
    """


class MetricDescriptorMetadataLaunchStage(str, Enum):
    """
    Deprecated. Must use the MetricDescriptor.launch_stage instead.
    """
    LAUNCH_STAGE_UNSPECIFIED = "LAUNCH_STAGE_UNSPECIFIED"
    """
    Do not use this default value.
    """
    UNIMPLEMENTED = "UNIMPLEMENTED"
    """
    The feature is not yet implemented. Users can not use it.
    """
    PRELAUNCH = "PRELAUNCH"
    """
    Prelaunch features are hidden from users and are only visible internally.
    """
    EARLY_ACCESS = "EARLY_ACCESS"
    """
    Early Access features are limited to a closed group of testers. To use these features, you must sign up in advance and sign a Trusted Tester agreement (which includes confidentiality provisions). These features may be unstable, changed in backward-incompatible ways, and are not guaranteed to be released.
    """
    ALPHA = "ALPHA"
    """
    Alpha is a limited availability test for releases before they are cleared for widespread use. By Alpha, all significant design issues are resolved and we are in the process of verifying functionality. Alpha customers need to apply for access, agree to applicable terms, and have their projects allowlisted. Alpha releases don't have to be feature complete, no SLAs are provided, and there are no technical support obligations, but they will be far enough along that customers can actually use them in test environments or for limited-use tests -- just like they would in normal production cases.
    """
    BETA = "BETA"
    """
    Beta is the point at which we are ready to open a release for any customer to use. There are no SLA or technical support obligations in a Beta release. Products will be complete from a feature perspective, but may have some open outstanding issues. Beta releases are suitable for limited production use cases.
    """
    GA = "GA"
    """
    GA features are open to all developers and are considered stable and fully qualified for production use.
    """
    DEPRECATED = "DEPRECATED"
    """
    Deprecated features are scheduled to be shut down and removed. For more information, see the "Deprecation Policy" section of our [Terms of Service](https://cloud.google.com/terms/) and the [Google Cloud Platform Subject to the Deprecation Policy](https://cloud.google.com/terms/deprecation) documentation.
    """


class MetricDescriptorMetricKind(str, Enum):
    """
    Whether the metric records instantaneous values, changes to a value, etc. Some combinations of `metric_kind` and `value_type` might not be supported.
    """
    METRIC_KIND_UNSPECIFIED = "METRIC_KIND_UNSPECIFIED"
    """
    Do not use this default value.
    """
    GAUGE = "GAUGE"
    """
    An instantaneous measurement of a value.
    """
    DELTA = "DELTA"
    """
    The change in a value during a time interval.
    """
    CUMULATIVE = "CUMULATIVE"
    """
    A value accumulated over a time interval. Cumulative measurements in a time series should have the same start time and increasing end times, until an event resets the cumulative value to zero and sets a new start time for the following points.
    """


class MetricDescriptorValueType(str, Enum):
    """
    Whether the measurement is an integer, a floating-point number, etc. Some combinations of `metric_kind` and `value_type` might not be supported.
    """
    VALUE_TYPE_UNSPECIFIED = "VALUE_TYPE_UNSPECIFIED"
    """
    Do not use this default value.
    """
    BOOL = "BOOL"
    """
    The value is a boolean. This value type can be used only if the metric kind is `GAUGE`.
    """
    INT64 = "INT64"
    """
    The value is a signed 64-bit integer.
    """
    DOUBLE = "DOUBLE"
    """
    The value is a double precision floating point number.
    """
    STRING = "STRING"
    """
    The value is a text string. This value type can be used only if the metric kind is `GAUGE`.
    """
    DISTRIBUTION = "DISTRIBUTION"
    """
    The value is a `Distribution`.
    """
    MONEY = "MONEY"
    """
    The value is money.
    """


class MonitoredResourceDescriptorLaunchStage(str, Enum):
    """
    Optional. The launch stage of the monitored resource definition.
    """
    LAUNCH_STAGE_UNSPECIFIED = "LAUNCH_STAGE_UNSPECIFIED"
    """
    Do not use this default value.
    """
    UNIMPLEMENTED = "UNIMPLEMENTED"
    """
    The feature is not yet implemented. Users can not use it.
    """
    PRELAUNCH = "PRELAUNCH"
    """
    Prelaunch features are hidden from users and are only visible internally.
    """
    EARLY_ACCESS = "EARLY_ACCESS"
    """
    Early Access features are limited to a closed group of testers. To use these features, you must sign up in advance and sign a Trusted Tester agreement (which includes confidentiality provisions). These features may be unstable, changed in backward-incompatible ways, and are not guaranteed to be released.
    """
    ALPHA = "ALPHA"
    """
    Alpha is a limited availability test for releases before they are cleared for widespread use. By Alpha, all significant design issues are resolved and we are in the process of verifying functionality. Alpha customers need to apply for access, agree to applicable terms, and have their projects allowlisted. Alpha releases don't have to be feature complete, no SLAs are provided, and there are no technical support obligations, but they will be far enough along that customers can actually use them in test environments or for limited-use tests -- just like they would in normal production cases.
    """
    BETA = "BETA"
    """
    Beta is the point at which we are ready to open a release for any customer to use. There are no SLA or technical support obligations in a Beta release. Products will be complete from a feature perspective, but may have some open outstanding issues. Beta releases are suitable for limited production use cases.
    """
    GA = "GA"
    """
    GA features are open to all developers and are considered stable and fully qualified for production use.
    """
    DEPRECATED = "DEPRECATED"
    """
    Deprecated features are scheduled to be shut down and removed. For more information, see the "Deprecation Policy" section of our [Terms of Service](https://cloud.google.com/terms/) and the [Google Cloud Platform Subject to the Deprecation Policy](https://cloud.google.com/terms/deprecation) documentation.
    """


class PublishingOrganization(str, Enum):
    """
    For whom the client library is being published.
    """
    CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED = "CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED"
    """
    Not useful.
    """
    CLOUD = "CLOUD"
    """
    Google Cloud Platform Org.
    """
    ADS = "ADS"
    """
    Ads (Advertising) Org.
    """
    PHOTOS = "PHOTOS"
    """
    Photos Org.
    """
    STREET_VIEW = "STREET_VIEW"
    """
    Street View Org.
    """
    SHOPPING = "SHOPPING"
    """
    Shopping Org.
    """
    GEO = "GEO"
    """
    Geo Org.
    """
    GENERATIVE_AI = "GENERATIVE_AI"
    """
    Generative AI - https://developers.generativeai.google
    """


class RolloutStatus(str, Enum):
    """
    The status of this rollout. Readonly. In case of a failed rollout, the system will automatically rollback to the current Rollout version. Readonly.
    """
    ROLLOUT_STATUS_UNSPECIFIED = "ROLLOUT_STATUS_UNSPECIFIED"
    """
    No status specified.
    """
    IN_PROGRESS = "IN_PROGRESS"
    """
    The Rollout is in progress.
    """
    SUCCESS = "SUCCESS"
    """
    The Rollout has completed successfully.
    """
    CANCELLED = "CANCELLED"
    """
    The Rollout has been cancelled. This can happen if you have overlapping Rollout pushes, and the previous ones will be cancelled.
    """
    FAILED = "FAILED"
    """
    The Rollout has failed and the rollback attempt has failed too.
    """
    PENDING = "PENDING"
    """
    The Rollout has not started yet and is pending for execution.
    """
    FAILED_ROLLED_BACK = "FAILED_ROLLED_BACK"
    """
    The Rollout has failed and rolled back to the previous successful Rollout.
    """


class TypeSyntax(str, Enum):
    """
    The source syntax.
    """
    SYNTAX_PROTO2 = "SYNTAX_PROTO2"
    """
    Syntax `proto2`.
    """
    SYNTAX_PROTO3 = "SYNTAX_PROTO3"
    """
    Syntax `proto3`.
    """
    SYNTAX_EDITIONS = "SYNTAX_EDITIONS"
    """
    Syntax `editions`.
    """
