# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AndroidInstrumentationTestOrchestratorOption',
    'AndroidRoboTestRoboMode',
    'RoboDirectiveActionType',
]


class AndroidInstrumentationTestOrchestratorOption(str, Enum):
    """
    The option of whether running each test within its own invocation of instrumentation with Android Test Orchestrator or not. ** Orchestrator is only compatible with AndroidJUnitRunner version 1.1 or higher! ** Orchestrator offers the following benefits: - No shared state - Crashes are isolated - Logs are scoped per test See for more information about Android Test Orchestrator. If not set, the test will be run without the orchestrator.
    """
    ORCHESTRATOR_OPTION_UNSPECIFIED = "ORCHESTRATOR_OPTION_UNSPECIFIED"
    """
    Default value: the server will choose the mode. Currently implies that the test will run without the orchestrator. In the future, all instrumentation tests will be run with the orchestrator. Using the orchestrator is highly encouraged because of all the benefits it offers.
    """
    USE_ORCHESTRATOR = "USE_ORCHESTRATOR"
    """
    Run test using orchestrator. ** Only compatible with AndroidJUnitRunner version 1.1 or higher! ** Recommended.
    """
    DO_NOT_USE_ORCHESTRATOR = "DO_NOT_USE_ORCHESTRATOR"
    """
    Run test without using orchestrator.
    """


class AndroidRoboTestRoboMode(str, Enum):
    """
    The mode in which Robo should run. Most clients should allow the server to populate this field automatically.
    """
    ROBO_MODE_UNSPECIFIED = "ROBO_MODE_UNSPECIFIED"
    """
    This means that the server should choose the mode. Recommended.
    """
    ROBO_VERSION1 = "ROBO_VERSION_1"
    """
    Runs Robo in UIAutomator-only mode without app resigning
    """
    ROBO_VERSION2 = "ROBO_VERSION_2"
    """
    Runs Robo in standard Espresso with UIAutomator fallback
    """


class RoboDirectiveActionType(str, Enum):
    """
    Required. The type of action that Robo should perform on the specified element.
    """
    ACTION_TYPE_UNSPECIFIED = "ACTION_TYPE_UNSPECIFIED"
    """
    DO NOT USE. For proto versioning only.
    """
    SINGLE_CLICK = "SINGLE_CLICK"
    """
    Direct Robo to click on the specified element. No-op if specified element is not clickable.
    """
    ENTER_TEXT = "ENTER_TEXT"
    """
    Direct Robo to enter text on the specified element. No-op if specified element is not enabled or does not allow text entry.
    """
    IGNORE = "IGNORE"
    """
    Direct Robo to ignore interactions with a specific element.
    """
