# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AnimationFadeFadeType',
    'DashConfigSegmentReferenceScheme',
    'JobMode',
    'JobOptimization',
    'ManifestType',
]


class AnimationFadeFadeType(str, Enum):
    """
    Required. Type of fade animation: `FADE_IN` or `FADE_OUT`.
    """
    FADE_TYPE_UNSPECIFIED = "FADE_TYPE_UNSPECIFIED"
    """
    The fade type is not specified.
    """
    FADE_IN = "FADE_IN"
    """
    Fade the overlay object into view.
    """
    FADE_OUT = "FADE_OUT"
    """
    Fade the overlay object out of view.
    """


class DashConfigSegmentReferenceScheme(str, Enum):
    """
    The segment reference scheme for a `DASH` manifest. The default is `SEGMENT_LIST`.
    """
    SEGMENT_REFERENCE_SCHEME_UNSPECIFIED = "SEGMENT_REFERENCE_SCHEME_UNSPECIFIED"
    """
    The segment reference scheme is not specified.
    """
    SEGMENT_LIST = "SEGMENT_LIST"
    """
    Explicitly lists the URLs of media files for each segment. For example, if SegmentSettings.individual_segments is `true`, then the manifest contains fields similar to the following: ```xml ... ```
    """
    SEGMENT_TEMPLATE_NUMBER = "SEGMENT_TEMPLATE_NUMBER"
    """
    SegmentSettings.individual_segments must be set to `true` to use this segment reference scheme. Uses the DASH specification `` tag to determine the URLs of media files for each segment. For example: ```xml ... ```
    """


class JobMode(str, Enum):
    """
    The processing mode of the job. The default is `PROCESSING_MODE_INTERACTIVE`.
    """
    PROCESSING_MODE_UNSPECIFIED = "PROCESSING_MODE_UNSPECIFIED"
    """
    The job processing mode is not specified.
    """
    PROCESSING_MODE_INTERACTIVE = "PROCESSING_MODE_INTERACTIVE"
    """
    The job processing mode is interactive mode. Interactive job will either be ran or rejected if quota does not allow for it.
    """
    PROCESSING_MODE_BATCH = "PROCESSING_MODE_BATCH"
    """
    The job processing mode is batch mode. Batch mode allows queuing of jobs.
    """


class JobOptimization(str, Enum):
    """
    Optional. The optimization strategy of the job. The default is `AUTODETECT`.
    """
    OPTIMIZATION_STRATEGY_UNSPECIFIED = "OPTIMIZATION_STRATEGY_UNSPECIFIED"
    """
    The optimization strategy is not specified.
    """
    AUTODETECT = "AUTODETECT"
    """
    Prioritize job processing speed.
    """
    DISABLED = "DISABLED"
    """
    Disable all optimizations.
    """


class ManifestType(str, Enum):
    """
    Required. Type of the manifest.
    """
    MANIFEST_TYPE_UNSPECIFIED = "MANIFEST_TYPE_UNSPECIFIED"
    """
    The manifest type is not specified.
    """
    HLS = "HLS"
    """
    Create an HLS manifest. The corresponding file extension is `.m3u8`.
    """
    DASH = "DASH"
    """
    Create an MPEG-DASH manifest. The corresponding file extension is `.mpd`.
    """
