# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AuditLogConfigLogType',
    'ExternalAccessRuleAction',
    'LoggingServerProtocol',
    'LoggingServerSourceType',
    'NetworkPeeringPeerNetworkType',
    'PrivateCloudType',
    'PrivateConnectionRoutingMode',
    'PrivateConnectionType',
    'VmwareEngineNetworkType',
]


class AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """


class ExternalAccessRuleAction(str, Enum):
    """
    The action that the external access rule performs.
    """
    ACTION_UNSPECIFIED = "ACTION_UNSPECIFIED"
    """
    Defaults to allow.
    """
    ALLOW = "ALLOW"
    """
    Allows connections that match the other specified components.
    """
    DENY = "DENY"
    """
    Blocks connections that match the other specified components.
    """


class LoggingServerProtocol(str, Enum):
    """
    Required. Protocol used by vCenter to send logs to a logging server.
    """
    PROTOCOL_UNSPECIFIED = "PROTOCOL_UNSPECIFIED"
    """
    Unspecified communications protocol. This is the default value.
    """
    UDP = "UDP"
    """
    UDP
    """
    TCP = "TCP"
    """
    TCP
    """


class LoggingServerSourceType(str, Enum):
    """
    Required. The type of component that produces logs that will be forwarded to this logging server.
    """
    SOURCE_TYPE_UNSPECIFIED = "SOURCE_TYPE_UNSPECIFIED"
    """
    The default value. This value should never be used.
    """
    ESXI = "ESXI"
    """
    Logs produced by ESXI hosts
    """
    VCSA = "VCSA"
    """
    Logs produced by vCenter server
    """


class NetworkPeeringPeerNetworkType(str, Enum):
    """
    Required. The type of the network to peer with the VMware Engine network.
    """
    PEER_NETWORK_TYPE_UNSPECIFIED = "PEER_NETWORK_TYPE_UNSPECIFIED"
    """
    Unspecified
    """
    STANDARD = "STANDARD"
    """
    Peering connection used for connecting to another VPC network established by the same user. For example, a peering connection to another VPC network in the same project or to an on-premises network.
    """
    VMWARE_ENGINE_NETWORK = "VMWARE_ENGINE_NETWORK"
    """
    Peering connection used for connecting to another VMware Engine network.
    """
    PRIVATE_SERVICES_ACCESS = "PRIVATE_SERVICES_ACCESS"
    """
    Peering connection used for establishing [private services access](https://cloud.google.com/vpc/docs/private-services-access).
    """
    NETAPP_CLOUD_VOLUMES = "NETAPP_CLOUD_VOLUMES"
    """
    Peering connection used for connecting to NetApp Cloud Volumes.
    """
    THIRD_PARTY_SERVICE = "THIRD_PARTY_SERVICE"
    """
    Peering connection used for connecting to third-party services. Most third-party services require manual setup of reverse peering on the VPC network associated with the third-party service.
    """
    DELL_POWERSCALE = "DELL_POWERSCALE"
    """
    Peering connection used for connecting to Dell PowerScale Filers
    """


class PrivateCloudType(str, Enum):
    """
    Optional. Type of the private cloud. Defaults to STANDARD.
    """
    STANDARD = "STANDARD"
    """
    Standard private is a zonal resource, with 3+ nodes. Default type.
    """
    TIME_LIMITED = "TIME_LIMITED"
    """
    Time limited private cloud is a zonal resource, can have only 1 node and has limited life span. Will be deleted after defined period of time, can be converted into standard private cloud by expanding it up to 3 or more nodes.
    """
    STRETCHED = "STRETCHED"
    """
    Stretched private cloud is a regional resource with redundancy, with a minimum of 6 nodes, nodes count has to be even.
    """


class PrivateConnectionRoutingMode(str, Enum):
    """
    Optional. Routing Mode. Default value is set to GLOBAL. For type = PRIVATE_SERVICE_ACCESS, this field can be set to GLOBAL or REGIONAL, for other types only GLOBAL is supported.
    """
    ROUTING_MODE_UNSPECIFIED = "ROUTING_MODE_UNSPECIFIED"
    """
    The default value. This value should never be used.
    """
    GLOBAL_ = "GLOBAL"
    """
    Global Routing Mode
    """
    REGIONAL = "REGIONAL"
    """
    Regional Routing Mode
    """


class PrivateConnectionType(str, Enum):
    """
    Required. Private connection type.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    The default value. This value should never be used.
    """
    PRIVATE_SERVICE_ACCESS = "PRIVATE_SERVICE_ACCESS"
    """
    Connection used for establishing [private services access](https://cloud.google.com/vpc/docs/private-services-access).
    """
    NETAPP_CLOUD_VOLUMES = "NETAPP_CLOUD_VOLUMES"
    """
    Connection used for connecting to NetApp Cloud Volumes.
    """
    DELL_POWERSCALE = "DELL_POWERSCALE"
    """
    Connection used for connecting to Dell PowerScale.
    """
    THIRD_PARTY_SERVICE = "THIRD_PARTY_SERVICE"
    """
    Connection used for connecting to third-party services.
    """


class VmwareEngineNetworkType(str, Enum):
    """
    Required. VMware Engine network type.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    The default value. This value should never be used.
    """
    LEGACY = "LEGACY"
    """
    Network type used by private clouds created in projects without a network of type `STANDARD`. This network type is no longer used for new VMware Engine private cloud deployments.
    """
    STANDARD = "STANDARD"
    """
    Standard network type used for private cloud connectivity.
    """
