# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'GetScanConfigResult',
    'AwaitableGetScanConfigResult',
    'get_scan_config',
    'get_scan_config_output',
]

@pulumi.output_type
class GetScanConfigResult:
    def __init__(__self__, authentication=None, blacklist_patterns=None, display_name=None, latest_run=None, max_qps=None, name=None, schedule=None, starting_urls=None, target_platforms=None, user_agent=None):
        if authentication and not isinstance(authentication, dict):
            raise TypeError("Expected argument 'authentication' to be a dict")
        pulumi.set(__self__, "authentication", authentication)
        if blacklist_patterns and not isinstance(blacklist_patterns, list):
            raise TypeError("Expected argument 'blacklist_patterns' to be a list")
        pulumi.set(__self__, "blacklist_patterns", blacklist_patterns)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if latest_run and not isinstance(latest_run, dict):
            raise TypeError("Expected argument 'latest_run' to be a dict")
        pulumi.set(__self__, "latest_run", latest_run)
        if max_qps and not isinstance(max_qps, int):
            raise TypeError("Expected argument 'max_qps' to be a int")
        pulumi.set(__self__, "max_qps", max_qps)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if schedule and not isinstance(schedule, dict):
            raise TypeError("Expected argument 'schedule' to be a dict")
        pulumi.set(__self__, "schedule", schedule)
        if starting_urls and not isinstance(starting_urls, list):
            raise TypeError("Expected argument 'starting_urls' to be a list")
        pulumi.set(__self__, "starting_urls", starting_urls)
        if target_platforms and not isinstance(target_platforms, list):
            raise TypeError("Expected argument 'target_platforms' to be a list")
        pulumi.set(__self__, "target_platforms", target_platforms)
        if user_agent and not isinstance(user_agent, str):
            raise TypeError("Expected argument 'user_agent' to be a str")
        pulumi.set(__self__, "user_agent", user_agent)

    @property
    @pulumi.getter
    def authentication(self) -> 'outputs.AuthenticationResponse':
        """
        The authentication configuration. If specified, service will use the authentication configuration during scanning.
        """
        return pulumi.get(self, "authentication")

    @property
    @pulumi.getter(name="blacklistPatterns")
    def blacklist_patterns(self) -> Sequence[str]:
        """
        The excluded URL patterns as described in https://cloud.google.com/security-command-center/docs/how-to-use-web-security-scanner#excluding_urls
        """
        return pulumi.get(self, "blacklist_patterns")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> str:
        """
        The user provided display name of the ScanConfig.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="latestRun")
    def latest_run(self) -> 'outputs.ScanRunResponse':
        """
        Latest ScanRun if available.
        """
        return pulumi.get(self, "latest_run")

    @property
    @pulumi.getter(name="maxQps")
    def max_qps(self) -> int:
        """
        The maximum QPS during scanning. A valid value ranges from 5 to 20 inclusively. If the field is unspecified or its value is set 0, server will default to 15. Other values outside of [5, 20] range will be rejected with INVALID_ARGUMENT error.
        """
        return pulumi.get(self, "max_qps")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The resource name of the ScanConfig. The name follows the format of 'projects/{projectId}/scanConfigs/{scanConfigId}'. The ScanConfig IDs are generated by the system.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schedule(self) -> 'outputs.ScheduleResponse':
        """
        The schedule of the ScanConfig.
        """
        return pulumi.get(self, "schedule")

    @property
    @pulumi.getter(name="startingUrls")
    def starting_urls(self) -> Sequence[str]:
        """
        The starting URLs from which the scanner finds site pages.
        """
        return pulumi.get(self, "starting_urls")

    @property
    @pulumi.getter(name="targetPlatforms")
    def target_platforms(self) -> Sequence[str]:
        """
        Set of Google Cloud platforms targeted by the scan. If empty, APP_ENGINE will be used as a default.
        """
        return pulumi.get(self, "target_platforms")

    @property
    @pulumi.getter(name="userAgent")
    def user_agent(self) -> str:
        """
        The user agent used during scanning.
        """
        return pulumi.get(self, "user_agent")


class AwaitableGetScanConfigResult(GetScanConfigResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetScanConfigResult(
            authentication=self.authentication,
            blacklist_patterns=self.blacklist_patterns,
            display_name=self.display_name,
            latest_run=self.latest_run,
            max_qps=self.max_qps,
            name=self.name,
            schedule=self.schedule,
            starting_urls=self.starting_urls,
            target_platforms=self.target_platforms,
            user_agent=self.user_agent)


def get_scan_config(project: Optional[str] = None,
                    scan_config_id: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetScanConfigResult:
    """
    Gets a ScanConfig.
    """
    __args__ = dict()
    __args__['project'] = project
    __args__['scanConfigId'] = scan_config_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('google-native:websecurityscanner/v1alpha:getScanConfig', __args__, opts=opts, typ=GetScanConfigResult).value

    return AwaitableGetScanConfigResult(
        authentication=pulumi.get(__ret__, 'authentication'),
        blacklist_patterns=pulumi.get(__ret__, 'blacklist_patterns'),
        display_name=pulumi.get(__ret__, 'display_name'),
        latest_run=pulumi.get(__ret__, 'latest_run'),
        max_qps=pulumi.get(__ret__, 'max_qps'),
        name=pulumi.get(__ret__, 'name'),
        schedule=pulumi.get(__ret__, 'schedule'),
        starting_urls=pulumi.get(__ret__, 'starting_urls'),
        target_platforms=pulumi.get(__ret__, 'target_platforms'),
        user_agent=pulumi.get(__ret__, 'user_agent'))


@_utilities.lift_output_func(get_scan_config)
def get_scan_config_output(project: Optional[pulumi.Input[Optional[str]]] = None,
                           scan_config_id: Optional[pulumi.Input[str]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetScanConfigResult]:
    """
    Gets a ScanConfig.
    """
    ...
